#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <locale.h>

#include "luautil.h"

#define FILE_LUALOG "_lualog.txt"

/*<---------------------------------------------------------------------->*/
// Lua ̒l𕶎ɂB߂l͏o͂oCgB
// sz > 30 炢Ɖ肷B
static int luavalue2str(lua_State *L, int i, char *str, size_t sz)
{
    if (lua_isstring(L, i)){
        if(strlen(lua_tostring(L, i)) + 1 < sz){
            return sprintf(str, "%s ", lua_tostring(L, i));
        }
        else{
            strcpy(str, "toolongstr");
            return 10;
        }
    }
    else if (lua_isnumber(L, i)){
        return sprintf(str, "%f ", lua_tonumber(L, i));
    }
    else if (lua_isboolean(L, i)){
        return sprintf(str, "%s ", lua_toboolean(L, i) ? "true" : "false");
    }
    else{
        strcpy(str, "?");
        return 1;
    }
}
/*<---------------------------------------------------------------------->*/
static void print_lua_log(char *fmt, ...)
{
    va_list argp;
    FILE *fp;
    time_t t;
    char tm_str[32];

    fp = fopen(FILE_LUALOG, "a");
    if(!fp)
        return;

    t = time(NULL);
    strftime(tm_str, sizeof(tm_str), "%y/%m/%d %H:%M:%S", localtime(&t));
    fprintf(fp, "%s  ", tm_str);

    va_start(argp, fmt);
    vfprintf(fp, fmt, argp);
    va_end(argp);
    fprintf(fp, "\n");
    fclose(fp);
}
/*<---------------------------------------------------------------------->*/
static int print_log(lua_State *L)
{
    char str[2048];
    luautil_args2str(L, str, sizeof str);
    print_lua_log("%s", str);
    return 0;
}
/*<---------------------------------------------------------------------->*/
static int on_lua_alert(lua_State *L)
{
#if 1
    /* ̃R[h͌ĂяoƗ邱ƂB */
    /* ƂȂẴ^C~Oł͍sԍ͎擾łȂ悤B */
    /* 2005/10/29 B */
    lua_Debug ar;

    if(lua_getstack(L, 1, &ar)){
        lua_getinfo(L, "l", &ar);
    }else{
        ar.currentline = -1;
    }
    if(lua_isstring(L, -1)){
        print_lua_log("%s (Line %d)", lua_tostring(L, -1), ar.currentline);
    }
#else
    if(lua_isstring(L, -1)){
        print_lua_log("%s", lua_tostring(L, -1));
    }
#endif
    return 0;
}
/*<---------------------------------------------------------------------->*/
int luautil_init(void)
{
    FILE *fp;
    fp = fopen(FILE_LUALOG, "w");
    fclose(fp);
	setlocale(LC_ALL, "");
    return 0;
}
/*<---------------------------------------------------------------------->*/
// X^bNɊ܂܂ĂSĂ̒l񋓂AA𐶐B
//  bufsize 𒴂ꍇ͂ȏo͂ȂB
int luautil_args2str( lua_State *L, char *buf, int bufsize)
{
    int i,len,total=0;
    int n = lua_gettop(L);
    char str[1024];

    buf[0] = '\0';
    for (i = 1; i <= n; i++){
        if (lua_istable(L, i)){
            // e[ȕꍇ͒gSĂ̒lWJB
            // e[u̒Ƀe[uĂꍇɁA̒g܂ōċAIɓWJ邱Ƃ͂ȂB
            lua_pushnil(L);
            while (lua_next(L, i) != 0) {
                // `L[L  -2A`lL  -1 ̈ʒuɂB
                len = luavalue2str(L, -1, str, sizeof str);
                lua_pop(L, 1);  // `lLA`L[L ͎̌JԂ̂߂Ɏc
                // ӂȂ蕶B
                if(total+len+1 <= bufsize){
                    strcat(buf,str);
                    total += len+1;
                }
            }
        }
        else{
            // XJ[^Ȃ炻̂܂܏o͂B
            len = luavalue2str(L, i, str, sizeof str);
            // ӂȂ蕶B
            if(total+len+1 <= bufsize){
                strcat(buf,str);
                total += len+1;
            }
        }
    }
    return 0;
}
/*<---------------------------------------------------------------------->*/
int luautil_print_lua_error(lua_State *L)
{
    return on_lua_alert(L);
}
/*<---------------------------------------------------------------------->*/
void luautil_arg_error_log(lua_State *L, const char *funcname)
{
    lua_Debug ar;

    if(lua_getstack(L, 1, &ar)){
        lua_getinfo(L, "l", &ar);
    }else{
        ar.currentline = -1;
    }
    print_lua_log("Warning : invalid argument for %s (Line %d)", funcname, ar.currentline);
}
/*<---------------------------------------------------------------------->*/
int luautil_currentline(lua_State *L)
{
    lua_Debug ar;

    if(lua_getstack(L, 1, &ar)){
        lua_getinfo(L, "l", &ar);
        return ar.currentline;
    }else{
        return -1;
    }
}
/*<---------------------------------------------------------------------->*/
int luautil_currentsrc(lua_State *L, char const **src, int *curline)
{
    lua_Debug ar;

    if(lua_getstack(L, 1, &ar)){
        lua_getinfo(L, "Sl", &ar);
        *src = ar.source;
        *curline = ar.currentline;
        return 0;
    }else{
        return -1;
    }
}
/*<---------------------------------------------------------------------->*/
lua_State *luautil_load_lua(const char *lua_file, const char *lua_path)
{
    int result;
    lua_State *L;

    L = lua_open();
    lua_register(L, "_ALERT",    on_lua_alert);
    lua_register(L, "print_log", print_log);

    luaL_openlibs(L);

    /* Lua ̌pX LUA_PATH ݒB */
    if(lua_path != NULL){
        /* package.path擾ĒlB */
        const char *package_path = NULL;
        lua_pushstring(L, "package");
        lua_gettable(L, LUA_GLOBALSINDEX);
        if(lua_gettop(L) && lua_istable(L, -1)){
            lua_pushstring(L, "path");
            lua_gettable(L, -2);
            if(lua_gettop(L) && lua_isstring(L, -1)){
                package_path = lua_tostring(L, -1);
            }
        }
        lua_settop(L, 0);
        lua_pushstring(L, "package");
        lua_gettable(L, LUA_GLOBALSINDEX);
        lua_pushstring(L, "path");
        if(package_path != NULL){
            char newpath[1024];
            sprintf(newpath, "%s;%s", package_path, lua_path);
            lua_pushstring(L, newpath);
        }
        else{
            lua_pushstring(L, lua_path);
        }
        lua_settable(L, -3);
    }

/*    result = lua_dofile(L, lua_file);*/
    if(luaL_loadfile(L, lua_file) || lua_pcall(L, 0, 0, 0)){
        luautil_print_lua_error(L);
        lua_close(L);
        return NULL;
    }
    return L;
}
/*<---------------------------------------------------------------------->*/
void luautil_free_lua(lua_State *L)
{
    lua_close(L);
}
/*<---------------------------------------------------------------------->*/
static void fook_func(lua_State *L, lua_Debug *arp)
{
    int vtype;
    int notupper;
    const char *p;

    lua_pushnil(L);
    while (lua_next(L, LUA_GLOBALSINDEX) != 0) {
        /* `L[L  -2A`lL  -1 ̈ʒu */
        if(lua_isstring(L, -2)){
            vtype = lua_type(L, -1);
            if(vtype != LUA_TFUNCTION && vtype != LUA_TTABLE && vtype != LUA_TTHREAD &&
               vtype != LUA_TUSERDATA && vtype != LUA_TLIGHTUSERDATA){
                notupper = 0;
                p = lua_tostring(L, -2);
                while(*p != '\0'){
                    if(!isupper(*p) && !isdigit(*p) && *p != '_'){
                        notupper = 1;
                        break;
                    }
                    p++;
                }
                if(notupper){
                    lua_Debug ar;
                    if(lua_getstack(L, 1, &ar)){
                        lua_getinfo(L, "Sl", &ar);
                        print_lua_log("Warning: %s %d 啶łȂO[oϐ %s ܂B\n", ar.source, ar.currentline, lua_tostring(L, -2));
                    }
                }
            }
        }
        lua_pop(L, 1);  /* `lLA`L[L ͎̌JԂ̂߂Ɏc */
    }
}
/*<---------------------------------------------------------------------->*/
void luautil_fook_warning(lua_State *L)
{
    lua_sethook(L, fook_func, LUA_MASKLINE, 0);
}
/*<---------------------------------------------------------------------->*/
/* e[ulB*valueύXȂB */
void luautil_get_table_int( lua_State *L, int index, const char *key, int *value)
{
    lua_pushstring(L, key);
    lua_gettable(L, index);
    if(lua_isnumber(L, -1)){
        *value = lua_tonumber(L, -1);
        lua_pop(L, 1);
    }
}
/*<---------------------------------------------------------------------->*/
/* e[ulB*valueύXȂB */
void luautil_get_table_string( lua_State *L, int index, const char *key, const char **value)
{
    lua_pushstring(L, key);
    lua_gettable(L, index);
    if(lua_isstring(L, -1)){
        *value = lua_tostring(L, -1);
        lua_pop(L, 1);
    }
}
