/*<---------------------------------------------------------------------->*/
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include <imgctl.h>
#include "chr_win32.h"
/*<---------------------------------------------------------------------->*/
/* chr SJIS2byte1byteڂ̒lȂ1, łȂ0 */
static int is_sjis_2byte_1st(int chr)
{
    return (chr >= 0x81 && chr <= 0x9F) || (chr >= 0xE0 && chr <= 0xFC);
}
/*<---------------------------------------------------------------------->*/
/* chr SJIS2byte2byteڂ̒lȂ1, łȂ0 */
static int is_sjis_2byte_2nd(int chr)
{
    return (chr >= 0x40 && chr <= 0x7E) || (chr >= 0x80 && chr <= 0xFC);
}
/*<---------------------------------------------------------------------->*/
/* chr SJIS̔pJi̒lȂ1, łȂ0 */
static int is_sjis_hankakukana(int chr)
{
    return (chr >= 0xA1 && chr <= 0xDF);
}
/*<---------------------------------------------------------------------->*/
/*
 * ォEɊiqɕׂĕ`B
 * width    F`Ώۂ̉B̉ւ̕т̕ɒBƐ܂ԂB
 * chrs        FR[h̔zBSJIS1byte܂2byte̒lB
 * chrs_countFchrs ̗vfB
 * chr_w    Fiq̉BXW̑B
 * chr_h    Fiq̏cBYW̑B
 */
static void DrawMyFontString(HDC hdc, int width, const int *chrs, int chr_count, int chr_w, int chr_h)
{
    char str[1024];
    int i,chr,len,x_count,x,dsty=0;

    x_count = width/chr_w;
    if(sizeof str < (x_count*2+1))
        return;
    i = 0;
    for(;;){
        len = 0;
        for(x=0;x<x_count;x++){
            if(i >= chr_count)
                break;
            /* R[hPs̕𐶐B */
            chr = chrs[i++];
            /* ̔͂B */
            if(chr <= 0x7F){
                str[len++] = (char)chr;
                str[len++] = ' ';
            }
            else{
                str[len++] = (char)((chr>>8) & 0xff);
                str[len++] = (char)(chr & 0xff);
            }
        }
        if(!len)
            break;
        str[len] = '\0';
        TextOut(hdc, 0, dsty, (LPCTSTR)str, len);
        dsty += chr_h;
    }
}
/*<---------------------------------------------------------------------->*/
/*
 * ォEɊiqɕׂĕ`B
 * width    F`Ώۂ̉B̉ւ̕т̕ɒBƐ܂ԂB
 * chrs        FR[h̔zBSJIS1byte܂2byte̒lB
 * chrs_countFchrs ̗vfB
 * chr_w    Fiq̉BXW̑B
 * chr_h    Fiq̏cBYW̑B
 */
static void DrawMyFont(HDC hdc, int width, const int *chrs, int chr_count, int chr_w, int chr_h)
{
    char str[3];
    int i,chr,len,x,y;

#if defined(USE_UNICODE)
    RECT r;
#endif
    x = y = 0;
    for(i=0;i<chr_count;i++){
        /* R[hP̕𐶐B */
        chr = chrs[i];
#if defined(USE_UNICODE)
//		chr = (chr>>8) + ((chr<<8) & 0xff00);
        //wchar_t code = chr;
        //TextOutW(hdc, x, y, (LPCWSTR)&code, 1);
        wchar_t code[2] = {chr, L'\0'};
        TextOutW(hdc, x, y, code, 1);
        //TextOutW(hdc, x, y, L"", 1);
        /*r.left = x;
        r.top = y;
        r.right = x+chr_w;
        r.bottom = y+chr_h;
        DrawTextW(hdc, (LPCWSTR)&chr, 1, &r, 0);*/
#else
        /* ̔͂B */
        if(chr <= 0x7F){
            str[0] = (char)chr;
            str[1] = '\0';
            len = 1;
        }
        else{
            str[0] = (char)((chr>>8) & 0xff);
            str[1] = (char)(chr & 0xff);
            str[2] = '\0';
            len = 2;
        }
        TextOutA(hdc, x, y, (LPCSTR)str, len);
#endif
        x += chr_w;
        if(x+chr_w > width){
            x = 0;
            y += chr_h;
        }
    }
}
/*<---------------------------------------------------------------------->*/
// HBITMAP𐶐AĕԂB߂lDeleteObject()KvB
static HBITMAP GenerateChrBitmap(const int *chrcodes, int chr_count, int width, int height, int fontsize, const char *fontname, BYTE **pBits)
{
    HWND hWnd=NULL;

    HDC hdc;
    hdc = CreateCompatibleDC(GetDC(hWnd));

    BITMAPINFO bi;

    /* ۂ̂Ƃ24bppȊO܂ȂB */
    bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bi.bmiHeader.biWidth = width;
    bi.bmiHeader.biHeight = height;
    bi.bmiHeader.biPlanes = 1;
    bi.bmiHeader.biBitCount = 24;
    bi.bmiHeader.biCompression = BI_RGB;

    WORD cClrBits = (WORD)(bi.bmiHeader.biPlanes * bi.bmiHeader.biBitCount); 
    if (cClrBits == 1) 
        cClrBits = 1; 
    else if (cClrBits <= 4) 
        cClrBits = 4; 
    else if (cClrBits <= 8) 
        cClrBits = 8; 
    else if (cClrBits <= 16) 
        cClrBits = 16; 
    else if (cClrBits <= 24) 
        cClrBits = 24; 
    else
        cClrBits = 32;
    bi.bmiHeader.biSizeImage = (bi.bmiHeader.biWidth + 7) / 8 
        * bi.bmiHeader.biHeight * cClrBits;

    bi.bmiHeader.biXPelsPerMeter = 0;
    bi.bmiHeader.biYPelsPerMeter = 0;
    bi.bmiHeader.biClrUsed = 0;
    bi.bmiHeader.biClrImportant = 0;

    HBITMAP hbmp = CreateDIBSection(hdc, &bi, DIB_RGB_COLORS, (void**)pBits, NULL, 0);

    SelectObject(hdc, hbmp);

    HFONT font;
/*
    font = CreateFont(fontsize, 0, 0, 0, FW_NORMAL,
        FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, (LPCWSTR)fontname);
*/
#if defined(USE_UNICODE)
    font = CreateFontW(fontsize, 0, 0, 0, FW_NORMAL,
        FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, (LPCSTR)fontname);
#else
    font = CreateFontA(fontsize, 0, 0, 0, FW_NORMAL,
        FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, (LPCSTR)fontname);
#endif

    SelectObject(hdc, font);

    //draw fonts
    HGDIOBJ bg,hOldBrush;
    bg = GetStockObject(BLACK_BRUSH);
    hOldBrush = SelectObject(hdc, bg);
    Rectangle(hdc, 0, 0, width, height);
    SetTextColor(hdc, RGB(255, 255, 255));
    SetBkMode(hdc, TRANSPARENT);
    SetMapMode(hdc, MM_TEXT);
    SelectObject(hdc, hOldBrush);

#if 1
    DrawMyFont(hdc, width, chrcodes, chr_count, fontsize, fontsize);
#else
    // ̕TextOut()̌ĂяoȂ̂
    // rɁuvȂǂƉɂĂ܂悤B
    DrawMyFontString(hdc, width, chrcodes, chr_count, fontsize, fontsize);
#endif

    DeleteDC(hdc);
    DeleteObject(font);

    return hbmp;
}
/*<---------------------------------------------------------------------->*/
/*
 * SDL̃T[tFCXɕW`B
 * surface->format->BytesPerPixel == 4 ̎ȂB
 */
extern "C"
int GetStringSurface(SDL_Surface *surface, const int *chrcodes, int chr_count, int fontsize, const char *fontname)
{
    const char *usefont = "lr SVbN";

    if(surface->format->BytesPerPixel != 4){
        fprintf(stderr, "%s : 32bppłȂT[tFCXw肳܂B\n", __FILE__);
        return -1;
    }

    if(fontname != NULL){
        usefont = fontname;
    }

    BYTE* pBits;
    HBITMAP hbmp = GenerateChrBitmap(chrcodes, chr_count, surface->w, surface->h, fontsize, usefont, &pBits);
    if(hbmp == NULL)
        return -1;
    int pitch = (surface->w*3+3)/4*4;

    int srcy = surface->h - 1;
    for(int y=0;y<surface->h;y++){
        BYTE *psrc = pBits + pitch*srcy;
        BYTE *pdst = (BYTE*)surface->pixels + surface->pitch*y;
        for(int x=0;x<surface->w;x++){
            *pdst++ = *psrc++;
            *pdst++ = *psrc++;
            *pdst++ = *psrc++;
            *pdst++ = 0;
        }
        srcy--;
    }

    DeleteObject(hbmp);
    return 0;
}
/*<---------------------------------------------------------------------->*/
int GenerateChrPng(const int *chrcodes, int chr_count, int width, int height, int fontsize, const char *fontname, const char *lpPngFile)
{
    HWND hWnd=NULL;

    HDC hdc;
    hdc = CreateCompatibleDC(GetDC(hWnd));

    BITMAPINFO bi;

    /* ۂ̂Ƃ24bppȊO܂ȂB */
    bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bi.bmiHeader.biWidth = width;
    bi.bmiHeader.biHeight = height;
    bi.bmiHeader.biPlanes = 1;
    bi.bmiHeader.biBitCount = 24;
    bi.bmiHeader.biCompression = BI_RGB;

    WORD cClrBits = (WORD)(bi.bmiHeader.biPlanes * bi.bmiHeader.biBitCount); 
    if (cClrBits == 1) 
        cClrBits = 1; 
    else if (cClrBits <= 4) 
        cClrBits = 4; 
    else if (cClrBits <= 8) 
        cClrBits = 8; 
    else if (cClrBits <= 16) 
        cClrBits = 16; 
    else if (cClrBits <= 24) 
        cClrBits = 24; 
    else
        cClrBits = 32;
    bi.bmiHeader.biSizeImage = (bi.bmiHeader.biWidth + 7) / 8 
        * bi.bmiHeader.biHeight * cClrBits;

    bi.bmiHeader.biXPelsPerMeter = 0;
    bi.bmiHeader.biYPelsPerMeter = 0;
    bi.bmiHeader.biClrUsed = 0;
    bi.bmiHeader.biClrImportant = 0;

    BYTE *pBits;
    HBITMAP hbmp = CreateDIBSection(hdc, &bi, DIB_RGB_COLORS, (void**)&pBits, NULL, 0);

    SelectObject(hdc, hbmp);

    HFONT font;
#if defined(USE_UNICODE)
    font = CreateFontW(fontsize, 0, 0, 0, FW_NORMAL,
        FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, (LPCSTR)fontname);
#else
    font = CreateFontA(fontsize, 0, 0, 0, FW_NORMAL,
        FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, (LPCSTR)fontname);
#endif

    SelectObject(hdc, font);

    //draw fonts
    HGDIOBJ bg,hOldBrush;
    bg = GetStockObject(BLACK_BRUSH);
    hOldBrush = SelectObject(hdc, bg);
    Rectangle(hdc, 0, 0, width, height);
    SetTextColor(hdc, RGB(255, 255, 255));
    SetBkMode(hdc, TRANSPARENT);
    SetMapMode(hdc, MM_TEXT);
    SelectObject(hdc, hOldBrush);

    DrawMyFont(hdc, width, chrcodes, chr_count, fontsize, fontsize);
    DeleteObject(font);
    DeleteObject(hbmp);

    // imgctl API
    HDIB hdib = CreateDIB(&bi, pBits);
    DIBto8Bit(hdib, 0, TOBIT_ORG);

    DeleteDC(hdc);

    PNGOPT pngopt;
    ZeroMemory(&pngopt, sizeof pngopt);
    pngopt.dwFlag = POF_TRNSCOLOR;
    pngopt.wCompLevel = 5;
    pngopt.clrTrans = RGB(0, 0, 0);
    pngopt.clrBack = RGB(0, 0, 0);
    BOOL b = DIBtoPNGex(lpPngFile, hdib, &pngopt);
    DeleteDIB(hdib);
    return b ? 0 : -1;
}
/*<---------------------------------------------------------------------->*/
