//---------------------------------------------------------------------------
#include "drawchar.h"
extern "C"{
#include "jpstr.h"
}
//---------------------------------------------------------------------------
TCharacterDrawerOnSDL::TCharacterDrawerOnSDL(void)
{
    m_font_bmp = charbmp_alloc();
}
//---------------------------------------------------------------------------
TCharacterDrawerOnSDL::~TCharacterDrawerOnSDL(void)
{
    charbmp_free(m_font_bmp);
}
//---------------------------------------------------------------------------
int TCharacterDrawerOnSDL::Initialize(SDL_PixelFormat *format, int fontsize, const char* fontname)
{
    const char *chrimg;
    char binfile[256] = "";

    // Windows̏ꍇ͎IɐB
#if defined(WIN32)
    chrimg = NULL;
#else
    char chrimgbuf[256];
    sprintf(binfile, "chr/chr%d.bin", fontsize);
    sprintf(chrimgbuf, "chr/chr%d.png", fontsize);
    chrimg = chrimgbuf;
    fontname = NULL;
#endif
    if(charbmp_load(m_font_bmp, binfile, chrimg, fontsize, fontsize, fontname) == -1){
        printf("failed to load font bmp.\n");
        return -1;
    }
    return 0;
}
//---------------------------------------------------------------------------
int TCharacterDrawerOnSDL::DrawString(SDL_Surface *surface, int x, int y, const char *str, Uint32 rgba)
{
    return charbmp_draw_string_rgba(m_font_bmp, surface, x, y, str, rgba);
}
//---------------------------------------------------------------------------
int TCharacterDrawerOnSDL::DrawStringWithNewLine(SDL_Surface *surface, int x, int y, const char *str, int ystep, Uint32 rgba)
{
    char buf[256];
    int index = 0;
    int liney = y;
    bool cont = true;

    while(cont){
        int bindex = 0;
        for(;;){
            int chr1 = static_cast<int>(static_cast<unsigned char>(str[index]));
            if(chr1 == '\0'){
                cont = false;
                break;
            }
            if(chr1 == '\n'){
                index++;
                break;
            }
            if(is_sjis_2byte_1st(chr1)){
                buf[bindex++] = str[index++];
                buf[bindex++] = str[index++];
            }
            else{
                buf[bindex++] = str[index++];
            }
        }
        buf[bindex] = '\0';
        DrawString(surface, x, liney, buf, rgba);
        liney += ystep;
    }
    return 0;
}
//---------------------------------------------------------------------------
int TCharacterDrawerOnSDL::GetCharHeight() const
{
    int w, h;
    charbmp_get_charsize(m_font_bmp, &w, &h);
    return h;
}
//---------------------------------------------------------------------------
int TCharacterDrawerOnSDL::GetStringWidth(const char* text) const
{
    int w, h;
    charbmp_get_charsize(m_font_bmp, &w, &h);
    return strlen(text)*w/2;
}
