//---------------------------------------------------------------------------
#include "drawchar_win32.h"
//---------------------------------------------------------------------------
TCharacterDrawerSDLWin32::TCharacterDrawerSDLWin32(void) :
    m_SurfaceTemp(NULL), m_hdc(NULL), m_hbmp(NULL)
{
}
//---------------------------------------------------------------------------
TCharacterDrawerSDLWin32::~TCharacterDrawerSDLWin32(void)
{
    DeleteMyObject();
}
//---------------------------------------------------------------------------
void TCharacterDrawerSDLWin32::DeleteMyObject(void)
{
    if(m_SurfaceTemp != NULL)
        SDL_FreeSurface(m_SurfaceTemp);
    if(m_hdc != NULL)
        DeleteDC(m_hdc);
    if(m_hbmp != NULL)
        DeleteObject(m_hbmp);
}
//---------------------------------------------------------------------------
// planewidth, planeheight͓ŎgpꎞT[tFCX̃TCYB
// xɏo͂镶摜̃TCYꎞT[tFCX傫Əo͂ꎞT[tFCX̑傫Ő؂B
void TCharacterDrawerSDLWin32::Initialize(SDL_PixelFormat *format, int planewidth, int planeheight, int fontsize)
{
    HWND hWnd=NULL;

    DeleteMyObject();

    m_hdc = CreateCompatibleDC(GetDC(hWnd));

    BITMAPINFO *bi = (BITMAPINFO *)malloc(sizeof(BITMAPINFO) + sizeof(DWORD)*2);

    // ʂ̃tH[}bgƓrbg}bv쐬ĎB
    bi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bi->bmiHeader.biWidth = m_width = planewidth;
    bi->bmiHeader.biHeight = m_height = planeheight;
    bi->bmiHeader.biPlanes = 1;
    if(format->BitsPerPixel >= 24){
        bi->bmiHeader.biBitCount = 24;
        bi->bmiHeader.biCompression = BI_RGB;
    }else{
        bi->bmiHeader.biBitCount = 16;
        // sNZtH[}bg 5-5-5  5-6-5 lB
        if((format->Gmask>>format->Gshift) & 0x20){
            // 5-6-5
            *(DWORD *)&bi->bmiColors[0] = 0xf800;
            *(DWORD *)&bi->bmiColors[1] = 0x07e0;
            *(DWORD *)&bi->bmiColors[2] = 0x001f;
        }else{
            // 5-5-5
            *(DWORD *)&bi->bmiColors[0] = 0x7c00;
            *(DWORD *)&bi->bmiColors[1] = 0x03e0;
            *(DWORD *)&bi->bmiColors[2] = 0x001f;
        }
        bi->bmiHeader.biCompression = BI_BITFIELDS;
    }

    WORD cClrBits = (WORD)(bi->bmiHeader.biPlanes * bi->bmiHeader.biBitCount);
    if (cClrBits == 1) 
        cClrBits = 1; 
    else if (cClrBits <= 4) 
        cClrBits = 4; 
    else if (cClrBits <= 8) 
        cClrBits = 8; 
    else if (cClrBits <= 16) 
        cClrBits = 16; 
    else if (cClrBits <= 24) 
        cClrBits = 24; 
    else
        cClrBits = 32;
    bi->bmiHeader.biSizeImage = (bi->bmiHeader.biWidth + 7) / 8 
        * bi->bmiHeader.biHeight * cClrBits;
    bi->bmiHeader.biXPelsPerMeter = 0;
    bi->bmiHeader.biYPelsPerMeter = 0;
    bi->bmiHeader.biClrUsed = 0;
    bi->bmiHeader.biClrImportant = 0;

    m_hbmp = CreateDIBSection(m_hdc, bi, DIB_RGB_COLORS, (void**)&m_pbits, NULL, 0);
    free(bi);
    SelectObject(m_hdc, m_hbmp);

#if 0
    m_SurfaceTemp = SDL_CreateRGBSurface(SDL_SWSURFACE, m_width, m_height,
                32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000);
#else
    SDL_Surface *surface = SDL_CreateRGBSurface(SDL_SWSURFACE, m_width, m_height,
                32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000);
    m_SurfaceTemp = SDL_ConvertSurface(surface, format, SDL_SWSURFACE);
    SDL_FreeSurface(surface);
    printf("%08x, %08x, %08x\n", m_SurfaceTemp->format->Rmask, m_SurfaceTemp->format->Gmask, m_SurfaceTemp->format->Bmask);
#endif
}
//---------------------------------------------------------------------------
int TCharacterDrawerSDLWin32::DrawStringToSurface(SDL_Surface *surface, int dstx, int dsty, const char *str, const char *fontname, int fontsize, Uint32 rgba)
{
    if(m_pbits == NULL){
        return -1;
    }

    COLORREF bgColor;
    Uint32 colorkey;
    if((rgba & 0xffffff00) != 0){
        // FȊȌꍇ͍𓧉ߐFƂB
        bgColor = 0;
        colorkey = SDL_MapRGB(m_SurfaceTemp->format, 0, 0, 0);
    }else{
        // F̏ꍇ͔𓧉ߐFƂB
        bgColor = 0x00ffffff;
        colorkey = SDL_MapRGB(m_SurfaceTemp->format, 255, 255, 255);
    }

    // TextOut()BߐFwiFƂB
    HGDIOBJ hBrush,hOldBrush;
    hBrush = CreateSolidBrush(bgColor);
    hOldBrush = SelectObject(m_hdc, hBrush);
    Rectangle(m_hdc, 0, 0, m_width, m_height);
    SetTextColor(m_hdc, rgba>>8);
    SetBkMode(m_hdc, TRANSPARENT);
    SetMapMode(m_hdc, MM_TEXT);
    SelectObject(m_hdc, hOldBrush);
    DeleteObject(hBrush);

    HFONT hfont = CreateFont(fontsize, 0, 0, 0, FW_NORMAL,
        FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, fontname);
    HFONT hfontOld = (HFONT)SelectObject(m_hdc, hfont);
    size_t len = strlen(str);
    TextOut(m_hdc, 0, 0, (LPCTSTR)str, len);
    SelectObject(m_hdc, hfontOld);
    DeleteObject(hfont);

    BYTE *pbits = m_pbits;
    int srch = fontsize;
    if(srch > m_height)
        srch = m_height;
    int srcy = m_height - 1;
    int srcw = fontsize*len/2;
    if(srcw > m_width)
        srcw = m_width;
    if(m_SurfaceTemp->format->BitsPerPixel == 32){
        int pitch = (m_width*3+3)/4*4;
        for(int y=0;y<srch;y++){
            BYTE *psrc = pbits + pitch*srcy;
            BYTE *pdst = (BYTE*)m_SurfaceTemp->pixels + m_SurfaceTemp->pitch*y;
            for(int x=0;x<srcw;x++){
                *pdst++ = *psrc++;
                *pdst++ = *psrc++;
                *pdst++ = *psrc++;
                *pdst++ = 0;
            }
            srcy--;
        }
    }
    else if(m_SurfaceTemp->format->BitsPerPixel == 24){
        int pitch = (m_width*3+3)/4*4;
        for(int y=0;y<srch;y++){
            BYTE *psrc = pbits + pitch*srcy;
            BYTE *pdst = (BYTE*)m_SurfaceTemp->pixels + m_SurfaceTemp->pitch*y;
            for(int x=0;x<srcw;x++){
                *pdst++ = *psrc++;
                *pdst++ = *psrc++;
                *pdst++ = *psrc++;
            }
            srcy--;
        }
    }
    else if(surface->format->BitsPerPixel == 16){
        int pitch = (m_width*2+3)/4*4;
        for(int y=0;y<srch;y++){
            WORD *psrc = (WORD*)(pbits + pitch*srcy);
            WORD *pdst = (WORD*)((BYTE*)m_SurfaceTemp->pixels + m_SurfaceTemp->pitch*y);
            for(int x=0;x<srcw;x++){
                *pdst++ = *psrc++;
            }
            srcy--;
        }
    }

    SDL_SetColorKey(m_SurfaceTemp, SDL_SRCCOLORKEY, colorkey);
    int alpha = rgba & 0xff;
    if(alpha != 255)
        SDL_SetAlpha(m_SurfaceTemp, SDL_SRCALPHA, alpha);
    SDL_Rect srcrect, dstrect;
    srcrect.x = 0;
    srcrect.y = 0;
    srcrect.w = srcw;
    srcrect.h = srch;
    dstrect.x = dstx;
    dstrect.y = dsty;
    dstrect.w = srcrect.w;
    dstrect.h = srcrect.h;
    SDL_BlitSurface(m_SurfaceTemp, &srcrect, surface, &dstrect);
    return 0;
}
//---------------------------------------------------------------------------
