#if !defined(gcncharH)
#define gcncharH

// OpenGLpŁB̃obNGhł͎gpsB
#include "SDL.h"
#include "SDL_image.h"
#include <guichan.hpp>
#include <guichan/opengl.hpp>
#include <guichan/opengl/openglsdlimageloader.hpp>
#include <string>

class TGcnCharDrawer
{
public:
    TGcnCharDrawer();
    ~TGcnCharDrawer();
    bool Load(const char *file_code, const char *file_bmp, int chr_w, int chr_h, const char *font_name);
    void DrawChar(gcn::Graphics *g, int x, int y, int code, const gcn::Color& c);
    void DrawCharARGB(gcn::Graphics *g, int x, int y, int code, Uint32 rgba);
    void DrawChar(gcn::Graphics *g, int x, int y, int code);
    bool DrawString(gcn::Graphics *g, int x, int y, const char *str, const gcn::Color& c);
    bool DrawStringARGB(gcn::Graphics *g, int x, int y, const char *str, Uint32 argb);
    void DrawStringOnRect(gcn::Graphics *g, int x, int y, const gcn::Rectangle& r, int yspacing, const char *str, const gcn::Color& c);
    void DrawStringOnRectARGB(gcn::Graphics *g, int x, int y, const gcn::Rectangle& r, int yspacing, const char *str, Uint32 argb);
    void GetCharSize(int *w, int *h) const;
    int GetCharHeight() const { return m_chr_h; };
    int GetStringWidth(const char *str) const { return strlen(str)*m_chr_w/2; };
    gcn::Image* GenerateRichFontImage(const char *str, int xbold, int ybold, Uint32 argb, int borderw, int borderh, Uint32 argb_border);
    std::string GetLastError() const { return m_LastError; }
private:
    std::vector<gcn::OpenGLImage*> m_SurfaceList;
    SDL_Surface *m_SDLSurface;
    int m_code_table[65536];
    int m_chr_w;
    int m_chr_h;                // c
    int m_SDLCharXCount;        // SDL_Surfaceŉɕł镶
    int m_OpenGLCharCount;      // OpenGLT[tFCXꖇ̕
    int m_OpenGLCharXCount;     // OpenGLT[tFCXŉɕł镶
    std::string m_LastError;

    void BltCharARGB(int code, unsigned *dstpixels, int dstx, int dsty, int dstw, Uint32 argb);
    void DrawOpenGLTexture(gcn::OpenGLGraphics *g, const gcn::OpenGLImage* srcImage, int srcX, int srcY, int dstX, int dstY, int width, int height, const GLfloat *blend);
};

#endif
