//---------------------------------------------------------------------------
#include "gcnfpspane.h"
#include <algorithm>
#include <functional>

#pragma warning(push)
#pragma warning(disable: 4996)
#include <boost/format.hpp>
#pragma warning(pop)
//---------------------------------------------------------------------------
TGcnFPSPane::TGcnFPSPane(int maxfps) :
    m_Buf(maxfps)
{
    setSize(20, 20);
}
//---------------------------------------------------------------------------
TGcnFPSPane::~TGcnFPSPane()
{
}
//---------------------------------------------------------------------------
void TGcnFPSPane::draw(gcn::Graphics* g)
{
    g->setColor(gcn::Color(255,255,255));
    g->drawText((boost::format("%02d") % m_LastFPS).str(), 2, 2);
}
//---------------------------------------------------------------------------
void TGcnFPSPane::logic()
{
    //m_LastTick = SDL_GetTicks();
    m_LastFPS = std::count_if(m_Buf.begin(), m_Buf.end(), std::bind2nd(std::greater<int>(), m_LastTick - 1000)) + 1;
    m_Buf.push_back(m_LastTick);
}
//---------------------------------------------------------------------------
void TGcnFPSPane::SetTick(Uint32 tick)
{
    m_LastTick = tick;
}
