#ifndef cnvH
#define cnvH

#include <string>
#include <vector>
#include <set>
#include <map>
#include <tinyxml.h>
#include "sharedata.h"

struct TConvertedChara{
    std::string id;
    std::string name;
};

// ܂ܖ{̂ƓсAORo[^݂̂ŎgpB
enum TAnimationType{
    ANIMATION_NONE,
    ANIMATION_CHIP,
    ANIMATION_CENTER,
    ANIMATION_STREAM,
    ANIMATION_SHOT,
    ANIMATION_SCREENCENTER,
    ANIMATION_MAX
};

// ܂ܖ{̂ƓсAORo[^݂̂ŎgpB
enum TRangeType{
    RANGE_INVALID,      // G[
    RANGE_NORMAL,       // |AuXAʏ햂@
    RANGE_ME,           // SiMP񕜁Aǔjj
    RANGE_STREAM,       // 
    RANGE_ALLMYSIDE,    // ŚiI[q[j
    RANGE_ALLENEMY,     // GŚiNCGj
    RANGE_ALLWALL,      // ǑS
    RANGE_LASTDEADMYSIDE,   // ŌɎS̍W
    RANGE_LASTDEADENEMY,    // ŌɎSG̍W
    RANGE_ALLDEADMYSIDE,    // SS̍W
    RANGE_ALLDEADENEMY,     // SGS̍W
    RANGE_LOWERTHAN,        // ፂx̒n`
    RANGE_MAX
};

enum TPowerType{
    POWERTYPE_NONE,
    POWERTYPE_PA,
    POWERTYPE_PD,
    POWERTYPE_MA,
    POWERTYPE_MD,
    POWERTYPE_SKILL,
    POWERTYPE_MAX
};

// ܂ܖ{̂ƓсAORo[^݂̂ŎgpB
enum TFormula
{
    FORMULA_NONE,
    FORMULA_FTATTACK,       // t@[gD[K̒ʏŨ_[WvZ
    FORMULA_FTSPECIAL,      // KEZ
    FORMULA_FTMAGIC,        // @
    FORMULA_ANYTIME,        // K
    FORMULA_FTATTACKHIT,    // U̖̎iǉʂj
    FORMULA_FTSPECIALHIT,   // KEZ̖̎iǉʂj
    FORMULA_FTMAGICHIT,     // @̒ǉʂ̖̎
    FORMULA_MAX
};

// ܂ܖ{̂ƓсAORo[^݂̂ŎgpB
enum THitJudgeType
{
    HITJUDGE_NONE,
    HITJUDGE_SINGLE,        // Ŗƒǉʕt^𔻒肷B
    HITJUDGE_DOUBLE,        // ɒǉʕt^𔻒肷B
    HITJUDGE_SEPARATE,      // ƒǉʕt^ʁXɔ肷B
    HITJUDGE_MAX
};
//---------------------------------------------------------------------------
class TFarenCnv
{
public:
    TFarenCnv();
    bool ConvertFarenScenario(const char *srcpath, const char *dstpath, bool cnvScript, bool noDefault);
    void SetLogFileName(const char *path);
    void SetCnvSrcPath(const char *path);
private:
    std::string m_LogFileName;

    // Ro[g\[Xt@C̏ꏊB
    std::string m_CnvSrcPath;

    // ȍ~ARo[gf[^B
    std::vector<std::string> m_SpecialID;
    std::map<std::string, int> m_SpecialIDCount; // dSpecialIDɘAԂt邽߂̃}bvB

    std::vector<std::string> CharaIDArray;
    std::vector<std::string> AreaIDArray;

    // ߖTGÃXg̃XgB
    std::vector<std::vector<std::string> > AreaIDNeighbor;

    // o^ٗp\L̃m[hXgB
    std::vector<TiXmlElement> CallableList;

    // uX̉摜t@CZbgB
    std::set<std::string> BreathImageFiles;
    // ˍỦ摜t@CZbgB
    std::set<std::string> ShotImageFiles;

    // ̉摜t@CL[Ƃ}bvBl̓Aj[VB
    struct TKokuryuData{
        int width;
        int anicount;
    };
    std::map<std::string, TKokuryuData> KokuryuImageFiles;

    static const char *AnimationTypeID[ANIMATION_MAX];
    static const char *RangeTypeID[RANGE_MAX];
    static const char *PowerTypeID[POWERTYPE_MAX];
    static const char *FormulaID[FORMULA_MAX];
    static const char *HitJudgeTypeID[FORMULA_MAX];

    // @摜̃}bvB摜̑傫Aj[VoKv邽߁B
    TConvertedImageMap ConvertedImageMap;

    // @̃xP̃f[^B
    struct TMagicEntry{
        std::string id;
        std::string name;   // "@LvX"
        int consumemp;
        int magictype;      // ʁi0: 1:⏕ 2:Uj
        TRangeType rangetype;
        int range;
        int radius;
        int power;
        int attribute;      // U(1)`MP(18){g̃CfbNXB
        int animwidth;
        int animcount;      // MagicTable.txtɏĂȂ̂ŉ摜狁߂邵ȂB
        TAnimationType animtype;
        TPowerType powertype;
        TPowerType guardtype;
        TPowerType hittype;
        TPowerType avoidtype;
        TFormula powerformula;
        TFormula hitformula;
        TFormula addformula;
        THitJudgeType hitjudge;
        //bool screencenter;
        bool necromancy; // 앜łgpB
        bool isdeluge;
        std::string target;     // NCGłgpB
        std::string addstr;     // ΖhƐhłgpB
        std::string restarget;  // ΖhƐhłgpB
        std::string restype;    // ΖhƐhłgpB
        std::string summonchara;    // GgŎgpB
        std::string movetype;   // tCłgpB
        std::string excludemt;  // A[XNEFCNłgpB
        std::string script_before;  // RNKCpB
        std::string script_after;   // ^ƏǔjpB
        std::string reviveid;       // RNKCłgpB
        std::string imgfile;
        std::string sound;
        std::string guidance;

        TMagicEntry() :
            consumemp(0), magictype(0), rangetype(RANGE_INVALID), range(0), radius(0), power(0),
            attribute(0), animwidth(0), animcount(0), animtype(ANIMATION_NONE),
            powertype(POWERTYPE_NONE), guardtype(POWERTYPE_NONE),
            hittype(POWERTYPE_NONE), avoidtype(POWERTYPE_NONE),
            powerformula(FORMULA_FTSPECIAL), hitformula(FORMULA_FTSPECIALHIT), addformula(FORMULA_NONE),
            hitjudge(HITJUDGE_DOUBLE),
            necromancy(false), isdeluge(false)
        {}
    };
    std::vector<TMagicEntry> MagicEntryList;

    typedef struct{
        char Name[21];
        char Magic[6];  // ΐy
        char Merit[15]; // 0: 1:ア 2: 3:z
        char HeroFlag[4];
        short Race;     // 0:l 1:U[h} 2:Su 3:Gt 4:h[t 5: 6:ACX} 7:X^[
        short Cost;
        short MoveType; // 0: 1:ݑ 2:C 3: 4:n 5:Rn 6:X 7:ጴ 8:Rn 9:s
        short Movable;
        short HP;
        short MP;
        short PhysicalAttack;
        short PhysicalDefense;
        short Skill;
        short Speed;
        short MagicAttack;
        short MagicDefense;
        short Morale;
        short Aggressive;
        short HPRecover;
        short MPRecover;
        short SpecialNo;
        short SpecialCount;
        short HeroChar;
        short ClassChange;
        short Experience;
        short TurnMin;
        short TurnMax;
        short HelpID;
        short AttackAttribute[5];
        short AttackPower[5];
        short Employable[8];
        short dummy1[8];
        char BeastTamer;
        char OriginalSpecialData;
        char OriginalChipImage;
        char OriginalFlagImage;
        char OriginalFaceImage;
        char dummy2;
        short ImageNo;
        short dummy3;
        short FaceNo;
        short dummy4;
        short MasterFlagNo;
        short dummy5;    // ܂ł118byte
        char ID[21];
        char dummy6[139];
    }TCharacterData;

    // MasterDataGhost̏ɏĂ鐔B
    std::vector<int> m_GhostList;

    // MasterDataɏĂwcIDB
    std::vector<std::string> SideIDArray;

    // t@CBL[̓LIDB
    std::map<std::string, std::string> MasterFlagFileMap;

    // LN^[tH_̃XgB
    std::vector<std::string> m_CharaDirList;

    // MasterDataMasterRevival̏ɏĂf[^B
    typedef struct{
        int master_from;
        int master_to;
        std::string message;
    }TMasterRevival;
    std::vector<TMasterRevival> MasterRevivalList;

    typedef struct{
        int master_from;
        int master_to;
        std::string chara;    // ɎgpLH
        std::string message;
    }TMasterInherit;
    std::vector<TMasterInherit> MasterInheritList;

    std::vector<TConvertedChara> ConvertedCharaList;

    bool ConvertConfig(const char *srcpath, const char *dstpath);
    bool LoadCallAble(const char *srcpath);
    bool ConvertAreaData(const char *srcpath, const char *dstpath);
    bool ConvertCharacterData(const char *srcpath, const char *dstpath, bool noDefault, bool isDefaultScenario, bool isFirstData, int specialOffset, int specialOffsetEnd);
    bool ConvertMagicTable(const char *srcpath, const char *dstpath, const AnsiString& defscesrcpath, const AnsiString& defscedstpath);
    bool ConvertSpecialTable(const char *srcpath, const char *dstpath, bool noDefault, bool isDefaultScenario, bool isFirstData, bool forceOutput, bool& exists, bool &defout);
    bool OutputMagicEntry(TiXmlElement& e, const TMagicEntry& magic) const;
    TRangeType GetMagicRangeType(int magictype, int range, bool isdeluge) const;
    bool LoadDefaultSpecialTable(const char *srcpath, std::vector<std::string>& strlist) const;
    bool ConvertMasterData(const char *srcpath, const char *dstpath, bool noDefault);
    bool ConvertMoveAndSkill(const char *srcpath, const char *dstpath, const AnsiString& defscesrcpath);
    bool OutputMapChipType(const char *srcpath, const char *dstpath);
    bool OutputMagicGroup(const char *srcpath, const char *dstpath);
    bool OutputAttribute(const char *srcpath, const char *dstpath);
    bool OutputFieldMap(const char *srcpath, const char *dstpath, bool noDefault);
    bool OutputRace(const char *srcpath, const char *dstpath);
    bool OutputRevive(const char *srcpath, const char *dstpath);
    bool OutputLua(const char *dstpath);
    bool ConvertScenarioX(const char *srcpath, const char *dstpath, int num);
    bool ConvertPowerMap(const char *srcpath, const char *dstpath, const AnsiString& defscesrcpath, const AnsiString& defscedstpath);
    bool ConvertBMap(const char *srcpath, const char *dstpath, const AnsiString& defscesrcpath);
    bool ConvertMapChipTxt(const char *srcpath, const char *dstpath, const AnsiString& defscesrcpath);
    bool OutputMapObjTxt(const char *dstpath);
    bool CopyFiles(const char *srcdir, const char *dstdir);
    bool CopyCnvSrc(const char *dstpath);
    bool CopyMusicSound(const char *srcpath, const char *dstpath);
};

#endif
