#include <vcl.h>
#include <imgctl.h>
#include "convertpicture.h"
#include "imgctlutil.h"
#include "commonfunc.h"

//---------------------------------------------------------------------------
bool ConvertPicture(const char *srcpath, const char *dstpath, TConvertedImageMap& ConvertedImageMap)
{
    AnsiString src, dst;
    src.sprintf("%s\\Picture", srcpath);
    dst.sprintf("%s\\Picture", dstpath);

    // ɂꍇ̃G[͖
    CreateDirectory(dst.c_str(), NULL);

    AnsiString bmpfiles;
    bmpfiles.sprintf("%s\\*.bmp", src.c_str());
    WIN32_FIND_DATA findData;
    ZeroMemory(&findData, sizeof findData);
    HANDLE hFind = FindFirstFile(bmpfiles.c_str(), &findData);
    if(hFind != INVALID_HANDLE_VALUE){
        do{
            AnsiString filename = ExtractFileName(findData.cFileName);
            AnsiString bmpfile;
            bmpfile.sprintf("%s\\%s", src.c_str(), filename.c_str());
            HDIB hdib = BMPtoDIB(bmpfile.c_str());
            if(hdib != NULL){
                AnsiString noext = filename.SubString(0, filename.Length() - 4);
                BOOL b;
                // ̃t@C͓FLɂB
                AnsiString noext2 = noext.LowerCase();
                AnsiString pngfile;
                // Magiĉ͉啶sȂ̂œꂷB
                if(noext2.Pos("magic")){
                    pngfile.sprintf("M%s.png", noext2.c_str()+1);
                }
                else{
                    pngfile.sprintf("%s.png", noext.c_str());
                }
                AnsiString pngpath;
                pngpath.sprintf("%s\\%s", dst.c_str(), pngfile.c_str());
                // 摜ۑ
                TImageData imgdata;
                if(!GetHDIBSize(hdib, &imgdata.width, &imgdata.height)){
                    return false;
                }
                ConvertedImageMap[pngfile.c_str()] = imgdata;
                // PowerMap24bppɂB
                //if(!noext2.AnsiCompare("powermap")){
                //    DIBto24Bit(hdib);
                //}
                // ۑBƏ㕨Ɩ@͓FLɂB
                if(noext2.Pos("flag") ||
                   noext2.Pos("bmapobj") ||
                   noext2.Pos("magic")){
                    PNGOPT pngopt;
                    ZeroMemory(&pngopt, sizeof pngopt);
                    pngopt.dwFlag = POF_TRNSCOLOR;
                    pngopt.wCompLevel = 5;
                    pngopt.clrTrans = RGB(0, 0, 0);
                    pngopt.clrBack =  RGB(0, 0, 0); // w肵ȂViXœߕŕ\Ă܂B
                    b = DIBtoPNGex(pngpath.c_str(), hdib, &pngopt);
                }
                else{
                    b = DIBtoPNG(pngpath.c_str(), hdib, FALSE);
                }
                DeleteDIB(hdib);
                if(!b){
                    return false;
                }
            }
        }while(FindNextFile(hFind, &findData));
        FindClose(hFind);
    }
    return true;
}
