#include "imgctlutil.h"
#include <exception>
#include <boost/scoped_array.hpp>

//---------------------------------------------------------------------------
bool GetHDIBSize(HDIB hdib, int *width, int *height)
{
    try{
        DWORD dwbmiSize = 0;
        GetDIB(hdib, NULL, &dwbmiSize, NULL, NULL);
        boost::scoped_array<char> pbuf(new char[dwbmiSize]);
        LPBITMAPINFO pbmi = reinterpret_cast<LPBITMAPINFO>(pbuf.get());
        if(!GetDIB(hdib, pbmi, &dwbmiSize, NULL, NULL)){
            throw std::exception();
        }
        *width = pbmi->bmiHeader.biWidth;
        *height = pbmi->bmiHeader.biHeight;
    }
    catch(std::exception&){
        return false;
    }
    return true;
}
