#ifndef scriptcnvH
#define scriptcnvH

size_t FindChar(const std::string& str, unsigned char chr);

// ҂^B萔̕ϊɎgpB
enum TExpectedType
{
    ET_NONE,        // ҂Ȃ
    ET_PLANEINT,    // ll
    ET_PLANESTR,    // 񑦒l
    ET_BOOL,        // ^UlҁiIWiɂ͖ǐ^UlԂAPIɒu鏈Ŏgpj
    //ET_INTEGER,     // ҁiϊۂɐBmɂLuanumber^j
    ET_MASTERID,    // }X^[ID
    //ET_CHARAID = ET_MASTERID,     // LIDҁB}X^[IDƓȂ̂œlɁB
    ET_CHARAID,     // LIDҁB
    ET_CHARAID_HEROFLAG,     // LIDҁB
    ET_AREAID,      // GAID
};

class TFarenScriptCnv
{
public:
    TFarenScriptCnv(const std::vector<std::string>& chrids, const std::vector<std::string>& areaids);
    bool ConvertScripts(const char *srcpath, const char *dstpath);
    static bool OutputDummyScript(const char *dstpath);
private:
    struct TDstLine{
        std::string Value;
        int TabLevel;
    };

    struct TDestValue{
        TExpectedType MyType;       // ̕ϐ̌^
        TExpectedType IndexType;    // Y̌^
        std::string Name;           // ϊ̕
        TDestValue() : MyType(ET_NONE), IndexType(ET_NONE) {};
    };
    typedef std::map<std::string, TDestValue> TTableNameMap;
    TTableNameMap TableNameMap;

    struct TSimpleCmd{
        TExpectedType ArgType;      // ̌^
        std::string Name;           // ϊ̕
        TSimpleCmd() : ArgType(ET_NONE) {}
    };
    typedef std::map<std::string, TSimpleCmd> TSimpleCmdMap;
    TSimpleCmdMap SimpleCmdMap;

    struct TVariable{
        TExpectedType VarType;      // ̕ϐ̌^
        int LastDeclaredLine;       // ŌSetsꂽʒu
    };
    typedef std::map<std::string, TVariable> TVarTable;
    TVarTable VarTable;

    const std::vector<std::string>& CharaIDArray;
    const std::vector<std::string>& AreaIDArray;

    void SplitComparation(const std::string& src, std::string& lval, std::string& ope, std::string& rval);
    int GetArrayIndex(const char* src);
    void PrintTab(FILE *fp, int tabs);
    void RegistVariable(TVarTable& VarTable, std::vector<TDstLine>& DstLines, const std::string& varname, TExpectedType et);
    std::string ConvertVariable(TVarTable& VarTable, std::vector<TDstLine>& DstLines, AnsiString& errstr, const std::string src, TExpectedType& realtype, TExpectedType exptype = ET_NONE);
    bool ConvertScript(const char *srcpath, const char *dstpath);
};

#endif
