//---------------------------------------------------------------------------
#include "animationpane.h"
#include "ofimage.h"
#include "gamemaster.h"
//---------------------------------------------------------------------------
TAnimationPane::TAnimationPane() :
    m_Valid(false)
{
}
//---------------------------------------------------------------------------
TAnimationPane::~TAnimationPane()
{
}
//---------------------------------------------------------------------------
void TAnimationPane::SetAnimation(int index, int width, int height, int anim)
{
    m_Index = index;
    m_Width = width;
    m_Height = height;
    m_Animation = anim;
    setSize(width, height);

    const TOpenFarenImage* image = g_GameMaster.GetImage();
    int imgw, imgh;
    image->GetEffectSize(index, imgw, imgh);
    m_XCount = imgw / width;
    m_YCount = imgh / height;
    m_Valid = true;
}
//---------------------------------------------------------------------------
void TAnimationPane::draw(gcn::Graphics* g)
{
    if(m_Valid){
        const TOpenFarenImage* image = g_GameMaster.GetImage();
        int i = m_Animation % m_XCount;
        int d = m_Animation / m_XCount;
        d %= m_YCount;
        image->DrawEffect(g, 0, 0, m_Index, m_Width, m_Height, i, d);
    }
}
