//---------------------------------------------------------------------------
#ifndef areaopeH
#define areaopeH

#include <string>
#include <vector>
#include <guichan.hpp>
#include "gcnchar.h"
#include "ofgame.h"
#include "charalistpane.h"
#include "imagepane.h"
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TAreaCharaListPane : public gcn::Widget, public gcn::MouseListener
{
public:
    TAreaCharaListPane();
    virtual ~TAreaCharaListPane() {}
    virtual void draw(gcn::Graphics *g);
    void SetSelectedArea(int areaindex);
    int GetSelectedArea() const { return m_SelectedArea; }
    //void SetSelected(int i) { m_Selected = i; }
    int GetSelected() const { return m_Selected; }
    int GetBrowsed() const { return m_Browsed; }
    void LockSelected(bool b) { m_SelectLocked = b; }
    void ClearState();
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
private:
    int m_XCount;
    std::vector<int> m_CharaIndexList;
    int m_SelectedArea;
    int m_Selected;     // IꂽL̃CfbNX
    int m_Browsed;      // }EXĂꂽL̃CfbNX
    bool m_SelectLocked;
    TGcnCharDrawer *m_drawer;

    void NotifyStateChenged();
};
//---------------------------------------------------------------------------
class TAreaInfoPane : public gcn::Widget
{
public:
    TAreaInfoPane();
    virtual ~TAreaInfoPane() {}
    void SetSelectedArea(int areaindex);
    //int GetSelectedArea() const { return m_SelectedArea; }
    virtual void draw(gcn::Graphics *g);
private:
    //static const int m_FontSize = 12;
    TGcnCharDrawer *m_drawer;
    int m_SelectedArea;
};
//---------------------------------------------------------------------------
class TAreaOpeListModel : public gcn::ListModel
{
public:
    TAreaOpeListModel();
    virtual ~TAreaOpeListModel() {}
    virtual std::string getElementAt(int i);
    virtual int getNumberOfElements();
private:
};
//---------------------------------------------------------------------------
class TAreaOpePane : public gcn::Container
{
public:
    TAreaOpePane();
    virtual ~TAreaOpePane() {}
    virtual void draw(gcn::Graphics *g);
    void Show(bool showcontrol);
    void SetSelectedArea(int areaindex);
    gcn::Button& GetButtonMove() { return m_ButtonMove; }
    gcn::Button& GetButtonEmploy() { return m_ButtonEmploy; }
    gcn::Button& GetButtonDismiss() { return m_ButtonDismiss; }
    gcn::DropDown& GetAreaOpeDropDown() { return m_AreaOpeDropDown; }
private:
    gcn::Button m_ButtonMove;
    gcn::Button m_ButtonEmploy;
    gcn::Button m_ButtonDismiss;
    gcn::DropDown m_AreaOpeDropDown;
    TAreaOpeListModel m_AreaOpeListModel;
    TGcnCharDrawer *m_drawer;
    bool m_Shown;
    bool m_ShowControl;
};
//---------------------------------------------------------------------------
class TCharaListWindow : public TGcnWindow, public gcn::ActionListener
{
public:
    TCharaListWindow();
    virtual ~TCharaListWindow() {}
    void Show(bool showbutton);
    void SetSelectedArea(int areaindex);
    virtual void draw(gcn::Graphics *g);
    virtual void action(const gcn::ActionEvent& actionEvent);
    gcn::Button& GetButtonMove() { return m_AreaOpePane.GetButtonMove(); }
    gcn::Button& GetButtonEmploy() { return m_AreaOpePane.GetButtonEmploy(); }
    gcn::Button& GetButtonDismiss() { return m_AreaOpePane.GetButtonDismiss(); }
    gcn::DropDown& GetAreaOpeDropDown() { return m_AreaOpePane.GetAreaOpeDropDown(); }
    TAreaCharaListPane& GetCharaListPane() { return m_CharaListPane; }
private:
    TAreaCharaListPane m_CharaListPane;
    TAreaInfoPane m_AreaInfoPane;
    TAreaOpePane m_AreaOpePane;
    //bool m_Shown;
};
//---------------------------------------------------------------------------
class TMasterInfoPane : public gcn::Widget
{
public:
    TMasterInfoPane();
    virtual ~TMasterInfoPane() {}
    void SetMasterInstance(int index) { m_MasterInstance = index; };
    int GetMasterInstance() const { return m_MasterInstance; };
    virtual void draw(gcn::Graphics *g);
    virtual void logic() { m_Tick++; };
private:
    //static const int m_FontSize = 12;
    //static const int m_FontSizeBig = 16;    // GUIigĂ̂ƓTCYŁB
    TGcnCharDrawer *m_drawer;
    TGcnCharDrawer *m_drawerbig;
    int m_MasterInstance;
    int m_Tick;
};
//---------------------------------------------------------------------------
class TMasterOpePane : public gcn::Container
{
public:
    TMasterOpePane();
    virtual ~TMasterOpePane() {}
    //virtual void draw(gcn::Graphics *g);
    gcn::Button& GetButtonAreaList() { return m_ButtonAreaList; }
    gcn::Button& GetButtonMasterList() { return m_ButtonMasterList; }
    gcn::Button& GetButtonHeroList() { return m_ButtonHeroList; }
    gcn::Button& GetButtonPowerMap() { return m_ButtonPowerMap; }
    gcn::Button& GetButtonAlliance() { return m_ButtonAlliance; }
    gcn::Button& GetButtonWar() { return m_ButtonWar; }
    gcn::Button& GetButtonTurnEnd() { return m_ButtonTurnEnd; }
private:
    gcn::Button m_ButtonAreaList;
    gcn::Button m_ButtonMasterList;
    gcn::Button m_ButtonHeroList;
    gcn::Button m_ButtonPowerMap;
    gcn::Button m_ButtonAlliance;
    gcn::Button m_ButtonWar;
    gcn::Button m_ButtonTurnEnd;
};
//---------------------------------------------------------------------------
class TMasterWindow : public TGcnWindow
{
public:
    TMasterWindow();
    virtual ~TMasterWindow() {}
    bool Show();
    void SetMasterInstance(int index) { m_MasterInfoPane.SetMasterInstance(index); };
    //gcn::Button& GetButtonAlliance() { return m_ButtonAlliance; }
    //gcn::Button& GetButtonWar() { return m_ButtonWar; }
    //gcn::Button& GetButtonTurnEnd() { return m_ButtonTurnEnd; }
    gcn::Button& GetButtonAreaList() { return m_MasterOpePane.GetButtonAreaList(); }
    gcn::Button& GetButtonMasterList() { return m_MasterOpePane.GetButtonMasterList(); }
    gcn::Button& GetButtonHeroList() { return m_MasterOpePane.GetButtonHeroList(); }
    gcn::Button& GetButtonPowerMap() { return m_MasterOpePane.GetButtonPowerMap(); }
    gcn::Button& GetButtonAlliance() { return m_MasterOpePane.GetButtonAlliance(); }
    gcn::Button& GetButtonWar() { return m_MasterOpePane.GetButtonWar(); }
    gcn::Button& GetButtonTurnEnd() { return m_MasterOpePane.GetButtonTurnEnd(); }
    virtual void draw(gcn::Graphics *g);
private:
    TMasterInfoPane m_MasterInfoPane;
    TMasterOpePane m_MasterOpePane;
    //gcn::Button m_ButtonAlliance;
    //gcn::Button m_ButtonWar;
    //gcn::Button m_ButtonTurnEnd;
    bool m_Shown;
};
//---------------------------------------------------------------------------
class TEmployListModel : public gcn::ListModel
{
private:
    std::vector<int> m_TypeList;
    int m_Race;
public:
    TEmployListModel() {}
    virtual ~TEmployListModel() {}
    virtual std::string getElementAt(int i);
    virtual int getNumberOfElements();
    void SetEmployList(const std::vector<int>& typelist) { m_TypeList = typelist; }
    void SetRace(int race) { m_Race = race; }
    int GetEmployAt(int i) const;
};
//---------------------------------------------------------------------------
class TEmployWindow : public TGcnWindow, public gcn::ActionListener
{
private:
    TEmployListModel m_EmployListModel;
    gcn::ListBox m_EmployListBox;
    gcn::Button m_ButtonOk;
    gcn::Button m_ButtonCancel;
    int m_Budget;
public:
    TEmployWindow();
    virtual ~TEmployWindow() {}
    bool Show(const std::vector<int>& typelist, int race, int budget);
    gcn::ListBox& GetEmployListBox() { return m_EmployListBox; }
    gcn::Button& GetButtonOk() { return m_ButtonOk; }
    gcn::Button& GetButtonCancel() { return m_ButtonCancel; }
    int GetSelectedEmployType();
    virtual void draw(gcn::Graphics *g);
    virtual void action(const gcn::ActionEvent& actionEvent);
};
//---------------------------------------------------------------------------
class TWarCharaListPane : public gcn::Widget, public gcn::MouseListener
{
private:
    static const int m_CharaWidth = 32;
    static const int m_CharaHeight = 32;
    static const int m_CharaMargin = 8;
    static const int m_AreaLabelHeight = 20;
    static const int m_FontSize = 16;

    int m_XCount;
    std::vector<std::pair<int, int> > m_WarCharaList;
    // }EXړ̃LXe[^XEBhE\pB
    TCharacterInstance m_BrowsedCharacter;
    bool m_Browsed;
    TGcnCharDrawer *m_drawer;
    TMouseHandler* m_MouseHandler;
public:
    TWarCharaListPane();
    virtual ~TWarCharaListPane() {}
    virtual void draw(gcn::Graphics *g);
    void UpdateHeight();
    void AddChara(int areaindex, int charaindex);
    void RemoveChara(int areaindex, int charaindex);
    void ClearChara();
    bool GetCharaIndexAt(int x, int y, int& areaindex, int& charaindex) const;
    const TCharacterInstance* GetBrowsedCharacter() const;
    void GetCharaIndexList(std::vector<std::pair<int, int> >& indice) const { indice = m_WarCharaList; }
    int GetCharaIndexCount() const { return m_WarCharaList.size(); }
    void SetMouseHandler(TMouseHandler* p) { m_MouseHandler = p; }
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
private:
    //int GetCharaIndexAt(int x, int y) const;
};
//---------------------------------------------------------------------------
class TWarCharaWindow : public TGcnWindow, public gcn::ActionListener, public TMouseHandler
{
public:
    TWarCharaWindow();
    virtual ~TWarCharaWindow() {}
    void Show(int targetarea);
    void Hide();
    void SetLeftArea(int index);
    int GetLeftArea() const { return m_LeftAreaIndex; }
    void GetLeftToRight(std::vector<std::pair<int, int> >& indice) const;
    //void SetCharaListLeft(const TCharacterInstanceList* charalist); { m_LeftPane.SetCharaList(charalist); }
    //void SetCharaListRight(const TCharacterInstanceList* charalist); { m_RightPane.SetCharaList(charalist); }
    //TCharaListPane& GetLeftCharaListPane() { return m_LeftPane; }
    //TCharaListPane& GetRightCharaListPane() { return m_RightPane; }
    //gcn::Button& GetButtonAllRight() { return m_ButtonAllRight; }
    //gcn::Button& GetButtonAllLeft() { return m_ButtonAllLeft; }
    gcn::Button& GetButtonOk() { return m_ButtonOk; }
    gcn::Button& GetButtonCancel() { return m_ButtonCancel; }
    //void SetMouseListener(gcn::MouseListener *listener);
    const TCharacterInstance* GetBrowsedCharacter() const { return m_RightPane.GetBrowsedCharacter(); };
    void UpdateButtonEnabled();
    virtual void draw(gcn::Graphics *g);
    virtual void HandleMousePressed(gcn::MouseEvent &mouseEvent);
    virtual void HandleMouseMoved(gcn::MouseEvent &mouseEvent);
    virtual void action(const gcn::ActionEvent& actionEvent);
private:
    TCharaListPane m_LeftPane;
    TWarCharaListPane m_RightPane;
    gcn::Button m_ButtonAllRight;
    gcn::Button m_ButtonAllLeft;
    gcn::Button m_ButtonOk;
    gcn::Button m_ButtonCancel;

    int m_LeftAreaIndex;
    std::vector<std::vector<int> > m_LeftToRightFlag;
    int m_RightAreaIndex;

    // }EXړ̃LXe[^XEBhE\pB
    TCharacterInstance m_BrowsedCharacter;
    bool m_Browsed;

    bool m_Shown;

    static const int LR_MARGIN = 8; // E̗]

    void UpdateSize();
};
//---------------------------------------------------------------------------
class TEmployHeroPane : public gcn::Container
{
public:
    TEmployHeroPane();
    virtual ~TEmployHeroPane() {}
    virtual void draw(gcn::Graphics *g);
    void Show(int area, int hero, int money);
    void GetHero(int& area, int& hero) const { area = m_Area; hero = m_Hero; }
    gcn::Button& GetButtonDetail() { return m_ButtonDetail; }
    gcn::Button& GetButtonEmploy() { return m_ButtonEmploy; }
    gcn::Button& GetButtonCancel() { return m_ButtonCancel; }
private:
    gcn::Button m_ButtonDetail;
    gcn::Button m_ButtonEmploy;
    gcn::Button m_ButtonCancel;
    TGcnCharDrawer *m_drawer;
    TGcnCharDrawer *m_drawerbig;
    int m_Area;
    int m_Hero;
    int m_Money;
};
//---------------------------------------------------------------------------
class TEmployHeroWindow : public TGcnWindow
{
public:
    TEmployHeroWindow();
    virtual ~TEmployHeroWindow() {}
    void Show(int area, int hero, int money);
    void GetHero(int& area, int& hero) const { m_EmployHeroPane.GetHero(area, hero); }
    gcn::Button& GetButtonDetail() { return m_EmployHeroPane.GetButtonDetail(); }
    gcn::Button& GetButtonEmploy() { return m_EmployHeroPane.GetButtonEmploy(); }
    gcn::Button& GetButtonCancel() { return m_EmployHeroPane.GetButtonCancel(); }
private:
    TEmployHeroPane m_EmployHeroPane;
};
//---------------------------------------------------------------------------
class TPowerMapPane : public gcn::Container
{
public:
    TPowerMapPane();
    virtual ~TPowerMapPane() {}
    virtual void draw(gcn::Graphics *g);
    void Show();
    void SetMouseListener(gcn::MouseListener *mouseListener);
private:
    TGcnImagePane m_ImagePane;
    TGcnCharDrawer *m_drawer;
    static const int LINE_HEIGHT = 16;
};
//---------------------------------------------------------------------------
class TPowerMapWindow : public TGcnWindow
{
public:
    TPowerMapWindow();
    virtual ~TPowerMapWindow() {}
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    void Show();
private:
    TPowerMapPane m_PowerMapPane;
};
//---------------------------------------------------------------------------
#endif
