#if !defined(battlecharalistH)
#define battlecharalistH

#include <vector>
#include <guichan.hpp>
#include "gcnchar.h"
#include "gcnwindow.h"
#include "ofgame.h"

//---------------------------------------------------------------------------
class TBattleCharaListPane : public gcn::Widget
{
public:
    TBattleCharaListPane();
    virtual ~TBattleCharaListPane();
    virtual void draw(gcn::Graphics *g);
    //void SetCharaList(int index, int mastertype, const std::vector<const TCharacterInstance*>& charalist);
    void SetCharaList(int index, int mastertype, const TCharacterInstanceList* charalist);
    void ClearCharaList();
    void SetProperty(int lforce, int lbrave, int rforce, int rbrave, int turn);
    void SetShowGraph(bool b) { m_ShowGraph = b; }
private:
    static const int CHARAYCOUNT = 10;  // cɕׂ鐔B
    static const int TOPMARGIN = 32;    // 㕔̕B

    TGcnCharDrawer *m_Drawer;
    TGcnCharDrawer *m_DrawerBig;
    std::vector<int> m_MasterType;
    //std::vector<std::vector<const TCharacterInstance*> > m_CharaList;
    std::vector<const TCharacterInstanceList*> m_CharaList;

    bool m_ShowGraph;
    int m_LeftForce;
    int m_LeftBrave;
    int m_RightForce;
    int m_RightBrave;
    int m_Turn;
};
//---------------------------------------------------------------------------
class TBattleCharaListWindow : public TGcnWindow
{
public:
    TBattleCharaListWindow();
    virtual ~TBattleCharaListWindow();
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    TBattleCharaListPane& GetPane() { return m_BattleCharaListPane; }
    void SetCanHide(bool b) { m_CanHide = b; m_BattleCharaListPane.SetShowGraph(!b); }
private:
    TBattleCharaListPane m_BattleCharaListPane;
    bool m_CanHide;
};
//---------------------------------------------------------------------------
#endif
