//---------------------------------------------------------------------------
#ifndef battlecommandH
#define battlecommandH

#include <vector>
#include <string>
#include "ofimage.h"
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TBattleCommandWindow;
class TBattleCommandListener : public gcn::MouseListener
{
private:
    TBattleCommandWindow *m_Window;
public:
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
    void SetWindow(TBattleCommandWindow *p) { m_Window = p; }
};
//---------------------------------------------------------------------------
// 퓬̃R}h{^EBhE
class TBattleCommandWindow : public TGcnWindow
{
public:
    TBattleCommandWindow();
    virtual ~TBattleCommandWindow() {}
    void Show();
    gcn::ImageButton& GetWaitButton()    { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_WAIT]; }
    gcn::ImageButton& GetMoveButton()    { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_MOVE]; }
    gcn::ImageButton& GetAttackButton()  { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_ATTACK]; }
    gcn::ImageButton& GetMagicButton()   { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_MAGIC]; }
    gcn::ImageButton& GetSpecialButton() { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_SPECIAL]; }
    gcn::ImageButton& GetChargeButton()  { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_CHARGE]; }
    gcn::ImageButton& GetRedoButton()    { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_REDO]; }
    gcn::ImageButton& GetRedo2Button()    { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_REDO2]; }
    gcn::ImageButton& GetRunAwayButton()  { return m_ButtonList[TOpenFarenImage::BUTTONIMAGE_RUNAWAY]; }
    virtual void draw(gcn::Graphics *g);
    void SetCommandStrings(const std::vector<std::string>& strs);
    void SetCommandStringIndex(int index);

    static const int BUTTON_WIDTH = 32;
    static const int BUTTON_HEIGHT = 32;
    static const int COMSTR_HEIGHT = 24;
private:
    gcn::ImageButton m_ButtonList[TOpenFarenImage::BUTTONIMAGE_MAX];
    std::vector<std::string> m_CommandStrings;
    int m_CommandStringIndex;
    TBattleCommandListener m_Listener;
    bool m_Shown;
};
#endif
