//---------------------------------------------------------------------------
#ifndef charalistpaneH
#define charalistpaneH

#include <string>
#include <vector>
#include <guichan.hpp>
#include "ofgame.h"
#include "gcnchar.h"
//---------------------------------------------------------------------------
struct TMouseHandler
{
    virtual void HandleMousePressed(gcn::MouseEvent &mouseEvent) = 0;
    virtual void HandleMouseMoved(gcn::MouseEvent &mouseEvent) = 0;
};

class TCharaListPane : public gcn::Widget, public gcn::MouseListener
{
private:
    static const int m_CharaWidth = 32;
    static const int m_CharaHeight = 32;
    static const int m_CharaMargin = 8;

    int m_XCount;
    int m_YCount;
    const TCharacterInstanceList* m_CharaList;
    const std::vector<int>* m_CharaHidden;      // m_CharaListƓvfƂBꂪ1̎L\ȂB
    int m_Browsed;      // }EXĂꂽL̃CfbNX
    int m_Selected;
    TGcnCharDrawer *m_drawer;
    TMouseHandler* m_MouseHandler;
public:
    TCharaListPane();
    virtual ~TCharaListPane() {}
    virtual void draw(gcn::Graphics *g);
    void SetYCount(int count);
    void SetCharaList(const TCharacterInstanceList* charalist, const std::vector<int>* hidden);
    int GetBrowsed() const { return m_Browsed; }
    void SetSelected(int i) { m_Selected = i; }
    int GetSelected() const { return m_Selected; }
    int GetCharaIndexAt(int x, int y) const;
    void SetMouseHandler(TMouseHandler* p) { m_MouseHandler = p; }
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
};
//---------------------------------------------------------------------------
#endif
