//---------------------------------------------------------------------------
#ifndef charastatusH
#define charastatusH

#include <string>
#include <vector>
#include <guichan.hpp>
#include "ofgame.h"
#include "gcnchar.h"
#include "charalistpane.h"
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TGcnCharaStatusPane : public gcn::Widget
{
private:
    TGcnCharDrawer *m_drawer;
    TCharacterInstance m_chara;
public:
    TGcnCharaStatusPane();
    virtual ~TGcnCharaStatusPane() {}
    virtual void draw(gcn::Graphics *g);
    void SetCharaStatus(const TCharacterInstance& chara) { m_chara = chara; }
};
//---------------------------------------------------------------------------
class TCharaStatusWindow : public TGcnWindow
{
private:
    TGcnCharaStatusPane m_CharaStatusPane;
    bool m_Shown;
public:
    TCharaStatusWindow();
    virtual ~TCharaStatusWindow() {}
    void Show(const TCharacterInstance& chara);
    void MoveToCorner();
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
    //TGcnCharaStatusPane& GetCharaStatusPane() { return m_CharaStatusPane; };
};
//---------------------------------------------------------------------------
class TGcnCharaStatusFullPane : public gcn::Widget
{
public:
    TGcnCharaStatusFullPane();
    virtual ~TGcnCharaStatusFullPane() {}
    void SetCharaStatus(const TCharacterInstance& chara);
    virtual void draw(gcn::Graphics *g);
private:
    TGcnCharDrawer *m_drawer;
    TGcnCharDrawer *m_drawerBig;
    TCharacterInstance m_chara;
    static const int FULLWINDOW_NOFACEWIDTH = 256;
    static const int FULLWINDOW_NOHEROHEIGHT = 400;
};
//---------------------------------------------------------------------------
class TCharaStatusFullWindow : public TGcnWindow
{
public:
    TCharaStatusFullWindow();
    virtual ~TCharaStatusFullWindow() {}
    bool Show(const TCharacterInstance& chara);
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
private:
    TGcnCharaStatusFullPane m_CharaStatusFullPane;
    bool m_Shown;
};
//---------------------------------------------------------------------------
class TCharaMoveWindow : public TGcnWindow, public gcn::ActionListener, public TMouseHandler
{
private:
    TCharaListPane m_LeftTopPane;
    TCharaListPane m_LeftBottomPane;
    TCharaListPane m_RightTopPane;
    TCharaListPane m_RightBottomPane;
    gcn::Button m_ButtonAllRight;
    gcn::Button m_ButtonAllLeft;
    gcn::Button m_ButtonOk;
    gcn::Button m_ButtonCancel;

    int m_LeftAreaIndex;
    TCharacterInstanceList m_LeftTopCharaList;
    TCharacterInstanceList m_LeftBottomCharaList;
    std::vector<int> m_LeftToRightFlag;
    int m_RightAreaIndex;
    TCharacterInstanceList m_RightTopCharaList;
    TCharacterInstanceList m_RightBottomCharaList;
    std::vector<int> m_RightToLeftFlag;

    // }EXړ̃LXe[^XEBhE\pB̃Xg̃L𐳂w@l̂ʓ|L̂ŃCX^X̃Rs[B
    TCharacterInstance m_BrowsedCharacter;
    bool m_Browsed;
    bool m_Shown;
public:
    TCharaMoveWindow();
    virtual ~TCharaMoveWindow() {}
    void Show(int larea, const TCharacterInstanceList& lcharalist, int rarea, const TCharacterInstanceList& rcharalist);
    void GetLeftToRight(std::vector<int>& indice) const;
    void GetRightToLeft(std::vector<int>& indice) const;
    gcn::Button& GetButtonOk() { return m_ButtonOk; }
    gcn::Button& GetButtonCancel() { return m_ButtonCancel; }
    const TCharacterInstance* GetBrowsedCharacter() const;
    virtual void draw(gcn::Graphics *g);
    virtual void HandleMousePressed(gcn::MouseEvent &mouseEvent);
    virtual void HandleMouseMoved(gcn::MouseEvent &mouseEvent);
    virtual void action(const gcn::ActionEvent& actionEvent);
};
//---------------------------------------------------------------------------
void DrawSimpleCharaStatus(gcn::Graphics *g, int x, int y, const TCharacterInstance* chara);
//---------------------------------------------------------------------------
#endif
