#include "drawutil.h"
#include <cmath>

TDrawUtil g_DrawUtil;
//---------------------------------------------------------------------------
// LXe[^XȂǂ\LvVt̘g`悷B
void DrawFrame(gcn::Graphics *g, const gcn::Rectangle& r, const std::string& caption, TGcnCharDrawer *drawer)
{
    const int capx = 8;
    const int capy = - drawer->GetCharHeight() / 2;
    //int capw = caption.size() * FONT_SIZE / 2;
    int capw = drawer->GetStringWidth(caption.c_str());
    g->setColor(gcn::Color(192,192,192));
    // 
    g->drawLine(r.x + 1, r.y + r.height + 1, r.x + r.width + 1, r.y + r.height + 1);
    // 
    g->drawLine(r.x + 1, r.y + 1, r.x + 1, r.y + r.height + 1);
    // E
    g->drawLine(r.x + r.width + 1, r.y + 1, r.x + r.width + 1, r.y + r.height + 1);
    // Ӂij
    g->drawLine(r.x + 1, r.y + 1, r.x + capx , r.y + 1);
    // ӁiEj
    g->drawLine(r.x + capx + capw, r.y + 1, r.x + r.width + 1, r.y + 1);

    g->setColor(gcn::Color(255,255,255));
    // 
    g->drawLine(r.x, r.y + r.height, r.x + r.width, r.y + r.height);
    // 
    g->drawLine(r.x, r.y, r.x, r.y + r.height);
    // E
    g->drawLine(r.x + r.width, r.y, r.x + r.width, r.y + r.height);
    // Ӂij
    g->drawLine(r.x, r.y, r.x + capx , r.y);
    // ӁiEj
    g->drawLine(r.x + capx + capw, r.y, r.x + r.width, r.y);
    drawer->DrawString(g, r.x + capx, r.y + capy, caption.c_str(), gcn::Color(255,255,255));
}
//---------------------------------------------------------------------------
// Lzu̘̎g`悷B
void DrawChipFrame(gcn::Graphics *g, const gcn::Rectangle& r)
{
    // ̍g
    g->setColor(gcn::Color(0,0,0));
    gcn::Rectangle r1 = r;
    r1.x += 3;
    r1.y += 3;
    r1.width -= 5;
    r1.height -= 5;
    //g->drawRectangle(r1);
    g_DrawUtil.DrawRectangle(g, r1);

    // O̍g
    g->drawLine(r.x, r.y, r.x + r.width, r.y);
    g->drawLine(r.x, r.y + r.height, r.x + r.width, r.y + r.height);
    g->drawLine(r.x, r.y, r.x, r.y + r.height);
    g->drawLine(r.x + r.width, r.y, r.x + r.width, r.y + r.height);

    // ̔g
    g->setColor(gcn::Color(255,255,255));
    --r1.x;
    --r1.y;
    r1.width += 2;
    r1.height += 2;
    //g->drawRectangle(r1);
    g_DrawUtil.DrawRectangle(g, r1);
    --r1.x;
    --r1.y;
    r1.width += 2;
    r1.height += 2;
    //g->drawRectangle(r1);
    g_DrawUtil.DrawRectangle(g, r1);
}
//---------------------------------------------------------------------------
void DrawLine(int x1, int y1, int x2, int y2, float w)
{
    GLfloat oldw;
    glGetFloatv(GL_LINE_WIDTH, &oldw);
    glLineWidth(w);
    glBegin(GL_LINES);
    glVertex2f(x1, y1);
    glVertex2f(x2, y2);
    glEnd();
    glLineWidth(oldw);
}
//---------------------------------------------------------------------------
void DrawCircle(int x, int y, int r, float w)
{
    const float PI_OVER_180 = 0.0174532925;
    float inc = 22.5;
    GLfloat oldw;
    glGetFloatv(GL_LINE_WIDTH, &oldw);
    glLineWidth(w);
    glBegin(GL_LINE_LOOP);
    for(float step = 0.0; step < 360.0; step += inc){
         float angle = step * PI_OVER_180;
         glVertex2f(x + r * std::cos(angle), y + r * std::sin(angle));
    }
    glEnd();
    glLineWidth(oldw);
}
//---------------------------------------------------------------------------
void DrawBoldText(gcn::Graphics *g, const char *str, int x, int y)
{
    g->drawText(str, x, y);
    g->drawText(str, x + 1, y);
}
//---------------------------------------------------------------------------
void DrawImageStretchAlpha(gcn::Graphics *g, const gcn::Image *srcImage, int srcX, int srcY, int srcW, int srcH, int dstX, int dstY, int dstW, int dstH, float alpha)
{
    //GLfloat blend[4] = {1.0f, 1.0f, 1.0f, alpha};
    GLfloat blend[4] = {alpha, alpha, alpha, alpha};
    DrawOpenGLImage(reinterpret_cast<gcn::OpenGLGraphics*>(g), reinterpret_cast<const gcn::OpenGLImage*>(srcImage), srcX, srcY, srcW, srcH, dstX, dstY, dstW, dstH, blend);
}
//---------------------------------------------------------------------------
void DrawOpenGLImage(gcn::OpenGLGraphics *g, const gcn::OpenGLImage *srcImage, int srcX, int srcY, int srcW, int srcH, int dstX, int dstY, int dstW, int dstH, const GLfloat *blend)
{
    const gcn::ClipRectangle& top = g->getCurrentClipArea();
    dstX += top.xOffset;
    dstY += top.yOffset;

    // Find OpenGL texture coordinates
    float texX1 = srcX / (float)srcImage->getTextureWidth();
    float texY1 = srcY / (float)srcImage->getTextureHeight();
    float texX2 = (srcX+srcW) / (float)srcImage->getTextureWidth();
    float texY2 = (srcY+srcH) / (float)srcImage->getTextureHeight();

    glBindTexture(GL_TEXTURE_2D, srcImage->getTextureHandle());
    glEnable(GL_TEXTURE_2D);

//    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
//    glDisable(GL_DEPTH_TEST);

    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);

    //glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, blend);
    glColor4fv(blend);

    //glColor4f(0.5f, 0.5f, 0.5f, 0.5f);
    // Draw a textured quad -- the image
    glBegin(GL_QUADS);
    glTexCoord2f(texX1, texY1);
    glVertex3i(dstX, dstY, 0);

    glTexCoord2f(texX1, texY2);
    glVertex3i(dstX, dstY + dstH, 0);

    glTexCoord2f(texX2, texY2);
    glVertex3i(dstX + dstW, dstY + dstH, 0);

    glTexCoord2f(texX2, texY1);
    glVertex3i(dstX + dstW, dstY, 0);
    glEnd();

    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    glDisable(GL_TEXTURE_2D);

//    glEnable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);

    g->setColor(g->getColor());
}
//---------------------------------------------------------------------------
void TDrawUtil::SetSlide(int l, int r, int t, int b)
{
    m_SlideL = l;
    m_SlideR = r;
    m_SlideT = t;
    m_SlideB = b;
}
//---------------------------------------------------------------------------
void TDrawUtil::DrawRectangle(gcn::Graphics *g, const gcn::Rectangle& r) const
{
    g->drawRectangle(gcn::Rectangle(r.x + m_SlideL, r.y + m_SlideT, r.width - m_SlideL + m_SlideR, r.height - m_SlideT + m_SlideB));
    //g->drawPoint(r.x + m_SlideL, r.y + r.height - m_SlideT + m_SlideB);
    g->drawPoint(r.x, r.y + r.height);
}
//---------------------------------------------------------------------------
void TDrawUtil::DrawRectangle(gcn::Graphics *g, const gcn::Rectangle& r, float w) const
{
    GLfloat oldw;
    glGetFloatv(GL_LINE_WIDTH, &oldw);
    glLineWidth(w);
    glBegin(GL_LINE_LOOP);
    glVertex2f(r.x + m_SlideL, r.y + m_SlideT);
    glVertex2f(r.x + r.width - m_SlideL + m_SlideR, r.y + m_SlideT);
    glVertex2f(r.x + r.width - m_SlideL + m_SlideR, r.y + r.height - m_SlideT + m_SlideB);
    glVertex2f(r.x + m_SlideL, r.y + r.height - m_SlideT + m_SlideB);
    glEnd();
    glLineWidth(oldw);
}
//---------------------------------------------------------------------------
