//---------------------------------------------------------------------------
#ifndef drawutilH
#define drawutilH

#include <string>
#include <guichan.hpp>
#include "gcnchar.h"
//---------------------------------------------------------------------------
void DrawFrame(gcn::Graphics *g, const gcn::Rectangle& r, const std::string& caption, TGcnCharDrawer *drawer);
void DrawChipFrame(gcn::Graphics *g, const gcn::Rectangle& r);
void DrawLine(int x1, int y1, int x2, int y2, float w);
void DrawCircle(int x, int y, int r, float w);
void DrawBoldText(gcn::Graphics *g, const char *str, int x, int y);
void DrawImageStretchAlpha(gcn::Graphics *g, const gcn::Image *srcImage, int srcX, int srcY, int srcW, int srcH, int dstX, int dstY, int dstW, int dstH, float alpha);
void DrawOpenGLImage(gcn::OpenGLGraphics *g, const gcn::OpenGLImage *srcImage, int srcX, int srcY, int srcW, int srcH, int dstX, int dstY, int dstW, int dstH, const GLfloat *blend);
//---------------------------------------------------------------------------
class TDrawUtil
{
public:
    void SetSlide(int l, int r, int t, int b);
    void DrawRectangle(gcn::Graphics *g, const gcn::Rectangle& r) const;
    void DrawRectangle(gcn::Graphics *g, const gcn::Rectangle& r, float w) const;
private:
    int m_SlideL;
    int m_SlideR;
    int m_SlideT;
    int m_SlideB;
};
//---------------------------------------------------------------------------
extern TDrawUtil g_DrawUtil;
//---------------------------------------------------------------------------
#endif
