//---------------------------------------------------------------------------
#include "gamesave.h"
#include <boost/filesystem/operations.hpp>
#include "boostformat.h"
#include "logger.h"

/*namespace
{
    const char *XMLELM_SAVETOP = "Save";
    const char *XMLELM_GAMETOP = "Game";
    const char *XMLELM_LUATOP = "Lua";
}*/
//---------------------------------------------------------------------------
std::string TOpenFarenSerializer::GetSaveFileName(const std::string& savdir, int num)
{
    return (boost::format("%s/save%02d.xml") % savdir % num).str();
}
//---------------------------------------------------------------------------
void TOpenFarenSerializer::GetDigest(const std::string& savdir, std::vector<std::string>& savlist, int maxsize)
{
    savlist.clear();
    for(int i=0; i<maxsize; ++i){
        std::string filename = GetSaveFileName(savdir, i);
        if(boost::filesystem::exists(filename)){
            savlist.push_back("");
        }
        else{
            savlist.push_back("f[^Ȃ");
        }
    }
}
//---------------------------------------------------------------------------
/*bool TOpenFarenSerializer::SaveGame(const std::string& savdir, int num, const TOpenFarenGame& game, const TOpenFarenLuaManager& lua)
{
    std::string filename = (boost::format("%s/save%02d.xml") % savdir % num).str();
    TiXmlElement e(XMLELM_SAVETOP);

    TiXmlElement e_game(XMLELM_GAMETOP);
    game.SaveGame(e_game);
    e.InsertEndChild(e_game);

    TiXmlElement e_lua(XMLELM_LUATOP);
    lua.SaveToXML(e_lua);
    e.InsertEndChild(e_lua);

    TiXmlDocument doc(filename.c_str());
    doc.InsertEndChild(e);
    if(!doc.SaveFile()){
        return false;
    }
    return true;
}
//---------------------------------------------------------------------------
bool TOpenFarenSerializer::LoadGame(const std::string& savdir, int num, TOpenFarenGame& game, TOpenFarenLuaManager& lua)
{
    std::string filename = (boost::format("%s/save%02d.xml") % savdir % num).str();

    TiXmlDocument doc(filename.c_str());
    if(!doc.LoadFile(TIXML_ENCODING_UTF8)){
        g_Logger.ErrorLog((boost::format("%s XML parse error") % filename).str());
        return false;
    }
    const TiXmlElement *e = doc.FirstChildElement(XMLELM_SAVETOP);
    if(e == NULL){
        g_Logger.ErrorLog((boost::format("%s %s not found.") % filename % XMLELM_SAVETOP).str());
        return false;
    }

    const TiXmlElement *e_game = e->FirstChildElement(XMLELM_GAMETOP);
    if(e_game == NULL){
        g_Logger.ErrorLog((boost::format("%s %s not found.") % filename % XMLELM_GAMETOP).str());
        return false;
    }
//    if(!game.LoadSavedGame(*e_game)){
//        return false;
//    }

    const TiXmlElement *e_lua = e->FirstChildElement(XMLELM_LUATOP);
    if(e_lua == NULL){
        g_Logger.ErrorLog((boost::format("%s %s not found.") % filename % XMLELM_LUATOP).str());
        return false;
    }
    if(!lua.LoadFromXML(*e_lua)){
        return false;
    }

    return true;
}
//---------------------------------------------------------------------------
*/
