//---------------------------------------------------------------------------
#ifndef skinmanagerH
#define skinmanagerH

#include <guichan.hpp>

// gcnwindow.h
class TGcnWindow;
class TOpenFarenSkin;
//---------------------------------------------------------------------------
class TGcnSkinManager
{
public:
    enum TSkinImageIndex{
        SKINIMAGE_WINDOW,
        SKINIMAGE_MAX
    };

    TGcnSkinManager();
    virtual ~TGcnSkinManager();
    bool LoadSkinImage(const std::string& baseDir);
    gcn::Image* GetSkinImage(TSkinImageIndex index) { return m_SkinImage[index]; }
    void ApplyWindowSkin(TGcnWindow *win) const;
    void ApplyGrayPaneSkin(gcn::Widget *widget) const;
    void ApplyDarkPaneSkin(gcn::Widget *widget) const;
    //void ApplyListBoxSkin(gcn::ListBox *lb) const;
    void ApplyRadioButtonSkin(gcn::RadioButton *rb) const;
    void ApplyButtonEnabled(gcn::Button *b) const;
    void ApplyButtonDisabled(gcn::Button *b) const;
    void ApplyCheckBoxEnabled(gcn::CheckBox *cb) const;
    void ApplyCheckBoxDisabled(gcn::CheckBox *cb) const;
    void ApplyListBoxSkin(gcn::ListBox *lb) const;
    void ApplyScrollAreaSkin(gcn::ScrollArea *sa) const;
    const TOpenFarenSkin* GetSkin() const { return m_Skin; }
private:
    gcn::Image* m_SkinImage[SKINIMAGE_MAX];
    const TOpenFarenSkin* m_Skin;

    gcn::Image* LoadImage(const std::string& filename);
};
//---------------------------------------------------------------------------
#endif
