//---------------------------------------------------------------------------
#include "gcnwindow.h"
#include "drawutil.h"
#include "gcnskinmanager.h"
#include "gamemaster.h"
//---------------------------------------------------------------------------
TGcnWindow::TGcnWindow() :
    m_SkinImage(NULL)
{
    setFrameSize(0);
    g_GameMaster.GetSkinManager()->ApplyWindowSkin(this);
}
//---------------------------------------------------------------------------
TGcnWindow::TGcnWindow(const std::string& caption) :
    gcn::Window(caption),
    m_SkinImage(NULL)
{
    setFrameSize(0);
    g_GameMaster.GetSkinManager()->ApplyWindowSkin(this);
}
//---------------------------------------------------------------------------
TGcnWindow::~TGcnWindow()
{
}
//---------------------------------------------------------------------------
// gcn::Window::draw()Rsyď́Bguichaño[Wオ͍`FbNvB
void TGcnWindow::draw(gcn::Graphics* graphics)
{
    // ȑf`B
    gcn::Color faceColor = getBaseColor();
    gcn::Color backColor = getBackgroundColor();
    int width = getWidth() + getFrameSize() * 2 - 1;
    int height = getHeight() + getFrameSize() * 2 - 1;

    gcn::Rectangle d = getChildrenArea();

    // Phbgg`
    graphics->setColor(backColor);
    g_DrawUtil.DrawRectangle(graphics, gcn::Rectangle(0,0,getWidth(), getHeight()));
    // Fill the background around the content
    graphics->setColor(faceColor);
    // Fill top
    const gcn::Image *winimg = g_GameMaster.GetSkinManager()->GetSkinImage(TGcnSkinManager::SKINIMAGE_WINDOW);
    if(winimg != NULL){
        DrawImageStretchAlpha(graphics, winimg, 0, 0, winimg->getWidth(), winimg->getHeight(), 1, 1, getWidth() - 2, d.y - 1, 0.75);
    }
    else{
        graphics->fillRectangle(gcn::Rectangle(1, 1, getWidth() - 2, d.y - 1));
    }
    // Fill left
    graphics->fillRectangle(gcn::Rectangle(1, d.y, d.x - 1, d.height));
    // Fill right
    graphics->fillRectangle(gcn::Rectangle(d.x + d.width,
                                      d.y,
                                      getWidth() - d.x - d.width - 1,
                                      d.height));
    // Fill bottom
    graphics->fillRectangle(gcn::Rectangle(1,
                                      d.y + d.height,
                                      getWidth() - 2,
                                      getHeight() - d.height - d.y - 1));

    // gcn::Window::draw()ƓB
    if (isOpaque())
    {
        graphics->fillRectangle(d);
    }

    // ȉgcn::Window::draw()ƓB
    drawChildren(graphics);

    int textX;
    int textY;

    textY = ((int)getTitleBarHeight() - getFont()->getHeight()) / 2;

    switch (getAlignment())
    {
      case gcn::Graphics::LEFT:
          textX = 4;
          break;
      case gcn::Graphics::CENTER:
          textX = getWidth() / 2;
          break;
      case gcn::Graphics::RIGHT:
          textX = getWidth() - 4;
          break;
      default:
          throw GCN_EXCEPTION("Unknown alignment.");
    }

    graphics->setColor(getForegroundColor());
    graphics->setFont(getFont());
    graphics->pushClipArea(gcn::Rectangle(0, 0, getWidth(), getTitleBarHeight() - 1));
    graphics->drawText(getCaption(), textX, textY, getAlignment());
    graphics->popClipArea();
    drawChildren(graphics);
}
//---------------------------------------------------------------------------
