//---------------------------------------------------------------------------
#include "grid.h"
#include "gui.h"
#include "logger.h"
#include "boostformat.h"
//---------------------------------------------------------------------------
TGcnGrid::TGcnGrid() :
    m_Model(NULL),
    m_FontSize(TGuiContainerList::FONT_SIZE_SMALL)
    //m_RowHeight(4)
    //m_BGColor(0, 0, 0)
{
    m_drawer = g_GuiContainerList.GetDrawer(m_FontSize);
    addMouseListener(this);
}
//---------------------------------------------------------------------------
TGcnGrid::~TGcnGrid()
{
}
//---------------------------------------------------------------------------
void TGcnGrid::draw(gcn::Graphics* g)
{
    static const gcn::Color white(255, 255, 255);

    gcn::Rectangle r = getDimension();
    r.x = r.y = 0;
    g->setColor(getBackgroundColor());
    g->fillRectangle(r);

    if(m_Model == NULL){
        return;
    }
    int cols = m_Model->GetNumberOfColumns();
    int rows = m_Model->GetNumberOfRows();
    int gridh = m_Model->GetRowHeight();
    int gridtotalh = gridh * rows;

    g->setColor(white);
    // c
    int gridtotalw = 0;
    for(int col=0; col<cols; ++col){
        g->drawLine(gridtotalw, 0, gridtotalw, gridtotalh);
        int colw = m_Model->GetColumnWidth(col);
        // Z̃ACg擾B
        bool right = m_Model->GetColumnAlignment(col);
        for(int row=0; row<rows; ++row){
            // Z̒g`B
            std::string str = m_Model->GetElementAt(col, row);
            int x;
            if(right && row){
                x = gridtotalw + colw - m_drawer->GetStringWidth(str.c_str()) - 2;
            }
            else{
                x = gridtotalw + 2;
            }
            m_drawer->DrawString(g, x, row*gridh + 2, str.c_str(), white);
        }
        // ̗ցB
        gridtotalw += colw;
    }
    g->drawLine(gridtotalw, 0, gridtotalw, gridtotalh);

    // 
    int y = 0;
    for(int row=0; row<=rows; ++row){
        g->drawLine(0, y, gridtotalw, y);
        y += gridh;
    }
}
//---------------------------------------------------------------------------
void TGcnGrid::mousePressed(gcn::MouseEvent &mouseEvent)
{
    if(m_Model == NULL){
        return;
    }
    if(mouseEvent.getY() > m_Model->GetRowHeight()){
        return;
    }
    int x = mouseEvent.getX();
    int x1 = 0;
    int cols = m_Model->GetNumberOfColumns();
    for(int col=0; col<cols; ++col){
        int colw = m_Model->GetColumnWidth(col);
        if(x < x1 + colw){
            m_Model->OnSort(col);
            break;
        }
        x1 += colw;
    }
/*
    unsigned sz = m_ColumnWidth.size();
    for(unsigned u=0; u<sz; ++u){
        if(x < x1 + m_ColumnWidth[u]){
            m_Model->OnSort(u);
            break;
        }
        x1 += m_ColumnWidth[u];
    }
*/
}
//---------------------------------------------------------------------------
void TGcnGrid::SetGridModel(TGcnGridModel *model)
{
    m_Model = model;
    //m_ColumnWidth.resize(model->GetNumberOfColumns());
}
//---------------------------------------------------------------------------
void TGcnGrid::SetFontSize(int fontsize)
{
    m_FontSize = fontsize;
    m_drawer = g_GuiContainerList.GetDrawer(fontsize);
}
//---------------------------------------------------------------------------
/*void TGcnGrid::SetColumnWidth(int col, int w)
{
    if(col < m_ColumnWidth.size()){
        m_ColumnWidth[col] = w;
    }
}
//---------------------------------------------------------------------------
void TGcnGrid::SetRowHeight(int h)
{
    m_RowHeight = h;
}*/
//---------------------------------------------------------------------------
