//---------------------------------------------------------------------------
#ifndef gridH
#define gridH

#include <string>
#include <vector>
#include <guichan.hpp>
#include "gcnchar.h"
//---------------------------------------------------------------------------
class TGcnGridModel
{
public:
    virtual ~TGcnGridModel() {}
    virtual int GetNumberOfColumns() = 0;
    virtual int GetNumberOfRows() = 0;
    virtual std::string GetElementAt(int col, int row) = 0;
    virtual void OnSort(int col) = 0;
    virtual int GetColumnWidth(int col) = 0;
    virtual int GetRowHeight() = 0;
    virtual bool GetColumnAlignment(int col) = 0;
};
//---------------------------------------------------------------------------
class TGcnGrid : public gcn::Widget, public gcn::MouseListener
{
private:
    TGcnGridModel *m_Model;
    int m_FontSize;
    TGcnCharDrawer *m_drawer;
    //gcn::Color m_BGColor;
    //int m_RowHeight;
    //std::vector<int> m_ColumnWidth;
public:
    TGcnGrid();
    virtual ~TGcnGrid();
    virtual void draw(gcn::Graphics* g);
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    void SetGridModel(TGcnGridModel *model);
    void SetFontSize(int fontsize);
    //void SetColumnWidth(int col, int w);
    //void SetRowHeight(int h);
};
//---------------------------------------------------------------------------
#endif
