//---------------------------------------------------------------------------
#include <algorithm>
#include <cmath>
#include "gui.h"
#include "framewait.h"
#include "boostformat.h"
#include "logger.h"
//---------------------------------------------------------------------------
TGuiContainerList g_GuiContainerList;
//---------------------------------------------------------------------------
namespace{
    struct TDeleteObject
    {
        template<typename T>
        void operator()(const T *p) const{
            delete p;
        }
    };
}
//---------------------------------------------------------------------------
TGuiContainerList::TGuiContainerList()
    : m_tick(0)
{
    double pi;
    double rad, d;
    int i;

    using namespace std;
    pi = asin(1.0)*2.0;
    for(i=0; i<m_SinTableMax; i++){
        rad = (pi*i*2.0)/m_SinTableMax;
        d = 256*sin(rad);
        // ΒlŎľܓB
        if(d > 0){
            m_SinTable[i] = (int)(d + 0.5);
        }else{
            m_SinTable[i] = (int)(d - 0.5);
        }
        d = 256*cos(rad);
        // ΒlŎľܓB
        if(d > 0){
            m_CosTable[i] = (int)(d + 0.5);
        }else{
            m_CosTable[i] = (int)(d - 0.5);
        }
    }
}
//---------------------------------------------------------------------------
TGuiContainerList::~TGuiContainerList()
{
    // {NXO[oϐi|C^ȂăCX^XjƂĎgpꍇA
    // guichanSDL֘A̕邱Ƃ͂łȂB
}
//---------------------------------------------------------------------------
void TGuiContainerList::SetGui(gcn::Gui* pg)
{
    m_gui = pg;
}
//---------------------------------------------------------------------------
void TGuiContainerList::SetInput(gcn::SDLInput* pi)
{
    m_input = pi;
}
//---------------------------------------------------------------------------
void TGuiContainerList::Add(boost::shared_ptr<gcn::Widget> pw)
{
    m_list.push_back(pw);
}
//---------------------------------------------------------------------------
TGcnCharDrawer* TGuiContainerList::GetDrawer(int fontsize)
{
    for(TGcnCharDrawerList::iterator itr = m_drawerlist.begin(); itr != m_drawerlist.end(); ++itr){
        if((*itr)->GetCharHeight() == fontsize){
            return itr->get();
        }
    }
    boost::shared_ptr<TGcnCharDrawer> newdrawer(new TGcnCharDrawer());
    if(newdrawer->Load("sjis.txt", NULL, fontsize, fontsize, m_fontname.c_str())){
        m_drawerlist.push_back(newdrawer);
        return newdrawer.get();
    }
    else{
        g_Logger.ErrorLog((boost::format("TGcnCharDrawer::Load() failed. LastError=%s") % newdrawer->GetLastError()).str());
    }
    return NULL;
}
//---------------------------------------------------------------------------
void TGuiContainerList::RemoveAll()
{
    m_list.clear();

    delete m_input;
    delete m_gui;
}
//---------------------------------------------------------------------------
void TGuiContainerList::MoveWidgetToCenter(gcn::Widget* w)
{
    const gcn::Widget* top = GetGui()->getTop();
    int x = top->getWidth()/2 - w->getWidth()/2;
    int y = top->getHeight()/2 - w->getHeight()/2;
    if(x < 0){
        x = 0;
    }
    if(y < 0){
        y = 0;
    }
    w->setPosition(x, y);
}
//---------------------------------------------------------------------------
/*
// CxgĂPt[̏sB
// gcn::Gui::logic() ͍ēz肵ĂȂ̂AĂяo
// ŏ̃}EXCxgołȂs̂ŁAɎgĂ܂ĂTGcnMsgDlg̏ȊOł͎gȂƁB
bool TGuiContainerList::GcnProcessMessages()
{
    SDL_Event event;
    while(SDL_PollEvent(&event)){
        if(event.type == SDL_QUIT){
            // ICxg͏߂B
            SDL_PushEvent(&event);
            return false;
        }
        GetInput()->pushInput(event);
    }

    GetGui()->logic();
    GetGui()->draw();

#if defined(USE_OPENGL)
    SDL_GL_SwapBuffers();
#else
    SDL_Flip(screen);
#endif
    elapse_time(m_fps);

    return true;
}
*/
//---------------------------------------------------------------------------
