//---------------------------------------------------------------------------
#ifndef guiH
#define guiH

#include <list>
#include <vector>
#include <boost/shared_ptr.hpp>
#include <guichan.hpp>
#include <guichan/sdl.hpp>
#include "gcnchar.h"

//---------------------------------------------------------------------------
class TGuiContainerList
{
public:
    TGuiContainerList();
    ~TGuiContainerList();

    void SetGui(gcn::Gui* pg);
    gcn::Gui* GetGui() { return m_gui; };

    void SetInput(gcn::SDLInput* pi);
    gcn::SDLInput* GetInput() { return m_input; };

    void SetFPS(int fps){ m_fps = fps; };
    int GetFPS() const { return m_fps; };

    void Add(boost::shared_ptr<gcn::Widget> w);

    TGcnCharDrawer* GetDrawer(int fontsize);
    void SetFontName(const std::string& name) { m_fontname = name; };
    void RemoveAll();
    void MoveWidgetToCenter(gcn::Widget* w);
    bool GcnProcessMessages();
    void AddTick() { m_tick++; }
    int GetTick() const { return m_tick; }

    // Op֐
    int GetTrigonometricMax() const { return m_SinTableMax; }
    int GetSin(int i) const { return m_SinTable[i]; }
    int GetCos(int i) const { return m_CosTable[i]; }

    static const int FONT_SIZE_NORMAL = 16;
    static const int FONT_SIZE_SMALL = 12;
private:
    gcn::Gui* m_gui;
    gcn::SDLInput* m_input;
    typedef std::list<boost::shared_ptr<gcn::Widget> > TGcnWidgetList;
    TGcnWidgetList m_list;

    typedef std::list<boost::shared_ptr<TGcnCharDrawer> > TGcnCharDrawerList;
    TGcnCharDrawerList m_drawerlist;
    std::string m_fontname;
    int m_fps;
    int m_tick;
    // Op֐
    static const int m_SinTableMax = 64;
    int m_SinTable[m_SinTableMax];
    int m_CosTable[m_SinTableMax];
};
//---------------------------------------------------------------------------
extern TGuiContainerList g_GuiContainerList;
//---------------------------------------------------------------------------
#endif
