//---------------------------------------------------------------------------
#ifndef guichanjpH
#define guichanjpH

#include <guichan.hpp>
#include <guichan/sdl.hpp>
#include <SDL.h>
#if (USE_OPENGL)
#include <guichan/opengl.hpp>
#include <guichan/opengl/openglsdlimageloader.hpp>
#endif
#if (USE_OPENGL)
#include "gcnchar.h"
#else
#include "drawchar.h"
#endif
//---------------------------------------------------------------------------
class TGuichanFontSJIS : public gcn::Font
{
private:
#if (USE_OPENGL)
    TGcnCharDrawer *m_Drawer;
#else
    TCharacterDrawerOnSDL m_Drawer;
    SDL_Surface *m_Surface;
    gcn::SDLImage *m_Image;
#endif
public:
    TGuichanFontSJIS();
    virtual ~TGuichanFontSJIS();
#if (USE_OPENGL)
    bool Initialize(int fontsize, const std::string& fontname);
#else
    bool Initialize(SDL_PixelFormat *format, int fontsize, const char* fontname);
#endif
    virtual void drawString(gcn::Graphics *graphics, const std::string &text, int x, int y);
    virtual int getHeight() const;
    virtual int getWidth(const std::string& text) const;
};
//---------------------------------------------------------------------------
#endif
