#ifndef iniloadH
#define iniloadH

#include <string>
#include <map>

class TIniLoader
{
public:
    TIniLoader();
    virtual ~TIniLoader();

    bool LoadFromFile(const std::string& filename);
    bool GetString(const std::string& catkey, const std::string& key, std::string& val) const;
    bool GetInt(const std::string& catkey, const std::string& key, int& val) const;
    bool GetIntHex(const std::string& catkey, const std::string& key, int& val) const;
    std::string GetString(const std::string& catkey, const std::string& key) const;
    int GetInt(const std::string& catkey, const std::string& key) const;
    int GetIntHex(const std::string& catkey, const std::string& key) const;
    void SetString(const std::string& catkey, const std::string& key, std::string& val);
    void SetInt(const std::string& catkey, const std::string& key, int val);

    bool SaveToFile(const std::string& filename) const;
private:
    std::map<std::string, std::map<std::string, std::string> > m_ValueMap;
};
#endif
