//---------------------------------------------------------------------------
#ifndef loggerH
#define loggerH

#include <cstdio>
#include <string>
#include "boostformat.h"
//---------------------------------------------------------------------------
#if defined(WIN32)
#define FUNCNAME __FUNCTION__
#else
#define FUNCNAME __func__
#endif

#define LOGTEMPLATE(LOGFUNC, x) try{ LOGFUNC((boost::format("%s:%d:%s") % FUNCNAME % __LINE__ % x).str()); } \
                                catch(boost::io::format_error&) \
                                { LOGFUNC((boost::format("%s:%d:format error") % FUNCNAME % __LINE__).str()); }

#if defined(OF_NODBGLOG)
#define OFDBGLOG(x)
#else
#define OFDBGLOG(x) LOGTEMPLATE(g_Logger.DebugLog, x)
#endif

#define OFWRNLOG(x) LOGTEMPLATE(g_Logger.WarningLog, x)

#define OFERRLOG(x) LOGTEMPLATE(g_Logger.ErrorLog, x)
//---------------------------------------------------------------------------
class TOpenFarenLogger
{
private:
    FILE *m_fp;
    int m_LogLevel;
    bool m_EveryFlush;
public:
    enum TLogLevel{
        LOGLEVEL_ERROR=1,
        LOGLEVEL_WARNING,
        LOGLEVEL_DEBUG
    };

    TOpenFarenLogger();
    ~TOpenFarenLogger();
    void SetLogLevel(int level);
    void SetEveryFlush(bool b) { m_EveryFlush = b; }
    void DebugLog(const std::string& str);
    void WarningLog(const std::string& str);
    void ErrorLog(const std::string& str);
};
//---------------------------------------------------------------------------
// ̊֐͂ɒû͕ςȂ̂ňړ邩B
std::string GetNowDateStr();
//---------------------------------------------------------------------------
extern TOpenFarenLogger g_Logger;
//---------------------------------------------------------------------------
#endif
