//---------------------------------------------------------------------------
#ifndef magicwindowH
#define magicwindowH

#include <vector>
#include <guichan.hpp>
#include <boost/shared_ptr.hpp>
#include "gcnchar.h"
#include "ofdata.h"
#include "ofgame.h"
//---------------------------------------------------------------------------
bool HasUsableMagic(const TCharacterInstance& chara);
bool IsUsableMagic(const TCharacterInstance& chara, int special);
//---------------------------------------------------------------------------
class TMagicGroupPane : public gcn::Widget, gcn::MouseListener
{
private:
    int m_CharaType;
    int m_MP;
    int m_MagicGroupIndex;
    const std::vector<int> *m_MagicUseCount;
    std::vector<int> m_ButtonEnabledList;
    std::vector<int> m_SpecialList;
    std::vector<int> m_MagicGroupIndexList;
    std::vector<int> m_MagicIndexList;
    gcn::Rectangle m_ActiveButtonRect;
    int m_ActiveMagicIndex;
    int m_ActiveSpecialIndex;
    bool m_ActiveUsable;
    gcn::ActionListener* m_ActionListener;
    TGcnCharDrawer *m_CharDrawer;
    TGcnCharDrawer *m_CharDrawerBig;
public:
    TMagicGroupPane();
    virtual ~TMagicGroupPane() {}
    void SetMagicGroup(int charatype, int mp, int groupindex, const std::vector<int> *usecount);
    void Clear();
    void SetActionListener(gcn::ActionListener* listener);
    int GetSpecialAt(int x, int y, int& line, int& rank, int& magicindex, bool& usable);
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
    virtual void mouseExited(gcn::MouseEvent &mouseEvent);
    virtual void draw(gcn::Graphics *g);
};
//---------------------------------------------------------------------------
// 퓬̃R}h{^EBhE
class TMagicWindow : public gcn::Window
{
private:
    std::vector<boost::shared_ptr<TMagicGroupPane> > m_PaneList;
    std::vector<int> m_GroupList;
    gcn::ActionListener* m_ActionListener;
public:
    TMagicWindow();
    virtual ~TMagicWindow() {}
    void Show(const TCharacterInstance& chara, const std::vector<int> *usecount);
    void Clear();
    void SetActionListener(gcn::ActionListener* listener);
    bool IsMyAction(const gcn::Widget* source) const;
};
#endif
