//---------------------------------------------------------------------------
#ifndef masterselectH
#define masterselectH

#include <string>
#include <vector>
#include <guichan.hpp>
#include "textpane.h"
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TGcnMasterPane : public gcn::Widget, public gcn::MouseListener
{
public:
    TGcnMasterPane();
    virtual ~TGcnMasterPane() {}
    virtual void draw(gcn::Graphics *g);
    void StartOperation();
    void EndOperation();
    bool IsContainData() const { return m_ContainData; }
    void SetSelected(int x, int y);
    void SetBrowsed(int x, int y);
    int GetBrowsed() const { return m_Browsed; }
    void GetSelectedMasterIndex(std::vector<int>& indice) const;
    void AllSelect();
    void AllClear();
    virtual void mousePressed(gcn::MouseEvent &mouseEvent);
    virtual void mouseMoved(gcn::MouseEvent &mouseEvent);
private:
    TGcnCharDrawer *m_Drawer;
    bool m_ContainData;
    int m_XCount;
    int m_YCount;
    std::vector<int> m_MasterIndexList;
    std::vector<int> m_Selected;
    int m_Browsed;
};
//---------------------------------------------------------------------------
class TMasterSelectPane : public gcn::Container, public gcn::ActionListener
{
public:
    TMasterSelectPane();
    virtual ~TMasterSelectPane() {}
    virtual void action(const gcn::ActionEvent& actionEvent);
    virtual void logic();
    void StartOperation();
    void EndOperation();
private:
    gcn::Button m_ButtonAllSelect;
    gcn::Button m_ButtonAllClear;
    gcn::Button m_ButtonOk;
    gcn::Button m_ButtonCancel;
    gcn::ScrollArea m_MasterScrollArea;
    TGcnMasterPane m_MasterPane;
    TGcnTextPane m_TextHandle;
    TGcnTextPane m_TextDiffculty;
    TGcnTextPane m_TextExplanation;
};
//---------------------------------------------------------------------------
class TMasterSelectWindow : public TGcnWindow
{
public:
    TMasterSelectWindow();
    virtual ~TMasterSelectWindow() {}
    TMasterSelectPane& GetPane() { return m_Pane; }
private:
    TMasterSelectPane m_Pane;
};
//---------------------------------------------------------------------------
#endif
