//---------------------------------------------------------------------------
#ifndef msgdlgH
#define msgdlgH

#include <string>
#include <guichan.hpp>
#include "textpane.h"
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TGcnMsgDlg : public TGcnWindow, public gcn::ActionListener
{
private:
    static const int BUTTON_MAX = 4;
    gcn::Button m_button[BUTTON_MAX];
    //gcn::Label m_msglabel;
    TGcnTextPane m_msglabel;
    int m_ButtonFlag;
    int m_Pressed;
    int m_Tick;
    int m_Timeout;
    static TGcnMsgDlg *m_StaticMsgDlg;

    void UpdateContent();
public:
    static const int BUTTON_OK      = 0x00000001;
    static const int BUTTON_YES     = 0x00000002;
    static const int BUTTON_NO      = 0x00000004;
    static const int BUTTON_CANCEL  = 0x00000008;
    explicit TGcnMsgDlg(const std::string& caption, const std::string& msg, int button, int timeout = 0);
    virtual ~TGcnMsgDlg();
    void Show();
    void SetLabel(const std::string& msg);
    void SetButton(int button);
    void SetTimeout(int timeout);
    int GetPressedButton() const { return m_Pressed; }
    virtual void action(const gcn::ActionEvent& actionEvent);
    virtual void logic();
    static void Show(const std::string& caption, const std::string& msg, int button, int timeout = 0);
    static bool IsVisible();
    static int GetPressedButtonStatic() { return m_StaticMsgDlg->GetPressedButton(); }
};
//---------------------------------------------------------------------------
#endif
