//---------------------------------------------------------------------------
#ifndef ofdataH
#define ofdataH

#include <vector>
#include <map>
#include <string>
#include <tinyxml.h>
#include "scenario.h"
#include "oftypes.h"
//---------------------------------------------------------------------------
// VXeŒ񋟂鑮B
enum TSystemEffect
{
    SYSTEM_NONE,
    SYSTEM_NOEFFECT,    // ʂ̃_[WƂʂȏsȂB
    SYSTEM_POISON,
    SYSTEM_STONE,
    SYSTEM_PARALYZE,
    SYSTEM_SLEEP,
    SYSTEM_DREAM,
    SYSTEM_DEATH,
    SYSTEM_ABSORB,
    SYSTEM_HPRECOVER,
    SYSTEM_MPRECOVER,
    SYSTEM_CRASHWALL,
    SYSTEM_PLUS_PA,
    SYSTEM_PLUS_PD,
    SYSTEM_PLUS_SKILL,
    SYSTEM_PLUS_SPEED,
    SYSTEM_PLUS_MA,
    SYSTEM_PLUS_MD,
    SYSTEM_PLUS_HPRECOVER,
    SYSTEM_PLUS_MPRECOVER,
    SYSTEM_PLUS_ATTACKCOUNT,
    SYSTEM_CURE_POISON,
    SYSTEM_CURE_STONE,
    SYSTEM_CURE_PARALYZE,
    SYSTEM_CURE_SLEEP,
    SYSTEM_CURE_DREAM,
    SYSTEM_CURE_ALL,
    SYSTEM_CHANGE_RESISTANCE, // ΖhƂB
    SYSTEM_CHANGE_MOVETYPE,
    SYSTEM_SUMMON,
    SYSTEM_REVIVE,
    SYSTEM_EFFECTMAX
};
enum TResistance
{
    RES_NONE,
    RES_WEAK,
    RES_NORMAL,
    RES_STRONG,
    RES_ABSORB,
    RES_MAX
};
// ˒ƌʔ͈͂̎w@B
enum TRangeType
{
    RANGE_NORMAL = 1,   // |AuXAʏ햂@
    RANGE_ME,           // SiMP񕜁Aǔjj
    RANGE_STREAM,       // 
    RANGE_ALLMYSIDE,    // ŚiI[q[j
    RANGE_ALLENEMY,     // GŚiNCGj
    RANGE_ALLWALL,      // ǑS
    RANGE_LASTDEADMYSIDE,   // ŌɎS̍W
    RANGE_LASTDEADENEMY,    // ŌɎSG̍W
    RANGE_ALLDEADMYSIDE,    // SS̍W
    RANGE_ALLDEADENEMY,     // SGS̍W
    RANGE_LOWERTHAN,        // ፂx̒n`
    RANGE_MAX
};
// KEZE@ʁB
enum TAttributeType{
    ATTRTYPE_NONE,
    ATTRTYPE_ATTACK,        // GɓZ
    ATTRTYPE_BOOST,         // ɓZ
    ATTRTYPE_CRASHWALL,     // ǂɓZ
    ATTRTYPE_SUMMON,        // GȂɓZ
    ATTRTYPE_REVIVE,        // i܂͐VKLujZ
    ATTRTYPE_MAX
};
enum TReviveType{
    REVIVE_NONE,
    REVIVE_SAME,            // ̂܂ܕ
    REVIVE_EMPLOYABLE,      // ٗp\LVKɒu
    REVIVE_FROMLIST,        // XgꂽLVKɒu
    REVIVE_MAX
};
// KEZCxg̎ށB
enum TSpecialEventType{
    SPECIALEVENT_NONE,
    SPECIALEVENT_MEDEAD,        // ̎S
    SPECIALEVENT_MYSIDEDEAD,    // ̎S
    SPECIALEVENT_ENEMYDEAD,     // G̎S
    SPECIALEVENT_MAX
};
enum TAnimationType{
    ANIMATION_NONE,
    ANIMATION_CHIP,
    ANIMATION_CENTER,
    ANIMATION_STREAM,
    ANIMATION_SHOT,
    ANIMATION_SCREENCENTER,
    ANIMATION_MAX
};
enum TPowerType
{
    POWER_NONE,
    POWER_HP,
    POWER_MP,
    POWER_PA,
    POWER_PD,
    POWER_SKILL,
    POWER_SPEED,
    POWER_MA,
    POWER_MD,
    POWER_MAX
};
enum TFormula
{
    FORMULA_NONE,
    FORMULA_FTATTACK,       // t@[gD[K̒ʏŨ_[WvZ
    FORMULA_FTSPECIAL,      // KEZ
    FORMULA_FTMAGIC,        // @
    FORMULA_ANYTIME,        // K
    FORMULA_FTATTACKHIT,    // U̖̎iǉʂj
    FORMULA_FTSPECIALHIT,   // KEZ̖̎iǉʂj
    FORMULA_FTMAGICHIT,     // @̒ǉʂ̖̎
    FORMULA_MAX
};
enum THitJudgeType
{
    HITJUDGE_NONE,
    HITJUDGE_SINGLE,        // Ŗƒǉʕt^𔻒肷B
    HITJUDGE_DOUBLE,        // ɒǉʕt^𔻒肷B
    HITJUDGE_SEPARATE,      // ƒǉʕt^ʁXɔ肷B
    HITJUDGE_MAX
};
//---------------------------------------------------------------------------
struct TNamedType
{
    std::string m_id;
    std::string m_name;
};
typedef std::vector<TNamedType> TNamedTypeList;
//---------------------------------------------------------------------------
struct TRace
{
    std::string m_id;
    std::string m_name;
    std::vector<int> m_distance;
};
typedef std::vector<TRace> TRaceList;
//---------------------------------------------------------------------------
struct TAttribute
{
    std::string m_id;
    std::string m_name;
    std::string m_shortname;
    TAttributeType m_type;
    TSystemEffect m_systemeffect;
    TAttribute() : m_type(ATTRTYPE_NONE), m_systemeffect(SYSTEM_NONE)
    {
    }
};
typedef std::vector<TAttribute> TAttributeList;
//---------------------------------------------------------------------------
struct TMoveType
{
    std::string m_id;
    std::string m_name;
    std::vector<int> m_cost;        // n`^㕨̈ړRXgBCfbNX͒Pɒn`̌ɏ㕨B
    std::vector<int> m_skill;       // n`^㕨̈ړRXgBɓB
};
typedef std::vector<TMoveType> TMoveTypeList;
//---------------------------------------------------------------------------
struct TRevive
{
    std::string m_id;
    TReviveType m_selectmethod;
    std::vector<std::string> m_charaidlist;
    std::vector<int> m_charalist;
};
typedef std::vector<TRevive> TReviveList;
//---------------------------------------------------------------------------
struct TMagic
{
    std::string m_specialid;
    int m_special;
    int m_needrank;
    TMagic() : m_special(-1), m_needrank(0)
    {
    }
};
typedef std::vector<TMagic> TMagicList;
//---------------------------------------------------------------------------
struct TMagicData
{
    std::string m_id;
    std::string m_name;
    std::string m_guidance;
    std::string m_groupid;
    int m_limit;
    TMagicList m_magics;
    TMagicData() : m_limit(0)
    {
    }
};
typedef std::vector<TMagicData> TMagicDataList;
//---------------------------------------------------------------------------
struct TMagicGroup
{
    std::string m_id;
    std::string m_name;
    std::vector<int> m_magiclist;
    unsigned m_color;
    TMagicGroup() : m_color(0xffffffff)
    {
    }
};
typedef std::vector<TMagicGroup> TMagicGroupList;
//---------------------------------------------------------------------------
struct TSpecial
{
    std::string m_id;
    std::string m_name;
    int m_dirno;            // `ꂽfBNgCfbNX
    TRangeType m_rangetype;
    int m_rangeheight;          // RANGE_LOWERTHAN̊xB
    std::vector<int> m_excludemt;    // Oړ^CvB
    TAnimationType m_animtype;
    TFormula m_powerformula;
    TFormula m_hitformula1;
    TFormula m_hitformula2;
    THitJudgeType m_hitjudgetype;
    int m_animcount;
    int m_animwidth;
    int m_animheight;
    int m_consumemp;
    int m_maxrange;         // SƑŜ̏ꍇ͎gpȂB
    int m_maxradius;        // 01}XB17}XB
    int m_target;
    int m_power;
    TPowerType m_powertype; // gp\͒liʒlZo̍Uߑj
    TPowerType m_guardtype; // gp\͒liʒlZo̎󂯑j
    TPowerType m_hittype;   // gp\͒liZo̍Uߑj
    TPowerType m_avoidtype; // gp\͒liZo̎󂯑j
    int m_attribute;        // TOpenFarenData::m_AttributeList̃CfbNXB
    std::string m_addstr;
    std::string m_script_before;
    std::string m_script_after;
    // SYSTEM_CHANGE_REGISTANCẼp[^B
    int m_resistanceattr;
    TResistance m_resistancetype;
    // SYSTEM_CHANGE_MOVETYPẼp[^B
    int m_movetype;
    // SYSTEM_SUMMOÑp[^B
    std::string m_summoncharaid;
    int m_summonchara;
    // SYSTEM_REVIVẼp[^B
    int m_revive;
    std::string m_imagefile;
    int m_image;
    std::string m_soundfile;
    int m_sound;
    TSpecial() : m_dirno(0), m_rangetype(RANGE_NORMAL), m_animtype(ANIMATION_CHIP), m_animcount(1),
        m_consumemp(0), m_maxrange(1), m_maxradius(0), m_target(-1), m_power(0),
        m_powertype(POWER_NONE), m_guardtype(POWER_NONE), m_attribute(0), m_image(0), m_sound(-1) {}
};
typedef std::vector<TSpecial> TSpecialList;
//---------------------------------------------------------------------------
struct TMaster
{
    std::string m_id;       // wcIDi}X^[ςƐwcIDς̂Ƃj
    std::string m_name;     // wci܂܃f[^̓}X^[Ɠj
    std::string m_musicfile;
    std::string m_battlemusicfile;
    std::string m_masterbattlemusicfile;
    int m_music;
    int m_battlemusic;
    int m_masterbattlemusic;
    unsigned m_powermapcolor;   // ABGR
    std::string m_flagfile; // [hgp
    int m_facecharaindex;   // }X^[I̎gpB
    int m_flagindex;
    TMaster() : m_music(-1), m_battlemusic(-1), m_masterbattlemusic(-1),
        m_powermapcolor(0xff000000), m_facecharaindex(-1), m_flagindex(-1)
    {
    }
};
typedef std::vector<TMaster> TMasterList;
//---------------------------------------------------------------------------
struct TAttack
{
    int m_power;
    //int m_attribute;        // TOpenFarenData::m_AttributeList̃CfbNXB
    int m_special;          // TOpenFarenData::m_SpecialList̃CfbNXB-1Ȃ疳B
    //TAttack() : m_power(0), m_attribute(0) {}
    TAttack() : m_power(0), m_special(-1) {}
};

struct TBattleCharacter
{
    std::string m_id;
    std::string m_name;
    std::string m_chipfile; // [hgp
    std::string m_facefile; // [hgp
    int m_dirno;            // `ꂽfBNgCfbNX
    int m_chipindex;
    int m_faceindex;
    std::vector<int> m_magicrank;
    std::vector<TResistance> m_resistance;
    bool m_hero;
    bool m_master;          // \[gƎSbZ[WpB
    bool m_deadmessage;     // SbZ[WoB
    bool m_nowander;
    int m_race;             // TOpenFarenData::m_RaceList̃CfbNX
    int m_employcost;
    int m_turncost;
    int m_movetype;         // TOpenFarenData::m_MoveTypeList̃CfbNX
    int m_movable;
    // (*1)Nɂ鑝Ώ
    int m_hpmax;    // *1
    int m_mpmax;    // *1
    int m_pa;       // *1
    int m_pd;       // *1
    int m_skill;    // *1
    int m_speed;    // *1
    int m_ma;       // *1
    int m_md;       // *1
    int m_morale;
    int m_aggressive;
    int m_hprecover;
    int m_mprecover;
    int m_specialindex;
    int m_specialcount;
    int m_autospecialindex;
    TSpecialEventType m_autospecialtype;
    std::string m_autoscript;
    TSpecialEventType m_autoscripttype;
    int m_experience;
    int m_power;
    int m_turnmin;
    int m_turnmax;
    std::vector<int> m_commandrace; // r[XgeC}[B߂ł鑼푰̃XgBTOpenFarenData::m_RaceList̃CfbNXB
    int m_target;
    std::vector<TAttack> m_attacklist;
    std::vector<std::string> m_employable_id;
    std::vector<int> m_employable;
    std::string m_classchange_id;
    int m_classchange;
    TBattleCharacter() : m_dirno(0), m_chipindex(-1), m_faceindex(-1),
        m_hero(false), m_master(false), m_deadmessage(false), m_nowander(false),
        m_race(0), m_employcost(0), m_turncost(0),
        m_movetype(-1), m_movable(0),
        m_hpmax(0), m_mpmax(0), m_pa(0), m_pd(0), m_skill(0), m_speed(0), m_ma(0), m_md(0),
        m_morale(0), m_aggressive(0), m_hprecover(0), m_mprecover(0),
        m_specialindex(-1), m_specialcount(0), m_autospecialindex(-1), m_experience(1), m_power(1),
        m_turnmin(0), m_turnmax(-1), m_target(-1),
        m_classchange(-1)
    {
    }
};
typedef std::vector<TBattleCharacter> TBattleCharacterList;
//---------------------------------------------------------------------------
struct TPowerMapPoint
{
    std::string m_id;
    std::vector<point_t> m_points;
};
typedef std::vector<TPowerMapPoint> TPowerMapPointList;
//---------------------------------------------------------------------------
class TOpenFarenData
{
private:
    //TNamedTypeList m_MagicGroupList;
    TMagicGroupList m_MagicGroupList;
    TSpecialList m_SpecialList;
    //TNamedTypeList m_RaceList;
    TRaceList m_RaceList;
    TAttributeList m_AttributeList;
    std::vector<std::string> m_MapGroundList;   // n`̖OXg
    std::vector<std::string> m_MapObjectList;   // 㕨̖OXg
    TMoveTypeList m_MoveTypeList;
    TReviveList m_ReviveList;
    TMagicDataList m_MagicDataList;
    TMasterList m_MasterList;
    TPowerMapPointList m_PowerMapPointList;
    std::vector<int> m_MapObjList;  // 㕨XgBCfbNXF`bvCfbNXAlFށiTMapObject̒lj
    std::vector<int> m_MapChipList; // n`XgBCfbNXF`bvCfbNXAlFށiTMapChip̔z̃CfbNXj
    std::map<std::string, int> m_TargetTable;

    // LN^[
    std::vector<std::string> m_CharaDirList;
    TBattleCharacterList m_CharaList;

    std::string m_ScenarioTitle; // ViIBႦDefaultȂ"t@[gD[K"
    TFarenChapter m_Chapter;

    int m_NoMasterFlagIndex;
    int m_AttackWallSpecial;    // UɂǔjSpecial̃CfbNXB
    int m_HeroCount;            // lނ̑Blޑ{̊mvZɎgpB

    std::pair<int, int> m_FieldMapSize;
    std::string m_FieldMapFile;

    std::string m_PowerMapFile;

    std::string m_MoneyUnit;

    std::vector<std::string> m_CommonMusicList;

    bool LoadRace(const std::string& filename);
    bool LoadAttribute(const std::string& filename);
    bool LoadMagicTable(const std::string& filename);
    bool LoadMagicGroup(const std::string& filename);
    bool LoadSpecialTable(const std::string& filename, int dirno);
    bool LoadMapChipType(const std::string& filename);
    bool LoadMoveAndSkill(const std::string& filename);
    bool LoadRevive(const std::string& filename);
    static bool LoadIntArrayTxt(const std::string& filename, std::vector<int>& array);
    bool LoadMapObjTxt(const std::string& filename);
    bool LoadMapChipTxt(const std::string& filename);
    bool LoadMasterData(const std::string& filename);
    bool LoadCharacterData(const std::string& filename, int dirno);
    bool LoadPowerMap(const std::string& filename);
    bool LoadFieldMap(const std::string& filename);
    bool LoadNamedType(const std::string& filename, TNamedTypeList& l);
    bool ResolveMagic();
    bool ResolveCharacterID();
    static int GetNamedTypeIndex(const std::string& id, const TNamedTypeList& l);
public:
    TOpenFarenData();
    bool Load(const std::string& dir, int chapindex);

    // 푰
    int GetRaceIndex(const std::string& id) const;
    //const std::string& GetRaceName(int index) const { return m_RaceList[index].m_name; }
    const TRace& GetRace(int index) const { return m_RaceList[index]; }
    int GetRaceCount() const { return m_RaceList.size(); }

    // 
    int GetAttributeIndex(const std::string& id) const;
    int GetAttributeCount() const { return m_AttributeList.size(); }
    //const std::string& GetAttributeName(int index) const { return m_AttributeList[index].m_name; }
    const TAttribute& GetAttribute(int index) const { return m_AttributeList[index]; }

    // n`
    int GetMapGroundCount() const { return m_MapGroundList.size(); }
    const std::string& GetMapGroundName(int index) const { return m_MapGroundList[index]; }
    int GetMapObjectCount() const { return m_MapObjectList.size(); }
    const std::string& GetMapObjectName(int index) const { return m_MapObjectList[index]; }

    int GetMapObjType(int chipindex) const { return m_MapObjList.at(chipindex); }
    int GetMapChipType(int chipindex) const { return m_MapChipList.at(chipindex); }

    // ړ^Cv
    int GetMoveTypeIndex(const std::string& id) const;
    int GetMoveTypeCount() const { return m_MoveTypeList.size(); }
    const TMoveType& GetMoveType(int index) const { return m_MoveTypeList[index]; }

    // 
    int GetReviveIndex(const std::string& id) const;
    const TRevive& GetRevive(int index) const { return m_ReviveList[index]; }

    // @
    int GetMagicGroupIndex(const std::string& id) const;
    int GetMagicGroupCount() const { return m_MagicGroupList.size(); }
    //const std::string&  GetMagicGroupName(int index) const { return m_MagicGroupList[index].m_name; }
    const TMagicGroup&  GetMagicGroup(int index) const { return m_MagicGroupList[index]; }
    //int GetMagicDataIndex(const std::string& id) const;
    int GetMagicDataCount() const { return m_MagicDataList.size(); }
    const TMagicData& GetMagicData(int index) const { return m_MagicDataList[index]; }

    // KEZ
    int GetSpecialIndex(const std::string& id) const;
    int GetSpecialCount() const { return m_SpecialList.size(); }
    void SetSpecialImage(int index, int img) { m_SpecialList[index].m_image = img; }
    void SetSpecialChunk(int index, int chunk) { m_SpecialList[index].m_sound = chunk; }
    const TSpecial& GetSpecial(int index) const { return m_SpecialList[index]; }

    int GetAttackWallSpecial() const { return m_AttackWallSpecial; }

    // }X^[
    int GetMasterIndex(const std::string& id) const;
    int GetMasterCount() const { return m_MasterList.size(); }
    TMaster& GetMaster(int index) { return m_MasterList[index]; }
    const TMaster& GetMaster(int index) const { return m_MasterList[index]; }
    void SetMasterMusic(int index, int music, int battlemusic, int masterbattlemusic);

    // LN^[
    int GetCharacterCount() const { return m_CharaList.size(); }
    //TBattleCharacter& GetCharacter(int index) { return m_CharaList[index]; }    // 摜CfbNXXV̂߂ɕKvB
    const TBattleCharacter& GetCharacter(int index) const { return m_CharaList[index]; }
    int GetCharacterIndex(const std::string& id) const;
    void SetCharacterImage(int index, int faceindex, int chipindex);

    // ʉݒP
    const std::string& GetMoneyUnit() const { return m_MoneyUnit; }

    // ͐}
    int GetPowerMapPointIndex(const std::string& id) const;
    const TPowerMapPoint& GetPowerMapPoint(int index) const { return m_PowerMapPointList[index]; }
    const std::string& GetPowerMapFile() const { return m_PowerMapFile; }

    // lޑ
    int GetHeroCount() const { return m_HeroCount; }

    int GetCharacterDirCount() const { return m_CharaDirList.size(); }
    const std::string& GetCharacterDir(int index) const { return m_CharaDirList[index]; }

    void SetNoMasterFlagIndex(int i) { m_NoMasterFlagIndex = i; }
    int GetNoMasterFlagIndex() const { return m_NoMasterFlagIndex; }

    // ViIJn
    const TFarenChapter& GetChapter() const { return m_Chapter; }

    const std::string& GetSystemEffectName(TSystemEffect se) const;
    const std::string& GetScenarioTitle() const { return m_ScenarioTitle; }

    void GetFieldMapSize(int *w, int *h) const { *w = m_FieldMapSize.first; *h = m_FieldMapSize.second; }
    const std::string& GetFieldMapFile() const { return m_FieldMapFile; }

    const std::string&  GetCommonMusicFile(int index) { return m_CommonMusicList[index]; }
};
//---------------------------------------------------------------------------
#endif
