//---------------------------------------------------------------------------
#ifndef ofgameH
#define ofgameH

#include <vector>
#include <set>
#include <string>
#include <boost/shared_ptr.hpp>
//#include <boost/tuple/tuple.hpp>
#include <tinyxml.h>
#include "oftypes.h"
#include "ofdata.h"
//---------------------------------------------------------------------------
enum TAreaOperation
{
    AREAOPE_TRAINING,
    AREAOPE_SEARCHHERO,
    AREAOPE_BUILDCITY,
    AREAOPE_BUILDWALL,
    AREAOPE_BUILDROAD,
    AREAOPE_MAX
};
//---------------------------------------------------------------------------
// 퓬̏ԁiłȂǁjB
struct TSystemEffectStatus
{
    TSystemEffect m_type;   // TSystemEffect̒lB
    int m_tick;             // ԕt^̌oߎԁB
};
typedef std::vector<TSystemEffectStatus> TSystemEffectStatusList;
struct TSystemEffectLess{
    bool operator()(const TSystemEffectStatus& lhs, const TSystemEffectStatus& rhs){
        return lhs.m_type < rhs.m_type;
    }
};
/*struct TSystemEffectEqual{
    bool operator()(const TSystemEffectStatus& lhs, const TSystemEffectStatus& rhs){
        return lhs.m_type == rhs.m_type;
    }
};*/
//---------------------------------------------------------------------------
struct TCharacterInstance
{
    int m_type; // TBattleCharacter̃CfbNX
    int m_rank;
    int m_experience;
    // Nɂ␳̒lB
    int m_hpmax_rank;   // HP/MP͑Ȃ̂ŕsvȂ̂ԈčĂ܂ϐB
    int m_mpmax_rank;   // V
    int m_pa_rank;
    int m_pd_rank;
    int m_skill_rank;
    int m_speed_rank;
    int m_ma_rank;
    int m_md_rank;
    // @ɂăvXꂽlB
    int m_pa_plus;
    int m_pd_plus;
    int m_skill_plus;
    int m_speed_plus;
    int m_ma_plus;
    int m_md_plus;
    int m_hprecover_plus;
    int m_mprecover_plus;
    int m_attackcount_plus;
    int m_movable_plus;
    // 牺̓Q[ɒlB
    bool m_actioned;
    int m_hp;
    int m_mp;
    int m_brave;
    int m_power;        // \[ĝ߂ɐ͎wi[ĂB
    int m_wincount;     // j
    int m_dummy;        // 0ǂݏo߂̃_~[B
    // 牺̓Q[̐퓬̂ݒlB
    std::vector<TResistance> m_resistance;  // RBς邱Ƃ̂ŁB
    int m_movetype;                         // TOpenFarenData::m_MoveTypeList̃CfbNX
    point_t m_location;
    int m_showingindex; // 퓬̕\XvCg̃CfbNXB
    int m_actionpoint;  // 퓬̍s|CgB
    enum TElementStatus{
        ELEMENT_NONE,
        ELEMENT_SUMMON,     // 
        ELEMENT_SUMMONED,   // 폢
        ELEMENT_MAX
    }m_elementstatus;
    int m_elementindex; // Gg̏ꍇ͏ҁA҂̏ꍇ̓Gg̃CfbNXB
    bool m_runaway;     // ς݁B
    bool m_try_runaway; // BłƂ͌ȂB
    TSystemEffectStatusList m_seslist;  // 퓬̏ԁB
    std::vector<int> m_addstrspe;      // Ԃɒǉŕ\镶Special̃CfbNXB
    TCharacterInstance() :
        m_type(0), m_rank(0), m_experience(0),
        m_hpmax_rank(0), m_mpmax_rank(0),
        m_pa_rank(0), m_pd_rank(0), m_skill_rank(0), m_speed_rank(0), m_ma_rank(0), m_md_rank(0),
        m_pa_plus(0), m_pd_plus(0), m_skill_plus(0), m_speed_plus(0), m_ma_plus(0), m_md_plus(0),
        m_hprecover_plus(0), m_mprecover_plus(0), m_attackcount_plus(0), m_movable_plus(0),
        m_actioned(false),
        m_hp(0), m_mp(0),
        m_brave(100), m_power(0), m_wincount(0), m_dummy(0), m_movetype(-1), m_actionpoint(0),
        m_elementstatus(ELEMENT_NONE),
        m_runaway(false), m_try_runaway(false) {}
};
typedef std::vector<TCharacterInstance> TCharacterInstanceList;
//---------------------------------------------------------------------------
struct TMasterInstance
{
    int m_type;     // TMaster̃CfbNX
    bool m_exists;
    bool m_player;
    int m_income;
    int m_outgo;
    int m_money;
    //int m_wait;     // ̃^[܂ł̃JE^B
    int m_power;    // \[gE\̂߂ɐ͎wi[ĂB
    TMasterInstance() : m_type(0), m_exists(true), m_player(false), m_income(0), m_outgo(0), m_money(0) {}
};
typedef std::vector<TMasterInstance> TMasterInstanceList;
// ͎wstd::pair<int, int>\[g邽߂̔r֐IuWFNgBsecond͎wƂB
struct TMasterPowerLess
{
    bool operator()(const std::pair<int, int>& lhs, const std::pair<int, int>& rhs){
        return lhs.second < rhs.second;
    }
};
//---------------------------------------------------------------------------
class TBattleMap;

struct TAreaInstance
{
    std::string m_id;
    std::string m_name;
    int m_baseincome;
    int m_citymax;
    int m_wallmax;
    int m_roadmax;
    int m_city;
    int m_wall;
    int m_road;
    int m_wallini;      // ǂ̏[ij
    int m_inhabitcost;  // ͌ٗppij
    TAreaOperation m_operation;
    int m_operationeffort;  // ҋ@sslB
    point_t m_location;
    std::vector<std::string> m_neighborid;
    std::vector<int> m_neighbor;
    std::vector<int> m_inhabit;         // TBattleCharacter̃CfbNX
    std::vector<int> m_employable;      // TBattleCharacter̃CfbNX
    std::string m_musicfile;
    int m_music;
    int m_master;       // TOpenFarenGame::m_MasterInstanceList̃CfbNX
    bool m_ignore;      // gȂiʂɕ\ȂjGA
    int m_nameimage;
    TCharacterInstanceList m_charalist;
    std::vector<point_t> m_powermappoint;
    std::string m_bmapfile;
    boost::shared_ptr<TBattleMap> m_bmap;

    TAreaInstance() : m_baseincome(0), m_citymax(0), m_wallmax(0), m_roadmax(0), m_city(0), m_wall(0), m_road(0),
        m_wallini(0), m_inhabitcost(100), m_operation(AREAOPE_TRAINING), m_operationeffort(0), m_music(-1), m_master(-1),
        m_ignore(false), m_nameimage(-1) {}
};
typedef std::vector<TAreaInstance> TAreaInstanceList;
//---------------------------------------------------------------------------
struct TAlliance
{
    int master1, master2;
    int turn;
};
typedef std::vector<TAlliance> TAllianceList;
//---------------------------------------------------------------------------
class TOpenFarenGame// : public TStrategyInterface
{
public:
    TOpenFarenGame();
    bool LoadNew(const TOpenFarenData& data, const std::string& dir, int chapindex, int gamelevel);
    bool LoadSaved(const TOpenFarenData& data, const std::string& dir, int chapindex, const TiXmlElement& e);
    bool Save(TiXmlElement& e) const;
    void GetSaveTitleString(std::string& str) const;

    int GetAreaInstanceCount() const { return m_AreaInstanceList.size(); }
    int GetAreaInstanceIndex(const std::string& id) const;
    const TAreaInstance& GetAreaInstance(int i) const { return m_AreaInstanceList[i]; }
    TBattleMap* GetBattleMap(int i) { return m_AreaInstanceList[i].m_bmap.get(); }
    //TAreaInstance& GetAreaInstance(int i) { return m_AreaInstanceList[i]; }
    void SetAreaNameImage(int i, int imgnum) { m_AreaInstanceList[i].m_nameimage = imgnum; }
    void SetAreaOperation(int i, TAreaOperation ope) { m_AreaInstanceList[i].m_operation = ope; }
    void SetAreaMusic(int i, int m) { m_AreaInstanceList[i].m_music = m; }

    int GetMasterInstanceCount() const { return m_MasterInstanceList.size(); }
    const TMasterInstance& GetMasterInstance(int i) const { return m_MasterInstanceList[i]; }
    //TMasterInstance& GetMasterInstance(int i) { return m_MasterInstanceList[i]; }
    int GetMasterInstanceIndex(int mastertype) const;
    int GetMasterInstanceIndex(const std::string& id) const;

    int GetDeadCharaCount() const { return m_DeadCharaList.size(); }
    const TCharacterInstance& GetDeadChara(int index) const { return m_DeadCharaList[index]; }

    //int GetGameLevel() const { return m_GameLevel; }
    int GetCurrentMasterIndex() const { return m_CurrentMaster; }
    int GetComEmployCost(int charatype) const;
    void GetEmployable(int areaindex, int chrindex, std::vector<int>& employable) const;
    bool EmployCharacter(int areaindex, int chrindex, int employtype);
    bool DismissCharacter(int areaindex, int chrindex);
    bool MoveCharacter(int area_from, int area_to, const std::vector<int>& indice);
    bool MoveCharacter(int area1, int area2, const std::vector<int>& indice1to2, const std::vector<int>& indice2to1);
    void SetAreaNoMaster(int masterindex);
    void SetMasterPlayer(int mastertype, bool isPlayer);
    TCharacterInstance CreateCharaInstance(int ctype, int rank) const;
    void UpdateCharaRank(TCharacterInstance& c) const;
    bool CheckRankup(TCharacterInstance& c) const;
    int EvalCharaPower(const TCharacterInstance& c) const;
    int GetAreaIncome(int areaindex) const;
    int GetAreaPower(int ai) const;
    int GetMasterBaseArea(int masterindex) const;
    bool FindCharaExistsArea(int masterindex, int charatype, int& areaindex, int& charaindex) const;
    int GetMasterAreaCount(int masterindex) const;
    int GetMasterHeroCount(int masterindex) const;
    int GetMasterPower(int masterindex) const;
    int FindCharaInsertableArea(int masterindex, bool force) const;
    void InsertChara(int areaindex, int charatype);
    void RemoveChara(int areaindex, int charaindex);
    int GetTurn() const { return m_Turn; }
    int GetProgressedTurn() const { return m_ProgressedTurn; }
    int GetChapterNumber() const { return m_ChapterNumber; }
    void UpdateMasterPower();
    void UpdateMasterIncome();
    void UpdateMasterExists();
    void StartEnding();
    int FindAlliance(int master1, int master2) const;
    const TAlliance& GetAlliance(int index) const;
    void SetAlliance(int master1, int master2, int turn);
    void RemoveAlliance(int index);
    int EvalAllianceCost(int masterindex1, int masterindex2, int turn) const;
    void ConcludeAlliance(int master1, int master2, int turn, int cost);
    //bool ProposeAlliance(int masterindex, int turn);
    //bool GetProposedAlliance(int& masterindex, int& turn) const;
    //void PopProposedAlliance();
    void OrderMaster();
    bool ActivateNextMaster();
    void SortAreaCharacter(const std::set<int>& arealist);
    void SortAreaCharacter(int areaindex);
    void ApplyCharaAfterBattle(TCharacterInstance& chara_area, const TCharacterInstance& chara_bt) const;
    void MoveCharaAfterBattleDepWin(const std::vector<std::pair<int, int> >& indexlist, const TCharacterInstanceList& depcharalist, const TCharacterInstanceList& savcharalist, TCharacterInstanceList& savrestlist, int areaindex, int depmaster, bool depwin);
    void MoveCharaAfterNoBattle(const std::vector<std::pair<int, int> >& indexlist, int areaindex, int depmaster);
    //void WanderAfterWar(int masterindex, const TCharacterInstanceList& herolist);
    void AddWanderChara(const TCharacterInstance& hero);
    bool IsDepaturableArea(int areaindex) const;
    int GetRunnableArea(int areaindex, std::vector<int>& areaindexlist, std::vector<int>& runable) const;
    void ChangeMasterType(int masterindex, int mastertype, int usecharatype);
    void JudgeLostMaster(std::vector<int>& lostmaster) const;
    bool JudgePlayerGameOver() const;
    bool JudgeOvercome() const;
    void PlaceAllAreaCharaRandom();
    bool PopFoundWanderingChara(int& areaindex, int& charatype);
    bool JudgeEmployWanderingChara(int masterindex, int charatype) const;
    bool EmployWanderingChara(int areaindex, int charatype);
    TCharacterInstance GetWanderingChara(int charatype) const;
    bool CharaAppeared(int charatype) const;
    void UpdateWanderingHero();
    void UpdateAreaAndBMapAfterBattle(int areaindex);
    void PlusLey(int master, int ley);
    int GetAreaCity(int areaindex) const;
    void SetAreaCity(int areaindex, int city);
    int GetAreaWall(int areaindex) const;
    void SetAreaWall(int areaindex, int wall);
    int GetAreaRoad(int areaindex) const;
    void SetAreaRoad(int areaindex, int road);
    bool GetChampion(int num, std::string& champid) const;
    bool IsEnding() const { return m_IsEnding; };

    static const int AREACHARA_MAX = 20;
    static const int EXPERIENCE_MAX = 100;
    static const int RANK_MAX = 5;              // E0AS5
    static const int GAMELEVEL_MAX = 5;
    static const int DEFAULT_ALLIANCETURN = 6;
    static const char *AreaOperationName[AREAOPE_MAX];
private:
    // 񉻂ԁB
    TAreaInstanceList m_AreaInstanceList;
    TMasterInstanceList m_MasterInstanceList;
    TAllianceList m_AllianceList;

    // SLXgBNX`FWlƐlޑSĂɐ^StO蓖Ă̂͌IłȂ߁B
    TCharacterInstanceList m_DeadCharaList;

    // QLXgBNȂǂێ邽߃CX^X̃XgB
    TCharacterInstanceList m_WanderingCharaList;

    // ݂̃}X^[̐lޑ{ɂLBfirst=GAԍAsecond=LށB
    std::vector<std::pair<int, int> > m_FoundWanderingCharaList;

    // first=m_MasterInstanceList̃CfbNXAsecond=͎wB
    std::vector<std::pair<int, int> > m_MasterOrder;
    int m_MasterOrderIndex;
    int m_GameLevel;
    int m_Turn;
    int m_ProgressedTurn;
    int m_ChapterNumber;

    // ȉ͒񉻂ȂԁB
    int m_CurrentMaster;
    bool m_IsEnding;
    // \܂ꂽ̃XgBvf͐\ݑ}X^[ԍA}X^[ԍA^[B
    //typedef std::vector<boost::tuple<int, int, int> > TProposedAllianceList;
    //TProposedAllianceList m_ProposedAllianceList;

    // LoadNewGame / LoadSavedGameŒlB
    const TOpenFarenData* m_Data;

    void SaveAreaInstance(TiXmlElement& e) const;
    bool LoadAreaInstance(const TiXmlElement& top);
    bool LoadParmanentData(const std::string& dir);
    void PlaceAreaCharaRandom(int areaindex);
    void RemoveExpiredAlliance();
    bool ExistsConstantEnemyMaster(int master) const;
    bool IsBaseArea(int areaindex) const;
    int MoveCharaToNeighbor(TAreaInstance& area, int masterindex, const TCharacterInstance& chara);
    void ApplyAdministration();
    void CheckSearchHero();
    int FindCharaInstance(const TCharacterInstanceList& clist, int ctype) const;
};
//---------------------------------------------------------------------------
#endif
