//---------------------------------------------------------------------------
#ifndef fluaH
#define fluaH

#include "battleif.h"
extern "C"
{
#include <lua.h>
}

class TScriptAPI;
class TWorldMapLogic;
//---------------------------------------------------------------------------
class TOpenFarenLuaManager
{
private:
    //TStrategyInterface *m_StrategyIf;
    TBattleInterface *m_BattleIf;
    lua_State *m_L;
    bool m_CanResume;
    bool m_LastFunctionValue;
    int m_BattleMaster;
    TScriptAPI *m_ScriptAPI;
    TWorldMapLogic *m_WorldMapLogic;
public:
    TOpenFarenLuaManager();
    virtual ~TOpenFarenLuaManager(void);
    //void SetIf(TStrategyInterface *si, TBattleInterface *gi);
    void SetIf(TBattleInterface *gi, TScriptAPI *sapi, TWorldMapLogic *worldlogic);
    bool LoadLua(const char *lua_file);
    bool CallFunction(const char *funcname);
    bool CallFunction(const char *funcname, const std::vector<std::string>& args);
    bool CanResume(void) const;
    bool Resume(void);
    bool GetLastFunctionValue(void) const { return m_LastFunctionValue; }
    void SaveToXML(TiXmlElement& e) const;
    bool LoadFromXML(const TiXmlElement& e);
    void SetBattleMasterIndex(int index);
    void RegistInitVariable();
};
//---------------------------------------------------------------------------
#endif
