//---------------------------------------------------------------------------
#ifndef ofmixerH
#define ofmixerH

#include <SDL_mixer.h>
#include <vector>
#include <string>
#include <map>
//---------------------------------------------------------------------------
// ̃NXSDL_mixeȑƏI͂ȂBf[^̃ReiƍĐ~API񋟂B
class TOpenFarenMixer
{
public:
    enum TPermanentChunk{
        CHUNK_DEPARTURE,
        CHUNK_ATTACK,
        CHUNK_DEAD,
        CHUNK_MAX
    };
    enum TPermanentMusic{
        MUSIC_EVENT,
        MUSIC_DECISIVE,
        MUSIC_MAX
    };

    TOpenFarenMixer(bool enabled);
    ~TOpenFarenMixer();
    //void SetDirectory(const std::string& dir) { m_BaseDir = dir; };
    int LoadChunk(const std::string& filepath);
    int LoadMusic(const std::string& filepath);
    void PlayChunk(int index) const;
    void PlayMusic(int index) const;
    void PlayMusicWithFadeout(int index, int msec = 500) const;
    void FadeOutMusic(int msec = 500) const;
    bool LoadPermanentChunk(TPermanentChunk index, const std::string& filepath);
    void PlayPermanentChunk(TPermanentChunk index) const;
    bool LoadPermanentMusic(TPermanentMusic index, const std::string& filepath);
    void PlayPermanentMusic(TPermanentMusic index) const;
    void PlayPermanentMusicWithFadeout(TPermanentMusic index, int msec = 500) const;
    bool IsPlayingMusic() const;
private:
    bool m_Enabled;
    std::vector<Mix_Chunk*> m_ChunkList;
    std::vector<Mix_Music*> m_MusicList;
    std::map<std::string, int> m_LoadedMusic;
    //std::string m_BaseDir;  // tH_̃tpXBႦDefaultȂScenario/Default/SoundAndMusic̃tpXB
    int m_PermanentChunk[CHUNK_MAX];  // ʌʉ̃CfbNXB
    int m_PermanentMusic[MUSIC_MAX];  // MUSIC̃CfbNXB
};
//---------------------------------------------------------------------------
#endif
