#if !defined(oftypesH)
#define oftypesH

#include <functional>
#include <vector>
#include <algorithm>
#include <boost/operators.hpp>
//---------------------------------------------------------------------------
struct point_t : private boost::operators<point_t>
{
    int x;
    int y;
    point_t() : x(0), y(0) {}
    point_t(int xsrc, int ysrc) : x(xsrc), y(ysrc) {}
    bool operator==(const point_t& p) const{
        return x == p.x && y == p.y;
    }
};

struct TPointLess{
    bool operator()(const point_t& lhs, const point_t& rhs) const {
        return ((lhs.y<<16) | lhs.x) < ((rhs.y<<16) | rhs.x);
    }
};
//---------------------------------------------------------------------------
// m_idƂoĂIuWFNgstd::sortŃ\[g
// std::lower_boundŌ鎞̔r֐IuWFNgB
template<typename T>
struct TIDHolderLess
{
    bool operator()(const T& lhs, const T& rhs){
        return lhs.m_id < rhs.m_id;
    }
};
//---------------------------------------------------------------------------
// \[gꂽstd::vectot<T>T::m_ididɓvfTẴCfbNXԂB
template<typename T>
int FindFromSorted(const std::vector<T>& v, const std::string& id)
{
    T key;
    key.m_id = id;
    typename std::vector<T>::const_iterator itr = std::lower_bound(v.begin(), v.end(), key, TIDHolderLess<T>());
    if(itr != v.end() && itr->m_id == id){
        return std::distance(v.begin(), itr);
    }
    return -1;
}
//---------------------------------------------------------------------------
template<typename T>
int FindFromNotSorted(const std::vector<T>& v, const std::string& id)
{
    T key;
    key.m_id = id;
    typename std::vector<T>::const_iterator itr = std::find(v.begin(), v.end(), key);
    if(itr != v.end()){
        return std::distance(v.begin(), itr);
    }
    return -1;
}
//---------------------------------------------------------------------------
// C++Wɖ̂ŎdȂB
template <class T>
struct Select1st : public std::unary_function<T, typename T::first_type>
{
    const typename T::first_type& operator() (const T& x) const {
        return x.first;
    }
};

template <class T>
struct Select2nd : public std::unary_function<T, typename T::second_type>
{
    const typename T::second_type& operator() (const T& x) const {
        return x.second;
    }
};
//---------------------------------------------------------------------------
#endif
