//---------------------------------------------------------------------------
#include "saveloaddlg.h"
#include "ofini.h"
#include "boostformat.h"
#include "gamemaster.h"
#include "gcnskinmanager.h"
//---------------------------------------------------------------------------
std::string TSaveListModel::getElementAt(int i)
{
    // ̂getNumberOfElements()ŕԂlȏi邱Ƃ̂ŃK[hB
    if(i < m_SaveList.size()){
        return (boost::format("%d %s") % i % m_SaveList[i]).str();
    }
    return "";
}
//---------------------------------------------------------------------------
TSaveLoadPane::TSaveLoadPane()
{
    const TGcnSkinManager *skinmng = g_GameMaster.GetSkinManager();

    const int scrollbarw = g_Ini.GetIntValue(TOpenFarenIni::SCROLLBAR_WIDTH);
    // gcn::ListBox̃TCYsetListModelIɌ܂悤Ȃ̂ŎwȂB
    m_SaveListBox.setPosition(0, 0);
    m_SaveListBox.setListModel(&m_SaveListModel);
    //m_SaveListBox.addActionListener(this);
    skinmng->ApplyListBoxSkin(&m_SaveListBox);
    m_ScrollArea.setPosition(MARGIN_X, 4);
    m_ScrollArea.setScrollbarWidth(scrollbarw);
    m_ScrollArea.setContent(&m_SaveListBox);
    //m_ScrollArea.setBackgroundColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_LISTBOXBGCOLOR));
    m_ScrollArea.setBackgroundColor(skinmng->GetSkin()->GetColorValue(TOpenFarenSkin::SKINCOLOR_LISTBOXBGCOLOR));
    add(&m_ScrollArea);

    m_ButtonSaveLoad.setSize(56, 24);
    m_ButtonSaveLoad.setPosition(WIDTH/2 - 76, 168);
    skinmng->ApplyButtonEnabled(&m_ButtonSaveLoad);
    add(&m_ButtonSaveLoad);

    m_ButtonCancel.setCaption("");
    m_ButtonCancel.setSize(56, 24);
    m_ButtonCancel.setPosition(WIDTH/2 + 20, 168);
    skinmng->ApplyButtonEnabled(&m_ButtonCancel);
    add(&m_ButtonCancel);

    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    skinmng->ApplyGrayPaneSkin(this);

    setSize(WIDTH, 196);
}
//---------------------------------------------------------------------------
TSaveLoadPane::~TSaveLoadPane()
{
}
//---------------------------------------------------------------------------
void TSaveLoadPane::SetMode(bool isSave)
{
    m_ButtonSaveLoad.setCaption(isSave ? "ۑ" : "Ǎ");
}
//---------------------------------------------------------------------------
void TSaveLoadPane::UpdateContent()
{
    const int scrollbarw = g_Ini.GetIntValue(TOpenFarenIni::SCROLLBAR_WIDTH);
    const int savew = WIDTH - MARGIN_X*2;
    const int scrollh = 168;
    int needh = m_SaveListModel.GetNeedHeight();
    if(needh <= scrollh){
        m_SaveListBox.setWidth(savew);
        m_ScrollArea.setSize(savew, needh);
    }
    else{
        m_SaveListBox.setWidth(savew - scrollbarw);
        m_ScrollArea.setSize(savew, scrollh);
    }
}
//---------------------------------------------------------------------------
TSaveLoadWindow::TSaveLoadWindow()
{
    add(&m_SaveLoadPane);
    m_SaveLoadPane.GetButtonSaveLoad().addActionListener(this);
    m_SaveLoadPane.GetButtonCancel().addActionListener(this);
    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    g_GameMaster.GetSkinManager()->ApplyWindowSkin(this);
    setOpaque(false);
    resizeToContent();
}
//---------------------------------------------------------------------------
TSaveLoadWindow::~TSaveLoadWindow()
{
}
//---------------------------------------------------------------------------
void TSaveLoadWindow::action(const gcn::ActionEvent& actionEvent)
{
    if(actionEvent.getSource() == &m_SaveLoadPane.GetButtonSaveLoad()){
        int num = m_SaveLoadPane.GetSelected();
        if(num >= 0){
            if(m_IsSave){
                g_GameMaster.SaveGame(num);
            }
            else{
                g_GameMaster.LoadGame(num);
            }
            //g_GameMaster.SetSaveLoadVisible(false, false);
            g_GameMaster.HideSaveLoad();
        }
    }
    else if(actionEvent.getSource() == &m_SaveLoadPane.GetButtonCancel()){
        g_GameMaster.HideSaveLoad();
        //g_GameMaster.SetSaveLoadVisible(false, false);
        //setVisible(false);
    }
}
//---------------------------------------------------------------------------
void TSaveLoadWindow::SetMode(bool isSave, const std::vector<std::string>& lst)
{
    m_IsSave = isSave;
    m_SaveLoadPane.SetMode(isSave);
    m_SaveLoadPane.SetList(lst);
    m_SaveLoadPane.UpdateContent();
}
//---------------------------------------------------------------------------
