//---------------------------------------------------------------------------
#ifndef saveloaddlgH
#define saveloaddlgH

#include <guichan.hpp>
#include <vector>
#include <string>
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TSaveListModel : public gcn::ListModel
{
private:
    std::vector<std::string> m_SaveList;

    static const int ROW_HEIGHT = 16;
public:
    TSaveListModel() {}
    virtual ~TSaveListModel() {}
    virtual std::string getElementAt(int i);
    virtual int getNumberOfElements() { return m_SaveList.size(); }
    void SetList(const std::vector<std::string>& lst) { m_SaveList = lst; }
    int GetNeedHeight() const { return m_SaveList.size()*ROW_HEIGHT; }
};
//---------------------------------------------------------------------------
class TSaveLoadPane : public gcn::Container
{
private:
    TSaveListModel m_SaveListModel;
    gcn::ListBox m_SaveListBox;
    gcn::ScrollArea m_ScrollArea;
    gcn::Button m_ButtonSaveLoad;
    gcn::Button m_ButtonCancel;

    static const int WIDTH = 720;
    static const int MARGIN_X = 4;
public:
    TSaveLoadPane();
    virtual ~TSaveLoadPane();
    gcn::Button& GetButtonSaveLoad() { return m_ButtonSaveLoad; }
    gcn::Button& GetButtonCancel() { return m_ButtonCancel; }
    void SetMode(bool isSave);
    void SetList(const std::vector<std::string>& lst) { m_SaveListModel.SetList(lst); }
    int GetSelected() const { return m_SaveListBox.getSelected(); }
    void UpdateContent();
};
//---------------------------------------------------------------------------
class TSaveLoadWindow : public TGcnWindow, gcn::ActionListener
{
private:
    TSaveLoadPane m_SaveLoadPane;
    bool m_IsSave;
public:
    TSaveLoadWindow();
    virtual ~TSaveLoadWindow();
    virtual void action(const gcn::ActionEvent& actionEvent);
    void SetMode(bool isSave, const std::vector<std::string>& lst);
//    void SetMode(bool isSave) { m_SaveLoadPane.SetMode(isSave); }
//    void SetList(const std::vector<std::string>& lst) { m_SaveLoadPane.SetList(lst); }
};
//---------------------------------------------------------------------------
#endif
