//---------------------------------------------------------------------------
#ifndef scenarioselectH
#define scenarioselectH

#include <string>
#include <vector>
#include <guichan.hpp>
#include "scenario.h"
#include "textpane.h"
#include "gcnwindow.h"
//---------------------------------------------------------------------------
class TSceSelectListModel : public gcn::ListModel
{
public:
    TSceSelectListModel();
    virtual ~TSceSelectListModel() {}
    virtual std::string getElementAt(int i);
    virtual int getNumberOfElements();
    void SetSceList(std::vector<TFarenScenario>* lst) { m_SceList = lst; }
private:
    std::vector<TFarenScenario> *m_SceList;
};
//---------------------------------------------------------------------------
class TChapterSelectListModel : public gcn::ListModel
{
public:
    TChapterSelectListModel();
    virtual ~TChapterSelectListModel() {}
    virtual std::string getElementAt(int i);
    virtual int getNumberOfElements();
    void SetSce(TFarenScenario* sce) { m_Sce = sce; }
private:
    TFarenScenario *m_Sce;
};
//---------------------------------------------------------------------------
class TSceSelectPane : public gcn::Container, public gcn::ActionListener
{
public:
    TSceSelectPane();
    virtual ~TSceSelectPane();
    void Init();
    int GetSelectedLevel() const;
    virtual void action(const gcn::ActionEvent& actionEvent);
    virtual void draw(gcn::Graphics *g);
private:
    gcn::Button m_ButtonOk;
    gcn::Button m_ButtonCancel;
    TGcnTextPane m_TextExplanation;
    std::vector<gcn::RadioButton*> m_RadioButtonList;
    std::vector<TFarenScenario> m_SceList;
    std::vector<std::string> m_SceDirList;

    TSceSelectListModel m_SceSelectListModel;
    TChapterSelectListModel m_ChapterSelectListModel;
    gcn::ListBox m_SceSelectListBox;
    gcn::ListBox m_ChapterSelectListBox;
    gcn::ScrollArea m_SceSelectScrollArea;

    void ClearChaptorSelection();
};
//---------------------------------------------------------------------------
class TSceSelectWindow : public TGcnWindow
{
public:
    TSceSelectWindow();
    virtual ~TSceSelectWindow() {}
    void Init() { m_Pane.Init(); }
    int GetSelectedLevel() const { return m_Pane.GetSelectedLevel(); }
private:
    TSceSelectPane m_Pane;
};
//---------------------------------------------------------------------------
#endif
