//---------------------------------------------------------------------------
#include "sysmenu.h"
#include "ofini.h"
#include "gamemaster.h"
#include "drawutil.h"
#include "gcnskinmanager.h"
#include "boostformat.h"
#include "logger.h"

#define MAX(a, b) ((a) < (b) ? (b) : (a))
#define MIN(a, b) ((a) > (b) ? (b) : (a))
//---------------------------------------------------------------------------
TStartMenuPane::TStartMenuPane()
{
    m_ButtonNew.setCaption("VKQ[");
    m_ButtonNew.setSize(96, 24);
    m_ButtonNew.setPosition(8, 8);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonNew);
    add(&m_ButtonNew);

    m_ButtonLoad.setCaption("");
    m_ButtonLoad.setSize(96, 24);
    m_ButtonLoad.setPosition(8, 40);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonLoad);
    add(&m_ButtonLoad);

    m_ButtonConfig.setCaption("ݒ");
    m_ButtonConfig.setSize(96, 24);
    m_ButtonConfig.setPosition(8, 72);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonConfig);
    add(&m_ButtonConfig);

    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    g_GameMaster.GetSkinManager()->ApplyGrayPaneSkin(this);
    setSize(112, 102);
}
//---------------------------------------------------------------------------
TStartMenuPane::~TStartMenuPane()
{
}
//---------------------------------------------------------------------------
TStartMenuWindow::TStartMenuWindow()
{
    add(&m_StartMenuPane);
    m_StartMenuPane.GetButtonNew().addActionListener(this);
    m_StartMenuPane.GetButtonLoad().addActionListener(this);
    m_StartMenuPane.GetButtonConfig().addActionListener(this);
    setOpaque(false);
    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    g_GameMaster.GetSkinManager()->ApplyWindowSkin(this);
    resizeToContent();
}
//---------------------------------------------------------------------------
TStartMenuWindow::~TStartMenuWindow()
{
}
//---------------------------------------------------------------------------
void TStartMenuWindow::action(const gcn::ActionEvent& actionEvent)
{
    if(actionEvent.getSource() == &m_StartMenuPane.GetButtonNew()){
        g_GameMaster.SetSceSelectVisible(true);
        setVisible(false);
    }
    else if(actionEvent.getSource() == &m_StartMenuPane.GetButtonLoad()){
        g_GameMaster.ShowSaveLoad(false);
        setVisible(false);
    }
    else if(actionEvent.getSource() == &m_StartMenuPane.GetButtonConfig()){
        g_GameMaster.ShowConfig();
        setVisible(false);
    }
}
//---------------------------------------------------------------------------
TConfigWindowPane::TConfigWindowPane() :
    m_LabelGuidance("EBhETCY͍ċNɗLɂȂ܂B")
{
    m_LabelGuidance.setSize(400, 24);
    m_LabelGuidance.setPosition(4, 4);
    m_LabelGuidance.setForegroundColor(gcn::Color(255,255,255));
    add(&m_LabelGuidance);

    m_ButtonWidthDec.setCaption("-");
    m_ButtonWidthDec.setSize(24, 24);
    m_ButtonWidthDec.setPosition(8, 32);
    m_ButtonWidthDec.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonWidthDec);
    add(&m_ButtonWidthDec);

    m_ButtonWidthInc.setCaption("+");
    m_ButtonWidthInc.setSize(24, 24);
    m_ButtonWidthInc.setPosition(240, 32);
    m_ButtonWidthInc.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonWidthInc);
    add(&m_ButtonWidthInc);

    m_ButtonW800.setCaption("800");
    m_ButtonW800.setSize(48, 24);
    m_ButtonW800.setPosition(56, 32);
    m_ButtonW800.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonW800);
    add(&m_ButtonW800);

    m_ButtonW1024.setCaption("1024");
    m_ButtonW1024.setSize(48, 24);
    m_ButtonW1024.setPosition(112, 32);
    m_ButtonW1024.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonW1024);
    add(&m_ButtonW1024);

    m_ButtonW1280.setCaption("1280");
    m_ButtonW1280.setSize(48, 24);
    m_ButtonW1280.setPosition(168, 32);
    m_ButtonW1280.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonW1280);
    add(&m_ButtonW1280);

    m_ButtonHeightDec.setCaption("-");
    m_ButtonHeightDec.setSize(24, 24);
    m_ButtonHeightDec.setPosition(272, 64);
    m_ButtonHeightDec.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonHeightDec);
    add(&m_ButtonHeightDec);

    m_ButtonH640.setCaption("640");
    m_ButtonH640.setSize(48, 24);
    m_ButtonH640.setPosition(272, 112);
    m_ButtonH640.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonH640);
    add(&m_ButtonH640);

    m_ButtonH800.setCaption("800");
    m_ButtonH800.setSize(48, 24);
    m_ButtonH800.setPosition(272, 144);
    m_ButtonH800.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonH800);
    add(&m_ButtonH800);

    m_ButtonH1024.setCaption("1024");
    m_ButtonH1024.setSize(48, 24);
    m_ButtonH1024.setPosition(272, 176);
    m_ButtonH1024.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonH1024);
    add(&m_ButtonH1024);

    m_ButtonHeightInc.setCaption("+");
    m_ButtonHeightInc.setSize(24, 24);
    m_ButtonHeightInc.setPosition(272, 224);
    m_ButtonHeightInc.addActionListener(this);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonHeightInc);
    add(&m_ButtonHeightInc);

    m_CheckBoxDisableSwapInterval.setSize(256, 16);
    m_CheckBoxDisableSwapInterval.setPosition(4, 276);
    m_CheckBoxDisableSwapInterval.setCaption("҂ȂiONj");
    g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxDisableSwapInterval);
    add(&m_CheckBoxDisableSwapInterval);

    setSize(480, 320);
}
//---------------------------------------------------------------------------
TConfigWindowPane::~TConfigWindowPane()
{
}
//---------------------------------------------------------------------------
void TConfigWindowPane::draw(gcn::Graphics *g)
{
    const int LEFT = 8;
    const int TOP = 64;

    gcn::Container::draw(g);
    g->setColor(gcn::Color(0,0,0));
    g->fillRectangle(gcn::Rectangle(LEFT, TOP, 256, 204));

    g->setColor(gcn::Color(255,255,255));
    g_DrawUtil.DrawRectangle(g, gcn::Rectangle(LEFT + 2, TOP + 2, m_Width/8, m_Height/8));

    std::string str = (boost::format("%d x %d ") % m_Width % m_Height).str();
    g->drawText(str, LEFT + 8, TOP + 8);
}
//---------------------------------------------------------------------------
void TConfigWindowPane::action(const gcn::ActionEvent& actionEvent)
{
    const int MIN_W = 640;
    const int MIN_H = 640;
    const int MAX_W = 1920;
    const int MAX_H = 1600;

    gcn::Widget *src = actionEvent.getSource();
    if(src == &m_ButtonWidthDec){
        m_Width -= 16;
        if(m_Width < MIN_W){
            m_Width = MIN_W;
        }
    }
    else if(src == &m_ButtonWidthInc){
        m_Width += 16;
        if(m_Width > MAX_W){
            m_Width = MAX_W;
        }
    }
    else if(src == &m_ButtonW800){
        m_Width = 800;
    }
    else if(src == &m_ButtonW1024){
        m_Width = 1024;
    }
    else if(src == &m_ButtonW1280){
        m_Width = 1280;
    }
    else if(src == &m_ButtonHeightDec){
        m_Height -= 16;
        if(m_Height < MIN_H){
            m_Height = MIN_H;
        }
    }
    else if(src == &m_ButtonHeightInc){
        m_Height += 16;
        if(m_Height > MAX_H){
            m_Height = MAX_H;
        }
    }
    else if(src == &m_ButtonH640){
        m_Height = 640;
    }
    else if(src == &m_ButtonH800){
        m_Height = 800;
    }
    else if(src == &m_ButtonH1024){
        m_Height = 1024;
    }
}
//---------------------------------------------------------------------------
void TConfigWindowPane::InitUI()
{
    m_Width = g_Ini.GetIntValue(TOpenFarenIni::WINDOW_WIDTH);
    m_Height = g_Ini.GetIntValue(TOpenFarenIni::WINDOW_HEIGHT);
    m_CheckBoxDisableSwapInterval.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::WINDOW_DISABLESWAPINTERVAL));
}
//---------------------------------------------------------------------------
void TConfigWindowPane::UIToIni() const
{
    g_Ini.SetIntValue(TOpenFarenIni::WINDOW_WIDTH, m_Width);
    g_Ini.SetIntValue(TOpenFarenIni::WINDOW_HEIGHT, m_Height);
    g_Ini.SetBoolValue(TOpenFarenIni::WINDOW_DISABLESWAPINTERVAL, m_CheckBoxDisableSwapInterval.isSelected());
}
//---------------------------------------------------------------------------
TSelectPane::TSelectPane()
    : m_Selected(-1)
{
    addMouseListener(this);
}
//---------------------------------------------------------------------------
void TSelectPane::draw(gcn::Graphics *g)
{
    int h = getHeight();
    g->setColor(getBackgroundColor());
    gcn::Rectangle r(0, 0, getWidth()-1, h-1);
    g->fillRectangle(r);

    if(m_Items.empty()){
        return;
    }
    int cnt = m_Items.size();
    int itemw = getWidth() / cnt;
    if(m_Selected != -1){
        g->setColor(getSelectionColor());
        gcn::Rectangle sr(m_Selected * itemw, 0, itemw - 1, h - 1);
        g->fillRectangle(sr);
    }
    g->setColor(getForegroundColor());
    //g->drawRectangle(r);
    g_DrawUtil.DrawRectangle(g, r);
    int x = 0;
    int y = (h - 16) / 2;
    for(int i=0; i<cnt; ++i){
        g->drawText(m_Items[i], x + itemw / 2, y, gcn::Graphics::CENTER);
        x += itemw;
    }
    x = itemw - 1;
    for(int i=0; i<cnt-1; ++i){
        g->drawLine(x, 1, x, h-2);
        x += itemw;
    }
}
//---------------------------------------------------------------------------
void TSelectPane::mousePressed(gcn::MouseEvent &mouseEvent)
{
    if(m_Items.empty()){
        return;
    }
    if(mouseEvent.getButton() == gcn::MouseEvent::LEFT){
        m_Selected = mouseEvent.getX() / (getWidth() / m_Items.size());
    }
}
//---------------------------------------------------------------------------
void TSelectPane::ClearItem()
{
    m_Items.clear();
    m_Selected = -1;
}
//---------------------------------------------------------------------------
void TSelectPane::AddItem(const std::string& str)
{
    m_Items.push_back(str);
}
//---------------------------------------------------------------------------
int TSelectPane::GetSelected() const
{
    return m_Selected;
}
//---------------------------------------------------------------------------
void TSelectPane::SetSelected(int index)
{
    if(index >= 0 && index < m_Items.size()){
        m_Selected = index;
    }
}
//---------------------------------------------------------------------------
TConfigBattlePane::TConfigBattlePane() :
    m_LabelSpeed1("x@"),
    m_LabelSpeed2("x")
{
    const char *items[TFarenGameMaster::BATTLESPEED_MAX] = {"P", "Q", "R", "S", "T"};

    m_SelectPaneSpeed.setSize(256, 24);
    m_SelectPaneSpeed.setPosition(72, 8);
    m_SelectPaneSpeed.setBackgroundColor(gcn::Color(0, 0, 0, 0));
    m_SelectPaneSpeed.setForegroundColor(gcn::Color(255, 255, 255));
    m_SelectPaneSpeed.setSelectionColor(gcn::Color(255, 192, 0));
    for(int i=0; i < TFarenGameMaster::BATTLESPEED_MAX; ++i){
        m_SelectPaneSpeed.AddItem(items[i]);
    }
    add(&m_SelectPaneSpeed);

    m_LabelSpeed1.setSize(64, 24);
    m_LabelSpeed1.setPosition(4, 8);
    m_LabelSpeed1.setForegroundColor(gcn::Color(255,255,255));
    add(&m_LabelSpeed1);
    m_LabelSpeed2.setSize(16, 24);
    m_LabelSpeed2.setPosition(332, 8);
    m_LabelSpeed2.setForegroundColor(gcn::Color(255,255,255));
    add(&m_LabelSpeed2);

    m_CheckBoxWatch.setSize(256, 16);
    m_CheckBoxWatch.setPosition(4, 40);
    m_CheckBoxWatch.setCaption("ϐ킷");
    g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxWatch);
    m_CheckBoxWatch.addActionListener(this);
    add(&m_CheckBoxWatch);

    m_CheckBoxOnlyLarge.setSize(256, 16);
    m_CheckBoxOnlyLarge.setPosition(4, 64);
    m_CheckBoxOnlyLarge.setCaption("͂傫Ȏϐ");
    add(&m_CheckBoxOnlyLarge);

    m_CheckBoxOnlyMaster.setSize(320, 16);
    m_CheckBoxOnlyMaster.setPosition(4, 88);
    m_CheckBoxOnlyMaster.setCaption("}X^[QĂ鎞ϐ");
    add(&m_CheckBoxOnlyMaster);

    m_CheckBoxNoNeutral.setSize(256, 16);
    m_CheckBoxNoNeutral.setPosition(4, 112);
    m_CheckBoxNoNeutral.setCaption("RƂ̐킢͌Ȃ");
    add(&m_CheckBoxNoNeutral);

    m_CheckBoxMaxSpeed.setSize(256, 16);
    m_CheckBoxMaxSpeed.setPosition(4, 136);
    m_CheckBoxMaxSpeed.setCaption("ϐ펞͍ō");
    add(&m_CheckBoxMaxSpeed);

    setSize(400, 332);
}
//---------------------------------------------------------------------------
TConfigBattlePane::~TConfigBattlePane()
{
}
//---------------------------------------------------------------------------
void TConfigBattlePane::action(const gcn::ActionEvent& actionEvent)
{
    gcn::Widget *src = actionEvent.getSource();
    if(src == &m_CheckBoxWatch){
        UpdateUI();
    }
}
//---------------------------------------------------------------------------
void TConfigBattlePane::InitUI()
{
    int speed = g_Ini.GetIntValue(TOpenFarenIni::BATTLE_ANIMSPEED);
    m_SelectPaneSpeed.SetSelected(speed - 1);
    m_CheckBoxWatch.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::WATCH_USE));
    m_CheckBoxOnlyLarge.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::WATCH_ONLYLARGE));
    m_CheckBoxOnlyMaster.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::WATCH_ONLYMASTER));
    m_CheckBoxNoNeutral.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::WATCH_NONEUTRAL));
    m_CheckBoxMaxSpeed.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::WATCH_MAXSPEED));
    UpdateUI();
}
//---------------------------------------------------------------------------
void TConfigBattlePane::UIToIni() const
{
    g_Ini.SetIntValue(TOpenFarenIni::BATTLE_ANIMSPEED, m_SelectPaneSpeed.GetSelected() + 1);
    g_Ini.SetBoolValue(TOpenFarenIni::WATCH_USE, m_CheckBoxWatch.isSelected());
    g_Ini.SetBoolValue(TOpenFarenIni::WATCH_ONLYLARGE, m_CheckBoxOnlyLarge.isSelected());
    g_Ini.SetBoolValue(TOpenFarenIni::WATCH_ONLYMASTER, m_CheckBoxOnlyMaster.isSelected());
    g_Ini.SetBoolValue(TOpenFarenIni::WATCH_NONEUTRAL, m_CheckBoxNoNeutral.isSelected());
    g_Ini.SetBoolValue(TOpenFarenIni::WATCH_MAXSPEED, m_CheckBoxMaxSpeed.isSelected());
}
//---------------------------------------------------------------------------
void TConfigBattlePane::UpdateUI()
{
    if(m_CheckBoxWatch.isSelected()){
        g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxOnlyLarge);
        g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxOnlyMaster);
        g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxNoNeutral);
        g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxMaxSpeed);
    }
    else{
        g_GameMaster.GetSkinManager()->ApplyCheckBoxDisabled(&m_CheckBoxOnlyLarge);
        g_GameMaster.GetSkinManager()->ApplyCheckBoxDisabled(&m_CheckBoxOnlyMaster);
        g_GameMaster.GetSkinManager()->ApplyCheckBoxDisabled(&m_CheckBoxNoNeutral);
        g_GameMaster.GetSkinManager()->ApplyCheckBoxDisabled(&m_CheckBoxMaxSpeed);
    }
}
//---------------------------------------------------------------------------
void TColorPane::draw(gcn::Graphics *g)
{
    g->setColor(getForegroundColor());
    g->fillRectangle(getDimension());
    g->fillRectangle(gcn::Rectangle(0, 0, getWidth(), getHeight()));
}
//---------------------------------------------------------------------------
TShortcutListModel::TShortcutListModel()
{
}
//---------------------------------------------------------------------------
std::string TShortcutListModel::getElementAt(int i)
{
    static const char *elms[TOpenFarenIni::SHORTCUTVAL_MAX] = {"ҋ@", "ړ", "U", "ˌ", "Z", "@", ""};
    return elms[i];
}
//---------------------------------------------------------------------------
int TShortcutListModel::getNumberOfElements()
{
    return TOpenFarenIni::SHORTCUTVAL_MAX;
}
//---------------------------------------------------------------------------
TConfigShortcutPane::TConfigShortcutPane() :
    m_WaitKey(false)
{
    const TGcnSkinManager *skinmng = g_GameMaster.GetSkinManager();

    m_ShortcutListBox.setPosition(4, 4);
    m_ShortcutListBox.setSize(160, 240);
    m_ShortcutListBox.setListModel(&m_ShortcutListModel);
    m_ShortcutListBox.addActionListener(this);
    skinmng->ApplyListBoxSkin(&m_ShortcutListBox);
    add(&m_ShortcutListBox);

    m_ButtonChange.setCaption("ύX");
    m_ButtonChange.setSize(56, 24);
    m_ButtonChange.setPosition(168, 4);
    m_ButtonChange.addActionListener(this);
    skinmng->ApplyButtonEnabled(&m_ButtonChange);
    add(&m_ButtonChange);

    m_ButtonCancel.setCaption("");
    m_ButtonCancel.setSize(56, 24);
    m_ButtonCancel.setPosition(228, 4);
    m_ButtonCancel.addActionListener(this);
    skinmng->ApplyButtonDisabled(&m_ButtonCancel);
    add(&m_ButtonCancel);

    m_ColorPaneLabelBack.setSize(168, 24);
    m_ColorPaneLabelBack.setPosition(168, 32);
    m_ColorPaneLabelBack.setForegroundColor(gcn::Color(0,0,0));
    add(&m_ColorPaneLabelBack);

    m_Label.setSize(160, 24);
    m_Label.setPosition(172, 32);
    int sel = m_ShortcutListBox.getSelected();
    if(sel >= TOpenFarenIni::SHORTCUT_WAIT && sel < TOpenFarenIni::SHORTCUTVAL_MAX){
        SDLKey key = g_Ini.GetShortcutValue(static_cast<TOpenFarenIni::TShortcutValue>(sel));
        m_Label.setCaption(KeysymToString(key));
    }
    else{
        m_Label.setCaption("");
    }
    m_Label.setForegroundColor(gcn::Color(255,255,255));
    add(&m_Label);

    skinmng->ApplyGrayPaneSkin(this);
    setSize(400, 200);
}
//---------------------------------------------------------------------------
TConfigShortcutPane::~TConfigShortcutPane()
{
}
//---------------------------------------------------------------------------
void TConfigShortcutPane::action(const gcn::ActionEvent& actionEvent)
{
    gcn::Widget *src = actionEvent.getSource();
    if(src == &m_ShortcutListBox){
        int sel = m_ShortcutListBox.getSelected();
        if(sel >= TOpenFarenIni::SHORTCUT_WAIT && sel < TOpenFarenIni::SHORTCUTVAL_MAX){
            SDLKey key = g_Ini.GetShortcutValue(static_cast<TOpenFarenIni::TShortcutValue>(sel));
            m_Label.setCaption(KeysymToString(key));
        }
        else{
            m_Label.setCaption("");
        }
    }
    else if(src == &m_ButtonChange){
        m_Label.setCaption("L[ĉ");
        g_GameMaster.ClearKeyQueue();
        g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonCancel);
        m_WaitKey = true;
    }
    else if(src == &m_ButtonCancel){
        m_Label.setCaption("label");
        g_GameMaster.GetSkinManager()->ApplyButtonDisabled(&m_ButtonCancel);
        m_WaitKey = false;
    }
}
//---------------------------------------------------------------------------
void TConfigShortcutPane::logic()
{
    if(m_WaitKey){
        SDLKey key;
        if(g_GameMaster.GetKeyQueue(key)){
            g_GameMaster.PopKeyQueue();
            //g_GameMaster.SetKeyQueueEnabled(false);
            int sel = m_ShortcutListBox.getSelected();
            //g_Logger.DebugLog((boost::format("KEY=%d") % key).str());
            if(sel >= TOpenFarenIni::SHORTCUT_WAIT && sel < TOpenFarenIni::SHORTCUTVAL_MAX){
                m_Label.setCaption(KeysymToString(key));
                g_Ini.SetShortcutValue(static_cast<TOpenFarenIni::TShortcutValue>(sel), key);
            }
            g_GameMaster.GetSkinManager()->ApplyButtonDisabled(&m_ButtonCancel);
            m_WaitKey = false;
        }
    }
    gcn::Container::logic();
}
//---------------------------------------------------------------------------
std::string TConfigShortcutPane::KeysymToString(SDLKey key)
{
    if(key == SDLK_UNKNOWN){
        return "ݒ薳";
    }
    // At@xbg
    if(key >= SDLK_a && key <= SDLK_z){
        char str[2] = {0};
        str[0] = 'A' + key - SDLK_a;
        return str;
    }
    // eL[Ȃ̐
    if(key >= SDLK_0 && key <= SDLK_9){
        char str[2] = {0};
        str[0] = '0' + key - SDLK_0;
        return str;
    }
    // eL[̐
    if(key >= SDLK_KP0 && key <= SDLK_KP9){
        char str[5] = "KP 0";
        str[3] = '0' + key - SDLK_KP0;
        return str;
    }
    // F
    if(key >= SDLK_F1 && key <= SDLK_F15){
        return (boost::format("F%d") % (key - SDLK_F1 + 1)).str();
    }
    const int symscount = 57;
    SDLKey keysyms[symscount] = {
        SDLK_BACKSPACE,
        SDLK_TAB,
        SDLK_CLEAR,
        SDLK_RETURN,
        SDLK_PAUSE,
        SDLK_ESCAPE,
        SDLK_SPACE,
        SDLK_EXCLAIM,
        SDLK_QUOTEDBL,
        SDLK_HASH,
        SDLK_DOLLAR,
        SDLK_AMPERSAND,
        SDLK_QUOTE,
        SDLK_LEFTPAREN,
        SDLK_RIGHTPAREN,
        SDLK_ASTERISK,
        SDLK_PLUS,
        SDLK_COMMA,
        SDLK_MINUS,
        SDLK_PERIOD,
        SDLK_SLASH,
        SDLK_COLON,
        SDLK_SEMICOLON,
        SDLK_LESS,
        SDLK_EQUALS,
        SDLK_GREATER,
        SDLK_QUESTION,
        SDLK_AT,
        SDLK_LEFTBRACKET,
        SDLK_BACKSLASH,
        SDLK_RIGHTBRACKET,
        SDLK_CARET,
        SDLK_UNDERSCORE,
        SDLK_BACKQUOTE,
        SDLK_DELETE,
        SDLK_KP_PERIOD,
        SDLK_KP_DIVIDE,
        SDLK_KP_MULTIPLY,
        SDLK_KP_MINUS,
        SDLK_KP_PLUS,
        SDLK_KP_ENTER,
        SDLK_KP_EQUALS,
        SDLK_UP,
        SDLK_DOWN,
        SDLK_RIGHT,
        SDLK_LEFT,
        SDLK_INSERT,
        SDLK_HOME,
        SDLK_END,
        SDLK_PAGEUP,
        SDLK_PAGEDOWN,
        SDLK_RSHIFT,
        SDLK_LSHIFT,
        SDLK_RCTRL,
        SDLK_LCTRL,
        SDLK_RALT,
        SDLK_LALT
    };
    const char *strs[57] = {
        "BS",
        "TAB",
        "CLEAR",
        "ENTER",
        "PAUSE",
        "ESC",
        "SPACE",
        "!",
        "\"",
        "#",
        "$",
        "&",
        "'",
        "(",
        ")",
        "*",
        "+",
        ",",
        "-",
        ".",
        "/",
        ":",
        ";",
        "<",
        "=",
        ">",
        "?",
        "@",
        "[",
        "\\",
        "]",
        "^",
        "_",
        "`",
        "DEL",
        "KP .",
        "KP /",
        "KP *",
        "KP -",
        "KP +",
        "KP ENTER",
        "KP =",
        "UP",
        "DOWN",
        "RIGHT",
        "LEFT",
        "INSERT",
        "HOME",
        "END",
        "PAGE UP",
        "PAGE DOWN",
        "RSHIFT",
        "LSHIFT",
        "RCTRL",
        "LCTRL",
        "RALT",
        "LALT"
    };
    const SDLKey* itr = std::find(keysyms, keysyms + symscount, key);
    if(itr != keysyms + symscount){
        return strs[itr - keysyms];
    }
    return (boost::format("keysym=%d") % key).str();
}
//---------------------------------------------------------------------------
TConfigScreenPane::TConfigScreenPane() :
    m_LabelGuidance("ԐȂ悤ɔ̈ʒu𒲐ĉB")
{
    m_LabelGuidance.setSize(400, 24);
    m_LabelGuidance.setPosition(4, 4);
    m_LabelGuidance.setForegroundColor(gcn::Color(255,255,255));
    add(&m_LabelGuidance);

    m_ButtonLeftInc.setCaption("+");
    m_ButtonLeftInc.setSize(24, 24);
    m_ButtonLeftInc.setPosition(36, 96);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonLeftInc);
    add(&m_ButtonLeftInc);

    m_ButtonLeftDec.setCaption("-");
    m_ButtonLeftDec.setSize(24, 24);
    m_ButtonLeftDec.setPosition(36, 136);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonLeftDec);
    add(&m_ButtonLeftDec);

    m_ButtonRightInc.setCaption("+");
    m_ButtonRightInc.setSize(24, 24);
    m_ButtonRightInc.setPosition(196, 96);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonRightInc);
    add(&m_ButtonRightInc);

    m_ButtonRightDec.setCaption("-");
    m_ButtonRightDec.setSize(24, 24);
    m_ButtonRightDec.setPosition(196, 136);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonRightDec);
    add(&m_ButtonRightDec);

    m_ButtonTopInc.setCaption("+");
    m_ButtonTopInc.setSize(24, 24);
    m_ButtonTopInc.setPosition(96, 36);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonTopInc);
    add(&m_ButtonTopInc);

    m_ButtonTopDec.setCaption("-");
    m_ButtonTopDec.setSize(24, 24);
    m_ButtonTopDec.setPosition(136, 36);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonTopDec);
    add(&m_ButtonTopDec);

    m_ButtonBottomInc.setCaption("+");
    m_ButtonBottomInc.setSize(24, 24);
    m_ButtonBottomInc.setPosition(96, 196);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonBottomInc);
    add(&m_ButtonBottomInc);

    m_ButtonBottomDec.setCaption("-");
    m_ButtonBottomDec.setSize(24, 24);
    m_ButtonBottomDec.setPosition(136, 196);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonBottomDec);
    add(&m_ButtonBottomDec);

    m_ButtonLeftInc.addActionListener(this);
    m_ButtonLeftDec.addActionListener(this);
    m_ButtonRightInc.addActionListener(this);
    m_ButtonRightDec.addActionListener(this);
    m_ButtonTopInc.addActionListener(this);
    m_ButtonTopDec.addActionListener(this);
    m_ButtonBottomInc.addActionListener(this);
    m_ButtonBottomDec.addActionListener(this);

    setSize(432, 332);
}
//---------------------------------------------------------------------------
TConfigScreenPane::~TConfigScreenPane()
{
}
//---------------------------------------------------------------------------
void TConfigScreenPane::draw(gcn::Graphics *g)
{
    gcn::Container::draw(g);
    g->setColor(gcn::Color(0,0,0));
    g->fillRectangle(gcn::Rectangle(64, 64, 128, 128));
    g->setColor(gcn::Color(255,0,0));
    g->fillRectangle(gcn::Rectangle(80, 80, 95, 95));
    g->setColor(gcn::Color(0,0,0));
    g->fillRectangle(gcn::Rectangle(81, 81, 93, 93));
    g->setColor(gcn::Color(255,255,255));
    g->drawRectangle(gcn::Rectangle(80 + m_SlideL, 80 + m_SlideT, 95 - m_SlideL + m_SlideR, 95 - m_SlideT + m_SlideB));
}
//---------------------------------------------------------------------------
void TConfigScreenPane::action(const gcn::ActionEvent& actionEvent)
{
    gcn::Widget *src = actionEvent.getSource();
    if(src == &m_ButtonLeftInc){
        m_SlideL = MIN(m_SlideL + 1, 4);
    }
    else if(src == &m_ButtonLeftDec){
        m_SlideL = MAX(m_SlideL - 1, -4);
    }
    else if(src == &m_ButtonRightInc){
        m_SlideR = MIN(m_SlideR + 1, 4);
    }
    else if(src == &m_ButtonRightDec){
        m_SlideR = MAX(m_SlideR - 1, -4);
    }
    else if(src == &m_ButtonTopInc){
        m_SlideT = MIN(m_SlideT + 1, 4);
    }
    else if(src == &m_ButtonTopDec){
        m_SlideT = MAX(m_SlideT - 1, -4);
    }
    else if(src == &m_ButtonBottomInc){
        m_SlideB = MIN(m_SlideB + 1, 4);
    }
    else if(src == &m_ButtonBottomDec){
        m_SlideB = MAX(m_SlideB - 1, -4);
    }
}
//---------------------------------------------------------------------------
void TConfigScreenPane::InitUI()
{
    m_SlideL = g_Ini.GetIntValue(TOpenFarenIni::DRAWRECT_SLIDEL);
    m_SlideR = g_Ini.GetIntValue(TOpenFarenIni::DRAWRECT_SLIDER);
    m_SlideT = g_Ini.GetIntValue(TOpenFarenIni::DRAWRECT_SLIDET);
    m_SlideB = g_Ini.GetIntValue(TOpenFarenIni::DRAWRECT_SLIDEB);
}
//---------------------------------------------------------------------------
void TConfigScreenPane::UIToIni() const
{
    g_Ini.SetIntValue(TOpenFarenIni::DRAWRECT_SLIDEL, m_SlideL);
    g_Ini.SetIntValue(TOpenFarenIni::DRAWRECT_SLIDER, m_SlideR);
    g_Ini.SetIntValue(TOpenFarenIni::DRAWRECT_SLIDET, m_SlideT);
    g_Ini.SetIntValue(TOpenFarenIni::DRAWRECT_SLIDEB, m_SlideB);
}
//---------------------------------------------------------------------------
TConfigMusicSoundPane::TConfigMusicSoundPane() :
    m_LabelGuidance("̐ݒ͍ċNɗLɂȂ܂B")
{
    m_LabelGuidance.setSize(400, 24);
    m_LabelGuidance.setPosition(4, 4);
    m_LabelGuidance.setForegroundColor(gcn::Color(255,255,255));
    add(&m_LabelGuidance);

    m_CheckBoxMusic.setSize(256, 16);
    m_CheckBoxMusic.setPosition(4, 40);
    m_CheckBoxMusic.setCaption("y炷");
    g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxMusic);
    add(&m_CheckBoxMusic);

    m_CheckBoxSound.setSize(256, 16);
    m_CheckBoxSound.setPosition(4, 64);
    m_CheckBoxSound.setCaption("ʉ炷");
    g_GameMaster.GetSkinManager()->ApplyCheckBoxEnabled(&m_CheckBoxSound);
    add(&m_CheckBoxSound);

    setSize(400, 332);
}
//---------------------------------------------------------------------------
TConfigMusicSoundPane::~TConfigMusicSoundPane()
{
}
//---------------------------------------------------------------------------
void TConfigMusicSoundPane::InitUI()
{
    m_CheckBoxMusic.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::MUSIC_ENABLED));
    m_CheckBoxSound.setSelected(g_Ini.GetBoolValue(TOpenFarenIni::SOUND_ENABLED));
}
//---------------------------------------------------------------------------
void TConfigMusicSoundPane::UIToIni() const
{
    g_Ini.SetBoolValue(TOpenFarenIni::MUSIC_ENABLED, m_CheckBoxMusic.isSelected());
    g_Ini.SetBoolValue(TOpenFarenIni::SOUND_ENABLED, m_CheckBoxSound.isSelected());
}
//---------------------------------------------------------------------------
TConfigPane::TConfigPane()
{
    m_TabbedArea.setSize(472, 324);
    m_TabbedArea.setPosition(4, 4);
    m_TabbedArea.addTab("퓬", &m_BattlePane);
    m_TabbedArea.addTab("V[gJbg", &m_ShortcutPane);
    m_TabbedArea.addTab("EBhE", &m_WindowPane);
    m_TabbedArea.addTab("`", &m_ScreenPane);
    m_TabbedArea.addTab("", &m_MusicSoundPane);
    //m_TabbedArea.setForegroundColor(gcn::Color(255,255,255)); // ĂFςȂ
    add(&m_TabbedArea);

    m_ButtonOk.setCaption("OK");
    m_ButtonOk.setSize(56, 24);
    m_ButtonOk.setPosition(356, 332);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonOk);
    add(&m_ButtonOk);

    m_ButtonCancel.setCaption("Cancel");
    m_ButtonCancel.setSize(56, 24);
    m_ButtonCancel.setPosition(420, 332);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonCancel);
    add(&m_ButtonCancel);

    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_GRAYPANE));
    g_GameMaster.GetSkinManager()->ApplyGrayPaneSkin(this);
    setSize(480, 360);
}
//---------------------------------------------------------------------------
TConfigPane::~TConfigPane()
{
}
//---------------------------------------------------------------------------
void TConfigPane::logic()
{
    // gcn::TabbedArea::addTab()ŉʏɕ\ꍇAlogic()ĂяoȂ݂B䂦ɎŌĂԁB
    m_ShortcutPane.logic();
    gcn::Container::logic();
}
//---------------------------------------------------------------------------
void TConfigPane::InitUI()
{
    m_BattlePane.InitUI();
    m_WindowPane.InitUI();
    m_ScreenPane.InitUI();
    m_MusicSoundPane.InitUI();
}
//---------------------------------------------------------------------------
void TConfigPane::UIToIni() const
{
    m_BattlePane.UIToIni();
    m_WindowPane.UIToIni();
    m_ScreenPane.UIToIni();
    m_MusicSoundPane.UIToIni();
}
//---------------------------------------------------------------------------
TConfigWindow::TConfigWindow()
{
    add(&m_ConfigPane);
    m_ConfigPane.GetButtonOk().addActionListener(this);
    m_ConfigPane.GetButtonCancel().addActionListener(this);
    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    g_GameMaster.GetSkinManager()->ApplyWindowSkin(this);
    setOpaque(false);
    resizeToContent();
}
//---------------------------------------------------------------------------
TConfigWindow::~TConfigWindow()
{
}
//---------------------------------------------------------------------------
void TConfigWindow::InitUI()
{
    m_ConfigPane.InitUI();
}
//---------------------------------------------------------------------------
void TConfigWindow::action(const gcn::ActionEvent& actionEvent)
{
    bool ok = false;
    if(actionEvent.getSource() == &m_ConfigPane.GetButtonOk()){
        m_ConfigPane.UIToIni();
        g_Ini.SaveToFile(TFarenGameMaster::INIFILE);
        ok = true;
    }
    else if(actionEvent.getSource() == &m_ConfigPane.GetButtonCancel()){
    }
    g_GameMaster.HideConfig(ok);
}
//---------------------------------------------------------------------------
TSysMenuPane::TSysMenuPane()
{
    m_ButtonSave.setCaption("ۑ");
    m_ButtonSave.setSize(56, 24);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonSave);
    add(&m_ButtonSave);

    m_ButtonLoad.setCaption("Ǎ");
    m_ButtonLoad.setSize(56, 24);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonLoad);
    add(&m_ButtonLoad);

    m_ButtonConfig.setCaption("ݒ");
    m_ButtonConfig.setSize(56, 24);
    g_GameMaster.GetSkinManager()->ApplyButtonEnabled(&m_ButtonConfig);
    add(&m_ButtonConfig);

    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    g_GameMaster.GetSkinManager()->ApplyGrayPaneSkin(this);
    setSize(72, 100);
}
//---------------------------------------------------------------------------
TSysMenuPane::~TSysMenuPane()
{
}
//---------------------------------------------------------------------------
void TSysMenuPane::SetMode(TSysMenuMode mode)
{
    int configy = 8;
    int h = 36;
    if(mode == SYSMENU_WORLD){
        m_ButtonSave.setPosition(8, 8);
        m_ButtonLoad.setPosition(8, 40);
        configy = 72;
        h = 100;
    }
    m_ButtonConfig.setPosition(8, configy);
    setSize(72, h);
}
//---------------------------------------------------------------------------
TSysMenuWindow::TSysMenuWindow()
{
    add(&m_SysMenuPane);
    m_SysMenuPane.GetButtonSave().addActionListener(this);
    m_SysMenuPane.GetButtonLoad().addActionListener(this);
    m_SysMenuPane.GetButtonConfig().addActionListener(this);
    //setBaseColor(g_Ini.GetColorValue(TOpenFarenIni::GUICOLOR_WINDOW));
    g_GameMaster.GetSkinManager()->ApplyWindowSkin(this);
    setOpaque(false);
    resizeToContent();
}
//---------------------------------------------------------------------------
TSysMenuWindow::~TSysMenuWindow()
{
}
//---------------------------------------------------------------------------
void TSysMenuWindow::action(const gcn::ActionEvent& actionEvent)
{
    if(actionEvent.getSource() == &m_SysMenuPane.GetButtonSave()){
        g_GameMaster.ShowSaveLoad(true);
    }
    else if(actionEvent.getSource() == &m_SysMenuPane.GetButtonLoad()){
        g_GameMaster.ShowSaveLoad(false);
    }
    else if(actionEvent.getSource() == &m_SysMenuPane.GetButtonConfig()){
        g_GameMaster.ShowConfig();
    }
    g_GameMaster.SetSysMenuVisible(false);
}
//---------------------------------------------------------------------------
void TSysMenuWindow::SetMode(TSysMenuMode mode)
{
    m_SysMenuPane.SetMode(mode);
    resizeToContent();
}
//---------------------------------------------------------------------------
