//---------------------------------------------------------------------------
#include "textpane.h"
#include "gui.h"
#include "logger.h"
#include "boostformat.h"
//---------------------------------------------------------------------------
TGcnTextPane::TGcnTextPane()
    : m_drawer(NULL),
    m_fontsize(16),
    m_yspacing(0)
{
    //setForegroundColor(gcn::Color(255,255,255));
    m_drawer = g_GuiContainerList.GetDrawer(m_fontsize);
}
//---------------------------------------------------------------------------
TGcnTextPane::TGcnTextPane(const std::string& s, int fontsize)
    : m_drawer(NULL),
    m_text(s),
    m_fontsize(fontsize),
    m_yspacing(0)
{
    //setForegroundColor(gcn::Color(255,255,255));
    m_drawer = g_GuiContainerList.GetDrawer(fontsize);
}
//---------------------------------------------------------------------------
TGcnTextPane::~TGcnTextPane()
{
}
//---------------------------------------------------------------------------
void TGcnTextPane::SetFontSize(int fontsize)
{
    m_fontsize = fontsize;
    m_drawer = g_GuiContainerList.GetDrawer(fontsize);
}
//---------------------------------------------------------------------------
void TGcnTextPane::SetText(const std::string& s)
{
    m_text = s;
}
//---------------------------------------------------------------------------
void TGcnTextPane::AdjustSize()
{
    int maxlen = 0;
    int len = 0;
    int lines = 1;
    int sz = m_text.size();
    for(int i=0; i<sz; ++i){
        if(m_text.at(i) == '\n'){
            if(maxlen < len){
                maxlen = len;
            }
            len = 0;
            ++lines;
        }
        else{
            ++len;
        }
    }
    if(maxlen < len){
        maxlen = len;
    }
    setSize(m_fontsize * maxlen / 2, m_fontsize * lines);
    //OFDBGLOG((boost::format("%s, %d, %d, %d, %d") % m_text % sz % maxlen % getWidth() % getHeight()).str());
}
//---------------------------------------------------------------------------
void TGcnTextPane::draw(gcn::Graphics* g)
{
    gcn::Rectangle r = getDimension();
    r.x = r.y = 0;
    g->setColor(getBackgroundColor());
    g->fillRectangle(r);
    m_drawer->DrawStringOnRect(g, 0, 0, r, m_yspacing, m_text.c_str(), getForegroundColor());
    //m_drawer->DrawStringOnRectARGB(g, 0, 0, r, m_yspacing, m_text.c_str(), 0xffffffff);
}
