//---------------------------------------------------------------------------
#ifndef valuelayerH
#define valuelayerH

#include <vector>
//---------------------------------------------------------------------------
// QzɎgpB
template <typename ValueType> class TValueLayer
{
private:
    int Width;
    int Height;
    std::vector<ValueType> Value;
public:
    TValueLayer(int w, int h) : Width(w),Height(h){
        Value.resize(w*h);
    };
    TValueLayer(const TValueLayer& layer) : Width(layer.Width),Height(layer.Height){
        Value.resize(Width*Height);
        Value.assign(layer.Value.begin(), layer.Value.end());
    };
    virtual ~TValueLayer(void){
    };
    TValueLayer& operator=(const TValueLayer& layer){
        Assign(layer);
        return *this;
    }
    void Assign(const TValueLayer& layer) {
        Value.resize(layer.Value.size());
        Value.assign(layer.Value.begin(), layer.Value.end());
        Width = layer.Width;
        Height = layer.Height;
    }
    void Resize(int w, int h) {
        Value.resize(w*h);
        Width = w;
        Height = h;
    }
    int GetWidth(void) const { return Width; }
    int GetHeight(void) const { return Height; }
    ValueType& GetValue(int x,int y){
        return Value[y*Width + x];
    }
    const ValueType& GetValue(int x, int y) const{
        return Value[y*Width + x];
    }
    void Init(ValueType v = ValueType()){
        Value.assign(Width*Height, v);
    }

    typedef typename std::vector<ValueType>::iterator Iterator;
    typedef typename std::vector<ValueType>::const_iterator ConstIterator;
    Iterator begin() { return Value.begin(); }
    ConstIterator begin() const { return Value.begin(); }
    Iterator end() { return Value.end(); }
    ConstIterator end() const { return Value.end(); }
};
//---------------------------------------------------------------------------
#endif
